if(!dojo._hasResource["com.ibm.data.MashupCatalogFeedStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.MashupCatalogFeedStore"] = true;
dojo.provide("com.ibm.data.MashupCatalogFeedStore");

dojo.require("com.ibm.data.CatalogMixin");
dojo.require("com.ibm.data.OpenSearchFeedStore");

dojo.declare("com.ibm.data.MashupCatalogFeedStore", 
		[com.ibm.data.OpenSearchFeedStore,com.ibm.data.CatalogMixin],
		{
			itemClass: "com.ibm.data.MashupCatalogFeedItem",
			searchable: false,
			
			namespaces: dojo.mixin({}, com.ibm.data.OpenSearchFeedStore.prototype.namespaces, {
		        "ext" : "http://www.ibm.com/xmlns/prod/lotus/mashups/v1.0/extensions",
				"model" : "http://www.ibm.com/xmlns/prod/lotus/mashups/v1.0/model-elements",
				"base" : "http://www.ibm.com/xmlns/prod/lotus/mashups/v1.0/base",
				"catalog" : "http://www.ibm.com/xmlns/atom/opensearch/catalog/1.0/",
				"xsi" : "http://www.w3.org/2001/XMLSchema-datatypes",
				"openSearch" : "http://a9.com/-/spec/opensearch/1.1/"
		    }),
		       
			constructor: function( /*Map*/ args ) {
				this._features['dojo.data.api.Identity'] = true;
				var serviceDoc = com.ibm.mm.enabler.model.ServiceDocumentModel.SERVICE_CATALOG;
				var serviceJson = com.ibm.mm.enabler.model.ServiceDocumentModel.getCollectionData(serviceDoc);
				this.isPortal = (serviceJson.idprefix == "id") ? false : true;
				
				this.url = serviceJson.url + "@"+ serviceJson.idprefix + ":" + this.category;
				var catalog = this.catalog ? this.catalog : "default";
				var mashupsIdPostfix = this.isPortal ? "" : "_c_" + catalog;
				this.url = this.url + mashupsIdPostfix;				
			},
				
			mapItem: function(/*item*/item){
				var map = {};
				var bigId = this.getEPResolvedValue(item, "id", null);
				if(this.isPortal) var ids = /^catalog:oid:(.+)@oid:.+/.exec(bigId);
				else var ids = /^catalog:id:(.+)@/.exec(bigId);
				map.id = ids.length > 1 ? ids[1] : "";
				map.label = this.getEPResolvedValue(item, "title", "untitled");
				map.description = this.getEPResolvedValue(item, "summary", "");
				map.thumbnail = this.getValue(item, "thumbnail", "");
				map.icon = this.getValue(item, "catalogIcon", "");
				map.onAutoWire = this.getEPResolvedValue(item, "catalogAutoWire", "");
				map.widgetParam = this.getEPResolvedValue(item, "catalogWidgetParam", "");
                if(map.widgetParam.length > 0) { map.prefsMapFcn = this.prefsMapFcn; }
                map.definitionURL = this.getValue(item, "definitionURL", "");
				map.type = "catalog";
				map.isTrusted = com.ibm.mm.builder.utils.iwidgetUtil.isWidgetTrusted(map.id);
				if(!map.thumbnail && builderConfig.builderPath) map["thumbnail"] = builderConfig.builderPath + "/images/gray_generic_widget_icon.png";
				return map;
			},
			
            prefsMapFcn: function(map){
				var pars = dojo.fromJson(map.widgetParam);
				var ret = {};
				for(var i in pars){
					ret[pars[i].itemName] = pars[i].itemValue;
				}
				return ret;
			},
            	
			prepareQuery: function(keywordArgs) {
				if(keywordArgs.count) {
					if(this.isPortal) keywordArgs.query["max-results"] = keywordArgs.count;
					else keywordArgs.query.num = keywordArgs.count;
					if(keywordArgs.start == null) {
						keywordArgs.start = 0;
					}
					if(this.isPortal) keywordArgs.query["start-index"] = keywordArgs.start;
					else keywordArgs.query.start = keywordArgs.start;
				}
				return keywordArgs;
			},
			
			validateSelf: function(){
				// summary: validates this datastore, if it does not validate the source will not be used
				// returns true for validation and false otherwise
				if(dojo.trim(ibmConfig["com.ibm.mashups.builder.contentShelf.mode"]) == "mashups") {
					var categories = com.ibm.mm.builder.utils.toolboxUtil.getCategories();
					var found = false;
					for (var i = 0; i < categories.length; i++) {
						var category = categories[i];
						var id = category.getID();
						if(id.indexOf(this.category) == 0) {
							found = true;
							break;
						}					
					}					
					return found;
					
				} else {
					return false;
				}
			},
			
			
			
			getSourceLabel: function(){
				var categories = com.ibm.mm.builder.utils.toolboxUtil.getCategories();
				for (var i = 0; i < categories.length; i++) {
					var category = categories[i];
					var id = category.getID();
                    if(id.indexOf(this.category) == 0
                        && (this.isPortal ? true : (id.indexOf("_c_") == this.category.length))) {
                        return com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(category);
                    }
				}
				return false;
			}
});

dojo.declare( "com.ibm.data.MashupCatalogFeedItem",
		com.ibm.data.OpenSearchFeedItem, 
		{
			namespaces: dojo.mixin({}, com.ibm.data.MashupCatalogFeedStore.prototype.namespaces),
			// there is no 'widget.metadata' prefix for the metadata
	        attrMappings: dojo.mixin({}, com.ibm.data.OpenSearchFeedItem.prototype.attrMappings, {
				thumbnail: {xpath: "./atom:content/model:catalog-entry/atom:link[@ext:rel='icon']", targetName: "href", type: "attr"},
                catalogIcon: {xpath: "./atom:content/model:catalog-entry/atom:link[@ext:rel='icon']", targetName: "href", type: "attr"},
				catalogAutoWire: {xpath: "//model:metadata[@name='com.ibm.mashups.builder.autoWiringEnabled']/base:value", targetName: "value", type: "attr"},
                definitionURL: {xpath: "./atom:content/model:catalog-entry/atom:link[@ext:rel='definition']", targetName: "href", type: "attr"},
				catalogWidgetParam: {xpath: "//model:metadata[@name='widgetParam']/base:value", targetName: "value", type: "attr"}
			})
		}
);

}
