if(!dojo._hasResource["com.ibm.data.OpenSearchFeedStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.OpenSearchFeedStore"] = true;
dojo.provide( "com.ibm.data.OpenSearchFeedStore" );

dojo.require( "com.ibm.data.AtomFeedStore" );
dojo.require( "dojox.data.dom" );

dojo.declare( "com.ibm.data.OpenSearchFeedStore",
			com.ibm.data.AtomFeedStore,
			{
				// namespaces: Map
				//		Map of namespaces used by the MashupHub feeds
				namespaces: dojo.mixin({}, com.ibm.data.AtomFeedStore.prototype.namespaces, {
		            "xhtml" : "http://www.w3.org/1999/xhtml",
		            "os" : "http://a9.com/-/spec/opensearch/1.1/"
		        }),
		        
		        attrMappings: dojo.mixin({}, com.ibm.data.AtomFeedStore.prototype.attrMappings, {
					nextLink: {xpath: "./atom:link[@rel='next']", targetName: "href", type: "attr"},
					startIndex: {xpath: "./os:startIndex", targetName: "textContent", type: "node"},
					itemsPerPage: {xpath: "./os:itemsPerPage", targetName: "textContent", type: "node"},
					totalResults: {xpath: "./os:totalResults", targetName: "textContent", type: "node"},
					query: {xpath: "./os:Query", type: "OpenSearchQueryConstruct"}
				}),
				
				// itemClass: String the class used to represent items of this store
				itemClass: "com.ibm.data.OpenSearchFeedItem",
				
				constructor: function( /*Map*/ args ) {
					// summary: Creates a new instance of a com.ibm.portal.data._PortalModelStore
					// args: Map
					//		The args map will be used to replace any default values of this store with the
					//		values specified in the args map.
					this._features['dojo.data.api.Identity'] = true;
				},
				
				handleConstructs: function(/*DOMNode*/ node, /*String*/ prop) {
					switch(prop) {
						case "OpenSearchQueryConstruct": return new com.ibm.data.OpenSearchQueryConstruct(node);
						default: return this.inherited(arguments);
					}
				},
				
				getResultSize: function(/*DOMDoc*/ doc, /*Request*/ request, /*Array*/ items) {
					// summary: Gets the total number of items retrieved by the query, which is not
					//		necessarily the number of items returned to the callbacks to fetch.
					//		This can be used for paging purposes to get the total number of items
					//		on the server that match the query, where subsequent fetch requests can
					//		be made to retrieve additional pages.
					var rule = this.attrMappings.totalResults;
					var ret = null;
					if(rule.type == "attr") ret = this._getAttrByXpath(doc, rule.xpath, rule.targetName);
					else ret = this._getNodeByXpath(doc, rule.xpath, rule.targetName);
					// if we found total results, return it as a number
					if(ret.found) return ret.value - 0;
					// otherwise, return -1 to indicate that we don't know
					else return -1;
				},
				
				/********************************/
				/**                            **/
				/**                            **/
				/**   dojo.data.api.Identity   **/
				/**                            **/
				/**                            **/
				/********************************/			
				fetchItemByIdentity: function(/* object */ keywordArgs){
					//	summary:
					//		Given the identity of an item, this method returns the item that has 
					//		that identity through the onItem callback.  Conforming implementations 
					//		should return null if there is no item with the given identity.  
					//		Implementations of fetchItemByIdentity() may sometimes return an item 
					//		from a local cache and may sometimes fetch an item from a remote server, 
					//
					// 	keywordArgs:
					//		An anonymous object that defines the item to locate and callbacks to invoke when the 
					//		item has been located and load has completed.  The format of the object is as follows:
					//		{
					//			identity: string|object,
					//			onItem: Function,
					//			onError: Function,
					//			scope: object
					//		}
					//	The *identity* parameter.
					//		The identity parameter is the identity of the item you wish to locate and load
					//		This attribute is required.  It should be a string or an object that toString() 
					//		can be called on.
					//		
					//	The *onItem* parameter.
					//		Function(item)
					//		The onItem parameter is the callback to invoke when the item has been loaded.  It takes only one
					//		parameter, the item located, or null if none found.
					//
					//	The *onError* parameter.
					//		Function(error)
					//		The onError parameter is the callback to invoke when the item load encountered an error.  It takes only one
					//		parameter, the error object
					//
					//	The *scope* parameter.
					//		If a scope object is provided, all of the callback functions (onItem, 
					//		onError, etc) will be invoked in the context of the scope object.
					//		In the body of the callback function, the value of the "this"
					//		keyword will be the scope object.   If no scope object is provided,
					//		the callback functions will be called in the context of dojo.global.
					//		For example, onItem.call(scope, item, request) vs. 
					//		onItem.call(dojo.global, item, request)
					return false;
				}
			}
);

dojo.declare( "com.ibm.data.OpenSearchFeedItem",
			com.ibm.data.AtomEntryItem, 
			{
				// namespaces: Map
				//		Map of namespaces used by the MashupHub feeds
				namespaces: dojo.mixin({}, com.ibm.data.OpenSearchFeedStore.prototype.namespaces)
			}
);


dojo.declare( "com.ibm.data.OpenSearchQueryConstruct",
			com.ibm.data._XmlConstruct,
			{
				namespaces: dojo.mixin({}, com.ibm.data.OpenSearchFeedStore.prototype.namespaces),
				
				constructor: function(/*DOMNode*/ root) {
					this.root = root;
				},
				getRole: function() {
					return this._getAttribute(this.root, "role");
				},
				getTitle: function() {
					return this._getAttribute(this.root, "title");
				},
				getTotalResults: function() {
					return this._getAttribute(this.root, "totalResults");
				},
				getSearchTerms: function() {
					return this._getAttribute(this.root, "searchTerms");
				},
				getCount: function() {
					return this._getAttribute(this.root, "count");
				},
				getStartIndex: function() {
					return this._getAttribute(this.root, "startIndex");
				},
				getStartPage: function() {
					return this._getAttribute(this.root, "startPage");
				},
				getLanguage: function() {
					return this._getAttribute(this.root, "language");
				},
				getInputEncoding: function() {
					return this._getAttribute(this.root, "inputEncoding");
				},
				getOutputEncoding: function() {
					return this._getAttribute(this.root, "outputEncoding");
				},
				toString: function() {
					return com.ibm.domUtilities.stringFromDoc(this.root);
				}
			}
);

}
