if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.model.FQASpacesStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.model.FQASpacesStore"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.model.FQASpacesStore");

dojo.require("dojo.data.util.simpleFetch");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil");

dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.model.FQASpacesStore", null, {
    
    constants: com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants,
    
    spaceUtil: com.ibm.mm.builder.utils.spaceUtil,
	
	enablerUtil : com.ibm.mm.builder.utils.enablerUtil,
	
	spaceManagerUtil: com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerUtil,
    
    LOGGER: com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.iwidget.spacemanager.model.FQASpacesStore"),
    
    constructor: function(kwArgs) {
      this._spacesStack =  this._getSpaceStack();
    },
    
    _getSpaceStack: function() {
    	var cookieValue = this.spaceManagerUtil.model.retrieveRecentSpaces();   
		
    	if (cookieValue && cookieValue != "undefined") {
			return dojo.fromJson(cookieValue);
		} else {
			return [];
		}
    },
    
    getValue: function(item, attribute, defaultValue) {
        this._assertIsItem(item);
        this._assertIsAttribute(attribute);
        
        switch (attribute) {
            case "id":
                return item.id || defaultValue;
            case "title":
                return item.title;//this.spaceUtil.getSpaceTitle(item.getID(), builderConfig.locale);
        }   
    },
	
	setValue: function(item, attribute, value) {
        this._assertIsItem(item);
        this._assertIsAttribute(attribute);
		
        item[attribute] = value;        
    },
    
    getValues: function(item, attribute){
        this._assertIsItem(item);
        this._assertIsAttribute(attribute);
        var value = this.getValue(item, attribute);
        return value ? [value] : []; // Array
    },
    
    getAttributes: function(item){
        return ["id", "title"];
    },
    
    _assertIsItem: function(item) {
        if (!item) {
            throw new Error("com.ibm.mm.builder.iwidget.spacemanager.model.FQASpacesStore: Invalid item");
        }
    },
    
    _assertIsAttribute: function(attribute) {
        if(!dojo.isString(attribute)){ 
            throw new Error("com.ibm.mm.builder.iwidget.spacemanager.model.FQASpacesStore: Invalid attribute argument.");
        }
    },
    
    _fetchItems: function(keywordArgs, findCallback, errorCallback){
        try {
            findCallback(this._spacesStack, keywordArgs);
        } catch (e) {
            errorCallback(e, keywordArgs);
        }
    },
    
    addToStack: function(spaceItem) {
        if (!spaceItem) {
            return;
        }        
		var index = this._indexOf(spaceItem);
		
        if (index >= 0) {
			this.setValue(this._getByIndex(index), "title", spaceItem.title);
            this._moveToTop(index);
			this.spaceManagerUtil.model.storeRecentSpaces(this._spacesStack);
			dojo.publish(this.constants.Topic.Space.refreshRecentSpaces);
            return;
        }
        
        this._spacesStack.unshift(spaceItem);
        if (this._spacesStack.length > this.constants.Config.RecentSpaces.MAX_LENGTH) {
            this._spacesStack.pop();
        }
        
        this.spaceManagerUtil.model.storeRecentSpaces(this._spacesStack);
		dojo.publish(this.constants.Topic.Space.refreshRecentSpaces);
    },
	
	changeSpaceTitle : function(spaceItem){
		if (!spaceItem) {
            return;
        }        
		var index = this._indexOf(spaceItem);
		
        if (index >= 0) {
			this.setValue(this._getByIndex(index), "title", spaceItem.title);
			this.spaceManagerUtil.model.storeRecentSpaces(this._spacesStack);
			dojo.publish(this.constants.Topic.Space.refreshRecentSpaces);
        }
	},
	
	_getByIndex: function(index){
		if (index >= 0 && this._spacesStack[index]) {
			return this._spacesStack[index];
		}
		else {
			return null;
		}
	},
    
	removeFromStackById: function(spaceId) {
        if (!spaceId) {
            return;
        }
        
		var index = -1;
		if (this._spacesStack) {
            for (var i = 0, l = this._spacesStack.length; i < l; i++) {
                if (this.getValue(this._spacesStack[i], "id") === spaceId) {
                    index = i;
                }
            }
        }
		
        if (index >= 0) {
            this._remove(index);
        }
        
        this.spaceManagerUtil.model.storeRecentSpaces(this._spacesStack);
		dojo.publish(this.constants.Topic.Space.refreshRecentSpaces);
    },
    
    _indexOf: function(spaceItem) {
        if (this._spacesStack) {
            for (var i = 0, l = this._spacesStack.length; i < l; i++) {
                if (this.getValue(this._spacesStack[i], "id") === this.getValue(spaceItem, "id")) {
                    return i;
                }
            }
        }
        return -1;
    },
    
    _moveToTop: function(index) {
        var tempSpace = this._spacesStack[index];
        this._remove(index);
        this._spacesStack.unshift(tempSpace);
    },
    
    _remove: function(index) {
        if (index >= 0 && index < this._spacesStack.length) {
            this._spacesStack.splice(index, 1);
        }
    }
});
// Mix in the simple fetch implementation to this class.
dojo.extend(com.ibm.mm.builder.iwidget.spacemanager.model.FQASpacesStore, dojo.data.util.simpleFetch);

}
