if(!dojo._hasResource["com.ibm.mm.builder.widget.CustomDialogResizer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.CustomDialogResizer"] = true;
dojo.provide("com.ibm.mm.builder.widget.CustomDialogResizer");

dojo.require("dojox.layout.ResizeHandle");

dojo.declare("com.ibm.mm.builder.widget.CustomDialogResizer", 
	[dojox.layout.ResizeHandle], {
	
	innerContainer: null,
	
	innerMargin: null,
	
	oritation: "right",
	
	intLeftRTLOrig:0,
	
	// shadow when resizing dialog
	resizeShadow: null,
	// onResize: function
	// called each time dialog is resized
	onResize: null,

	templateString: '<div dojoAttachPoint="resizeHandle" class="customDialogResizeHandle"><div></div></div>',
	
	_beginSizing: function(/*Event*/ e){
		// summary: setup movement listeners and calculate initial size
		
		if (this._isSizing){ return false; }

		this.targetWidget = dijit.byId(this.targetId);

		// FIXME: resizing widgets does weird things, disable virtual resizing for now:
		if (this.targetWidget) { this.activeResize = true; } 

		this.targetDomNode = this.targetWidget ? this.targetWidget.domNode : dojo.byId(this.targetId);
		if (this.targetContainer) { this.targetDomNode = this.targetContainer; } 
		if (!this.targetDomNode){ return; }

		this.intLeftRTLOrig = parseInt(this.targetDomNode.style.left,10);
		
		if (!this.activeResize) {
			this.targetDomNode.appendChild(this._activeResizeNode); 
			dojo.fadeIn({ node: this._activeResizeNode, duration:120, 
				beforeBegin: dojo.hitch(this,function(){
					this._activeResizeNode.style.display=''; 
				})
			}).play(); 
		}

		this._isSizing = true;
		this.startPoint  = {'x':e.clientX, 'y':e.clientY};

		// FIXME: this is funky: marginBox adds height, contentBox ignores padding (expected, but foo!)
		var mb = (this.targetWidget) ? dojo.marginBox(this.targetDomNode) : dojo.contentBox(this.targetDomNode);  
		this.startSize  = { 'w':mb.w, 'h':mb.h };

		this._connects = []; 
		this._connects.push(dojo.connect(document,"onmousemove",this,"_updateSizing")); 
		this._connects.push(dojo.connect(document,"onmouseup", this, "_endSizing"));
		this._connects.push(dojo.connect(document,"onmouseleave", this, "_endSizing"));
		
		// create the resize shadow
		this.resizeShadow = document.createElement("div");
		this.targetContainer.appendChild(this.resizeShadow);
		dojo.attr(this.resizeShadow, {"class": "dialog_resize_shadow"});
		dojo.style(this.resizeShadow, "width", mb.w + "px");
		dojo.style(this.resizeShadow, "height", mb.h + "px");
		
		e.preventDefault();
	},
	
	_changeSizing: function(/*Event*/ e){
		
		// summary: apply sizing information based on information in (e) to attached node
		var tmp = this._getNewCoords(e);
		if(tmp===false){ return; }
		
		if(this.targetWidget && typeof this.targetWidget.resize == "function"){
			this.targetWidget.resize(tmp);
		}else{
			var intLeft = 0;
			if (builderConfig.isBidi) {
				intLeft = this.intLeftRTLOrig - tmp.dx;				
			}			
			dojo.style(this.targetDomNode,"width",tmp.w+"px"); 
			dojo.style(this.targetDomNode,"height",tmp.h+"px");
			if (builderConfig.isBidi) {
				dojo.style(this.targetDomNode,"left",intLeft+"px");
			}
			if(this.innerContainer && this.innerMargin){
				this.innerContainer.style.height = (tmp.h - this.innerMargin.top - this.innerMargin.bottom ) + "px";
				this.innerContainer.style.width = (tmp.w - this.innerMargin.left - this.innerMargin.right - 2) + "px";				
			}
		}
		
		dojo.style(this.resizeShadow, "width", tmp.w + "px");	
		dojo.style(this.resizeShadow, "height", tmp.h + "px");
		e.preventDefault();
		
		if(this.onResize !== null)
		{
			this.onResize(tmp.w, tmp.h);
		}
	},

	_getNewCoords: function(/* Event */ e){
		
		// On IE, if you move the mouse above/to the left of the object being resized,
		// sometimes clientX/Y aren't set, apparently.  Just ignore the event.
		try{
			if(!e.clientX  || !e.clientY){ return false; }
		}catch(exception){
			// sometimes you get an exception accessing above fields...
			return false;
		}
		this._activeResizeLastEvent = e; 

		var dx = this.startPoint.x - e.clientX;
		var dy = this.startPoint.y - e.clientY;
		
		var newW = 0;
		var newH = (this._resizeY) ? this.startSize.h - dy : this.startSize.h;
		if (!builderConfig.isBidi) {
   		   newW = (this._resizeX) ? this.startSize.w - dx : this.startSize.w;		   
        } else {		
		   newW = (this._resizeX) ? this.startSize.w + dx : this.startSize.w;
        }

		// minimum size check
		if(this.minSize){
			//var mb = dojo.marginBox(this.targetDomNode);
			if(newW < this.minSize.w){
				newW = this.minSize.w;
			}
			if(newH < this.minSize.h){
				newH = this.minSize.h;
			}
		}
		return {w:newW, h:newH, dx:dx};  // Object
	},
	
	_endSizing: function(/*Event*/ e){
		this.inherited(arguments);
		dojo.forEach(this._connects,function(c){
			dojo.disconnect(c); 
		});
		
		// Note: the target dom node id is like : "widgetId_edit"
		if (this.targetDomNode){
			var domId = this.targetDomNode.id;
			if (domId.indexOf("_edit")!=-1){
				var widgetId = domId.substr(0,domId.length-5);
				var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
				var dlgContentNode = dojo.query(".dialog_container",this.targetDomNode)[0];
				var payload = {"newWidth": parseInt(dlgContentNode.style.width,10),"newHeight": parseInt(dlgContentNode.style.height,10)};
				eventService.publishEvent(com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET+"."+widgetId,payload);	
			}			
		}
		// remove resize shadow
		this.targetContainer.removeChild(this.resizeShadow);
		this.resizeShadow = null;
	}
});

}
