if(!dojo._hasResource["com.ibm.mm.builder.widget.ResizeWidget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.ResizeWidget"] = true;
dojo.provide("com.ibm.mm.builder.widget.ResizeWidget");
dojo.require("com.ibm.mm.builder.widget.CustomDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.mm.builder.dialog.DialogFooter");
dojo.declare("com.ibm.mm.builder.widget.ResizeWidget",[dijit._Widget, dijit._Templated],{	

	templateString:
		'<div class="resizeWidgetContainer">'+
			'<div class="resizeWidgetDiv" >'+
				'<div class="resizeWidgetItem" dojoAttachPoint="resizeWidthDiv">'+
					'<label for="" dojoAttachPoint="widgetWidthLabel"><span class="resizeWidget_item_label">${I_CONTEXT_MENU_WIDGET_WIDTH}</span></label>'+
					'<input dojoType="dijit.form.NumberSpinner" dojoAttachPoint="widgetWidthInput" type="text" required="true" '+
						'class="resizeWidget_inputField" title="${I_CONTEXT_MENU_WIDGET_WIDTH}" '+
						'invalidMessage="${I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE}" tabindex=0 />'+
				'</div>'+
				'<div class="clearthefloats"></div>' +
				'<div class="resizeWidgetItem" dojoAttachPoint="resizeHeightDiv">'+
					'<label for="" dojoAttachPoint="widgetHeightLabel"><span class="resizeWidget_item_label">${I_CONTEXT_MENU_WIDGET_HEIGHT}</span></label>'+
					'<input dojoType="dijit.form.NumberSpinner" dojoAttachPoint="widgetHeightInput" type="text" required="true" '+
						'class="resizeWidget_inputField" title="${I_CONTEXT_MENU_WIDGET_HEIGHT}" '+
						'invalidMessage="${I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE}" tabindex=0 />'+
				'</div>'+
				'<div class="clearthefloats"></div>' +
			'</div>'+
			'<div dojoType="com.ibm.mm.builder.dialog.DialogFooter" dojoAttachPoint="footer" '+
				'dojoAttachEvent="onSave: save, onCancel: hide">'+
		'</div>',
	
	I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE,
	// TODO: remove the 'or' after translation is ready
	I_CONTEXT_MENU_WIDGET_WIDTH: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_WIDTH_TITLE || "Widget width",
	I_CONTEXT_MENU_WIDGET_HEIGHT: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_HEIGHT_TITLE || "Widget height",
	I_COMMON_CANCEL: com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_CANCEL,
	I_COMMON_SAVE: com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_SAVE,
	
	minWidth:50,
	minHeight:50,
	
	widgetsInTemplate: true,
	
	postCreate: function(){
		this.evtSvc = com.ibm.mashups.services.ServiceManager.getService("eventService");
		
		this.uniDialog = new com.ibm.mm.builder.widget.CustomDialog(this.dlgPara);
		this.uniDialog.containerNode.appendChild(this.domNode);
		
		dojo.connect(this.uniDialog, "onResize", this, "onDialogResize");
		this._setA11YHint();
		
		if(dijit._masterTT){
			dijit.setWaiState(dijit._masterTT.containerNode,"live","assertive");
			dijit.setWaiRole(dijit._masterTT.containerNode,"alert");
		}

		dojo.attr(this.widgetWidthLabel, "for", this.widgetWidthInput.id);
		dojo.attr(this.widgetHeightLabel, "for", this.widgetHeightInput.id);
	},
	
	_setA11YHint: function() {
		var widthInput = dojo.query("input", this.resizeWidthDiv)[0];
		dojo.attr(widthInput, "title", this.I_CONTEXT_MENU_WIDGET_WIDTH);
		
		
		var heightInput = dojo.query("input", this.resizeHeightDiv)[0];
		dojo.attr(heightInput, "title", this.I_CONTEXT_MENU_WIDGET_HEIGHT);
		
	},
	
	hide: function(){
		this.uniDialog.hide();
	},
	
	updateProperty: function(widgetId){
		this.widgetId = widgetId;
		var widgetWrapper = com.ibm.pb.layout.LayoutParser.findById(this.widgetId);
		this.maxSize = this.createMaxSize(widgetId);
		var pageWidthMode = com.ibm.mm.builder.utils.pageWidthChanger.getPageWidthMode();
		this.widgetWidthInput.constraints = {
			min: this.minWidth, 
			max: this.maxSize.maxW,
			places: 0
		};
		this.widgetHeightInput.constraints = {
			min: this.minHeight, 
			max: this.maxSize.h,
			places: 0
		};
		
		var height = dojo.style(widgetWrapper, "height");
		if (height){
			height = parseInt(height,10);	
			this.widgetHeightInput.setValue(height);
		}
		var width = dojo.style(widgetWrapper, "width");
		if (width){
			width = parseInt(width,10);		
			this.widgetWidthInput.setValue(width);		
		}
		this.uniDialog.show();
	},
	
	setTitle: function(title){
		if (this.uniDialog) {
		    this.uniDialog.setTitle(title);
		}
	},
		
	save: function(){
		alert('this is a test in save');
		if (!(this.widgetWidthInput.isValid() && this.widgetHeightInput.isValid())) {
			return;
		}

		var newH = this.widgetHeightInput.getValue();
		var newW = this.widgetWidthInput.getValue();
		
		var payload = {
			widgetId: this.widgetId,
			width: newW,
			height: newH
		};
		this.evtSvc.broadcastEvent("com.ibm.mashups.builder.resizeWidget", payload);
		this.hide();
	},
	
	createMaxSize:function(widgetId){
		var curWidget = com.ibm.pb.layout.LayoutParser.findById(widgetId);
		var containerNode = curWidget.parentNode;
		if(curWidget && containerNode){
			// defect 7486
			var curWidgetBox = dojo.marginBox(curWidget);
			var curLeft = parseInt(curWidgetBox.l,10);
			var curTop = parseInt(curWidgetBox.t,10);	
			var wholeWidth = dojo._getContentBox(containerNode).w;
			var wholeHeight = dojo._getContentBox(containerNode).h;
			var pageWidthRange = com.ibm.mm.builder.utils.pageWidthChanger.getPageWidthRange();
			return {
				maxW: pageWidthRange.max - curLeft,
				w: wholeWidth - curLeft,
				h: wholeHeight - curTop
			};
		}
		return null;		
	},
	
	onDialogResize: function(width, height){
		alert('this is a test in onDialogResize');
		var dialogContainerCB = dojo.contentBox(this.uniDialog.containerNode);
		var containerMB = dojo.marginBox(this.containerNode);
		var footerHeight = dojo.marginBox(this.footer.domNode).h;
		containerMB.w = dialogContainerCB.w;
		containerMB.h = dialogContainerCB.h - footerHeight;
		dojo.marginBox(this.containerNode, containerMB);
	}
});

}
