if(!dojo._hasResource["com.ibm.widgets.DataMenu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.widgets.DataMenu"] = true;
dojo.provide("com.ibm.widgets.DataMenu");

dojo.require( "dijit.Menu" );
dojo.require( "dijit.InlineEditBox" );
dojo.require( "com.ibm.widgets.TimedMenu" );
dojo.require( "com.ibm.widgets.SelectionModeled" );
dojo.require( "com.ibm.widgets.InlineEditorWrapper" );
dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.bundles", "Shelf");

dojo.declare( "com.ibm.widgets.DataMenu",
			[dijit.Menu, com.ibm.widgets.TimedMenu, com.ibm.widgets.SelectionModeled],
			{			
				"class": "lotusActionMenu",
				
				// loadingIndicatorWidget: String name of widget class used to represent the loading state of this 
				// 		modeled widget.  By default, it is displayed as a child of this widget while children 
				// 		are being loaded, and is then removed after loading has completed.
				loadingIndicatorWidget: "com.ibm.widgets.LoadingMenuItem",
				
				// inlineEditorWidget: String name of widget class to use to instantiate the inline
				//		editor of this data backed widget.
				inlineEditorWidget: "com.ibm.widgets.EditorMenuItem",
				
				// closeDelay: Number of milliseconds to wait before closing a menu when it 
				// 		loses focus or receives an unhover event
				closeDelay: 500,
				
				// level: Number indicating the number of ancestor menus in the model chain above
				//		this menu.  Default is 0, indicating that this is a top level menu.
				level: 0,
				
				postCreate: function() {
					this.inherited(arguments);
					var ltr = this.isLeftToRight(),
						k = dojo.keys;
					this._exitKey = ltr ? k.LEFT_ARROW : k.RIGHT_ARROW;
					this._openKey = ltr ? k.RIGHT_ARROW : k.LEFT_ARROW;
					if(this.embeddedEditorParams.tooltipPosition) {
						this.embeddedEditorParams.tooltipPosition = ["after", "before", "below"];
					}
					this.initializeModelWidget();
					this._dndParams.withHandles = true;
					dojo.addClass(this.domNode, this["class"]);
					dojo.addClass(this.domNode, "modeledDataMenu");
					this.connect(this, "onMouseEnter", "_onHover");
					this.connect(this, "onMouseLeave", "_onUnhover");
					
					this.domNode.setAttribute("cellSpacing", "0px");
					dojo.style(this.domNode, {
						borderCollapse: "separate",
						borderSpacing: "0px"
					});
				},
				
				startup: function() {
					this.inherited(arguments);
					this.startupModelWidget();
				},
				
				setupInlineEditor: function() {
					return;
				},
				
				setupDnd: function() {
					this._dndParams.withHandles = true;
					this.inherited(arguments);
				},
				getInheritableParameters: function(item) {
					return dojo.mixin(this.inherited(arguments), {
						parentMenu: this,
						closeDelay: this.closeDelay,
						popupDelay: this.popupDelay,
						"class": this["class"]
					});
				},
				_getPopup: function(item) {
					if(this.level < this.levels) {
						return new this.constructor(this.getInheritableParameters(item));
					}
					return null;
				},
				loadHandler: function(items) {
					this.inherited(arguments);
					if(items.length == 0) {
						var a = this.anchor;
						if(a) {
							a.attr("hasChildren", false);
							a.destroyPopup && a.destroyPopup();
						}
					}
				},
				createItemRep: function(item) {
					var args = {
						iconClass: "dragHandleIcon", 
						label: com.ibm.domUtilities.encodeXML(this.model.getLabel(item)), 
						item: item
					};
					var cls = com.ibm.widgets.DataPopupMenuItem;
					
					if(this.model.mayHaveChildren(item) || this.showInlineEditor) {
						var popup = this._getPopup(item);
						if(popup) {
							args.popup = popup;
						}
					}
					
					var childWidget = new cls(args);
					return childWidget;
				},
				handleChildChildrenChange: function(child, children) {
					// summary: Called when a child that has no children gets children or when a child that has children
					//		loses all its children.
					if(children.length === 0) {
						// child lost all children, destroy its popup
						child.destroyPopup();
						this.currentPopup = null;
						child.attr("hasChildren", false);
					}
					else if(!child.popup){
						// child without children got new children, create its popup
						var popup = this._getPopup(child.item);
						if(popup) {
							child.setPopup(popup);
							child.attr("hasChildren", true);
							popup.load();
							this.onItemHover(child);
						}
					}
				},
				getTopAnchor: function() {
					if (this.anchor) {
						var parent = this.anchor.getParent();
						return parent && parent.getTopAnchor ? parent.getTopAnchor() : this.anchor;
					}
					else {
						return null;
					}
				},
				_moveToPopup: function(/*Event*/ evt){
					if(this.focusedChild && this.focusedChild.popup && !this.focusedChild.disabled) {
						this._openPopup();
					}
					else {
						var topAnchor = this.getTopAnchor();
						if(topAnchor) {
							topAnchor.getParent().focusNext();
						}
					}
				},
				_onChildBlur: function(item) {
					// nobody else is checking this, and apparently when widgets are destroyed
					// and the dom destroyed too, this fails trying to blur a non-existing node
					if (!item || !item.domNode) {
						return;
					}
					return this.inherited(arguments);
				},
				onItemHover: function(/*Widget*/ item){
					// summary: Called when cursor is over a MenuItem
					if(!this.inlineEditor || !this.inlineEditor.isEditing()) {
						this.isActive = true;
						return this.inherited(arguments);
					}
				},
				onItemClick: function(/*Widget*/ child, /*Event*/ evt){
					// summary: user defined function to handle clicks on an item
					if (child.attr("disabled")) {
						return false;
					} 
					this.onExecute();
					child.onClick(evt);
					if(child.item) this.onModelItemClick(child, child.item);
					// set _isClosing = true on this and parent menus
					(function(menu) {
						menu._isClosing = true;
						if (menu.parentMenu) {
							arguments.callee(menu.parentMenu);
						}
					})(this);
					this.close();
				},
				_onKeyPress: function(/*Event*/ evt){
					if(this.inlineEditor && 
					   this.inlineEditor.isEditing() && 
					   dojo.isDescendant(evt.target, this.inlineEditor.domNode)) {
						return;
					}
					 
					if (evt.ctrlKey || evt.altKey) {
						return;
					}
					switch(evt.charOrCode) {
						case this._exitKey:
							if(this.parentMenu) {
								this.onCancel(false);
							}
							else {
								var topAnchor = this.getTopAnchor();
								if(topAnchor) {
									topAnchor.getParent().focusPrev();
								}
							}
							dojo.stopEvent(evt);
							break;
						case this._openKey:
						 	this._moveToPopup(evt);
						 	dojo.stopEvent(evt);
						 	break;
					}
				},
				canClose: function() {
					// summary: Indicates whether or not this menu can close right now.  Is
					//		used to keep menus from closing when they are editing or in other
					//		conditions.
					return !this.inlineEditor || (this.inlineEditor && !this.inlineEditor.isEditing());
				}
			}
);

dojo.declare( "com.ibm.widgets._DataMenuItem", 
			null, 
			{
				templateString: 
				 '<tr class="dijitReset dijitMenuItem" dojoAttachPoint="focusNode" waiRole="menuitem" tabIndex="-1"'+
				 'dojoAttachEvent="onmouseenter:_onHover,onmouseleave:_onUnhover,ondijitclick:_onClick">'+
				 '<td dojoAttachPoint="dndHandleNode" class="dijitReset dragHandle" waiRole="presentation">'+
					'<img dojoAttachPoint="iconNode" src="${_blankGif}" alt="" />'+
					'<span class="dragHandleA11y">|</span>'+
				 '</td>'+
				 '<td class="dijitReset dijitMenuItemLabel" dojoAttachPoint="containerNode"></td>'+
				 '<td class="dijitReset dijitMenuArrowCell" waiRole="presentation">'+
					'<div class="modelHasChildrenIcon" dojoAttachPoint="arrowWrapper">'+
						'<div class="dijitMenuExpand"></div>'+
						'<span class="dijitMenuExpandA11y">+</span>'+
					'</div>'+
				 '</td>'+
				 '</tr>',
				
				_setDndHandleAttr: function(value) {
					this.dndHandle = value;
					dojo[value ? "addClass" : "removeClass"](this.dndHandleNode, "dojoDndHandle");
				},
				_setHasChildrenAttr: function(value) {
					this.hasChildren = value;
					dojo[value ? "addClass" : "removeClass"](this.domNode, "modelHasChildren");
				},
				_setDndStatusAttr: function(value) {
					this.dndStatus = value;
					if(this.popup) {
						this.popup[value ? "setupDnd" : "disableDnd"]();
					}
				},
				focus: function() {
					var parent = this.getParent();
					if(!parent.dndSource || !parent.dndSource.isDragging) {
						this.inherited(arguments);
					}
				}
			}
);

dojo.declare( "com.ibm.widgets.DataMenuItem",
			[dijit.MenuItem, com.ibm.widgets._DataMenuItem], 
			{
				
			}
);

dojo.declare( "com.ibm.widgets.DataPopupMenuItem",
			[dijit.MenuItem, com.ibm.widgets._DataMenuItem],
			{
				constructor: function() {
					this._popupConnects = null;
				},
				startup: function() {
					this.inherited(arguments);
					if(this.popup) {
						this.setPopup(this.popup);
					}
				},
				setPopup: function(popup) {
					this.popup = popup;
					this.popup.anchor = this;
					this._popupConnects = [
						this.connect(this.focusNode, "onfocus", "loadPopup"),
						this.connect(this.popup, "onLoading", "onLoading"),
						this.connect(this.popup, "onLoad", "onLoad")
					];
					this.popup.startup();
					if(this.arrowWrapper) {
						dojo.style(this.arrowWrapper, "visibility", "");
					}
					dijit.setWaiState(this.focusNode, "haspopup", "true");
				},
				destroyPopup: function() {
					if(this.popup) {
						dojo.forEach(this._popupConnects, this.disconnect, this);
						this._popupConnects = null;
						this.popup.destroyRecursive();
						delete this.popup;
						dijit.setWaiState(this.focusNode, "haspopup", "false");
					}
				},
				loadPopup: function() {
					if (this.popup) {
						this.popup.load();
					}
				},
				onLoad: function() {
					// fired when loading this menu item's popup is complete
				},
				onLoading: function() {
					// fired when loading this menu item's popup has started
				},
				_onHover: function() {
					this.loadPopup();
					this.inherited(arguments);
				},
				destroyDescendants: function() {
					this.destroyPopup();
					this.inherited(arguments);
				}
			}
);

dojo.declare( "com.ibm.widgets.LoadingMenuItem",
			dijit.MenuItem,
			{
				label: "Loading...",
				iconClass: "ibmLoading",
				
				postMixInProperties: function() {
					this.shelfBundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
					this.label=this.shelfBundle.shelf_loading;
				}
			}
);

dojo.declare( "com.ibm.widgets.EditorMenuItem",
			[dijit.MenuItem, com.ibm.widgets.InlineEditorWrapper],
			{
				templateString:
					 '<tr class="dijitReset dijitMenuItem inlineEditor lotusMenuSeparator" dojoAttachPoint="focusNode" waiRole="menuitem" tabIndex="-1"'+
					 'dojoAttachEvent="onmouseenter:_onHover,onmouseleave:_onUnhover,onkeypress:_onKeyPress">'+
					 '<td class="dijitReset" waiRole="presentation"><div class="dijitMenuItemIcon" dojoAttachPoint="iconNode"></div></td>'+
					 '<td class="dijitReset dijitMenuItemLabel" dojoAttachPoint="containerNode"><span dojoAttachPoint="editor">${label}</span></td>'+
					 '<td class="dijitReset dijitMenuArrowCell" waiRole="presentation"></td>'+
					 '</tr>',
					
				attributeMap: dojo.mixin(dojo.clone(dijit.MenuItem.prototype.attributeMap), {
					label: {node: "editor", type: "innerHTML"}
				}),
				postCreate: function() {
					this.inherited(arguments);
					dojo.setSelectable(this.domNode, true);
				},
				focus: function() {
					var parent = this.getParent();
					if(!parent.dndSource || !parent.dndSource.isDragging) {
						this.inherited(arguments);
					}
				},
				_onKeyPress: function(evt) {
					if(!evt.ctrlKey && !evt.altKey && evt.charOrCode == dojo.keys.ENTER	&& !this.isEditing()) {
						this.editor.edit();
						dojo.stopEvent(evt);
						return false;
					}
				}
			}
);

}
