/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.iwidget.model.WidgetModel");

/**
 * WidgetModel interface defines functions that expose information of a widget model.<br/>
 * Global model available to all the page components.<br/>
 * <code>var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel();</code>
 * @ibm-spi
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.model.WidgetModel",null,{
/**
 * @private
 */
	constructor:function(id){

	},

/**
Returns  an iWidgetWrapper object which represents a runtime instance of an iWidget object. <br/>
Id is the  "id" attribute that's defined in  microformat. It's used to uniquely identify an iWidget instance on the page.<br/>
<code> &lt;span class="iw-iWidget" id="{id}"&gt;  </code>
@param{String} id  unique id of an iWidget wrapper. Must not be NULL.
@type com.ibm.mashups.iwidget.widget. IWidgetWrapper
@returns{com.ibm.mashups.iwidget.widget. IWidgetWrapper }  an  iWidget Wrapper of the required iWidget . iWidget Wrapper represents a runtime instance of an iWidget.
*/	
	find:function(id){	
	},
/**
Returns  whether or not the given node has children. NOT Implemented.
@param{com.ibm.mashups.iwidget.iWidgetWrapper} iWidgetWrapper  parent iWidgetWrapper object. Must not be NULL.
@type Boolean
@returns{Boolean }  returns TRUE if the given node has children.
*/	
	hasChildren:function(iWidgetWrapper){	
	},
/**
Returns  an array of iWidgetWrapper object. NOT Implemented.<br/>
@param{com.ibm.mashups.iwidget.widget.IWidgetWrapper} iWidgetWrapper  parent object .Must not be NULL.
@param{Boolean} isNested  optional. the default  value is TRUE. It returns all the nested iWidgets if it's true. It returns only direct children if it's false. 
@type  com.ibm.mashups.iwidget.widget. IWidgetWrapper[]
@returns{com.ibm.mashups.iwidget.widget. IWidgetWrapper[]}  return an array of iWidgetWrapper object .
*/	
	getChildren:function(iWidgetWrapper,isNested){	
	},
/**
Returns  the parent object of the specified iWidgetWrapper object . <br/>
@param{com.ibm.mashups.iwidget.widget. IWidgetWrapper} iWidgetWrapper  iWidgetWrapper object. Must not be NULL.
@type com.ibm.mashups.iwidget.widget. IWidgetWrapper
@returns{com.ibm.mashups.iwidget.widget. IWidgetWrapper } returns parent node or NULL if the node has no parent.
*/	
	getParent:function(iWidgetWrapper){	
	},

/**
Returns the deferred object used to start this operation and an IWidgetDefinition object is returned when deferred object is executed.<br/>
<code>var deferred = widgetModel.getWidgetDefinitionByUrl(url)</code><br/>
<code>deferred.setFinishedCallback(callback,parameters);</code><br/>
<code>deferred.start(false);</code><br/>
here are the callback parameters that will be passed into callback function: <br/>
 &nbsp;&nbsp;&nbsp;&nbsp;<code>resource</code> -  IWidgetDefinition object <br>
&nbsp;&nbsp;&nbsp;&nbsp;<code>statuscode</code> - the HTTP status,code of the action .<br>
&nbsp;&nbsp;&nbsp;&nbsp;<code>params</code> - optional.  may use this to pass additional parameters  into the callback .<br>
here is a sample implementation of callbackfunction:<br/>
 &nbsp;&nbsp;&nbsp;&nbsp;<code>function callback(resource, statuscode, params) { </code><br/>
 &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;<code>  if (statuscode == 200) {   </code><br/>
 &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;<code>  var defObj = resource;</code><br/>
 &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;<code> ... }</code><br/>
 &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;<code> } </code><br/>
@param{String} url  url to load widget definition. Must not be NULL.
@type com.ibm.mashups.enabler.Deferred
@returns{com.ibm.mashups.enabler.Deferred}  a deferred object used to start this operation. 
@see com.ibm.mashups.iwidget.widget.IWidgetDefinition
@deprecated Use getWidgetDefinitionByURL instead.
*/ 
	getWidgetDefinitionByUrl:function(url){
	},
/**
Returns the deferred object used to start this operation and an IWidgetDefinition object is returned when deferred object is executed.<br/>
<code>var deferred = widgetModel.getWidgetDefinitionByUrl(url)</code><br/>
<code>deferred.setFinishedCallback(callback,parameters);</code><br/>
<code>deferred.start(false);</code><br/>
here are the callback parameters that will be passed into callback function: <br/>
 &nbsp;&nbsp;&nbsp;&nbsp;<code>resource</code> -  IWidgetDefinition object <br>
&nbsp;&nbsp;&nbsp;&nbsp;<code>statuscode</code> - the HTTP status,code of the action .<br>
&nbsp;&nbsp;&nbsp;&nbsp;<code>params</code> - optional.  may use this to pass additional parameters  into the callback .<br>
here is a sample implementation of callbackfunction:<br/>
 &nbsp;&nbsp;&nbsp;&nbsp;<code>function callback(resource, statuscode, params) { </code><br/>
 &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;<code>  if (statuscode == 200) {   </code><br/>
 &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;<code>  var defObj = resource;</code><br/>
 &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;<code> ... }</code><br/>
 &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;<code> } </code><br/>
@param{String} url  url to load widget definition. Must not be NULL.
@type com.ibm.mashups.enabler.Deferred
@returns{com.ibm.mashups.enabler.Deferred}  a deferred object used to start this operation. 
@see com.ibm.mashups.iwidget.widget.IWidgetDefinition
*/ 
	getWidgetDefinitionByURL:function(url){
	},
    
    /**
    * Commits the modifications applied to this model and all dependent models.<br>
    * @return {DeferredOperation} a deferred object used to start this operation. 
    * The return value when executed through the deferred object is <code>null</null>
    */
    commit:function(){
        //summary: This method persists the data
    },
	
	/**
Returns iWidgetDefinition object for the specified JSON object. <br/>
@param{Object} json  JSON object. Must not be NULL.
@type com.ibm.mashups.iwidget.widget. IWidgetWrapper
@return{com.ibm.mashups.iwidget.widget.IWidgetDefinition} returns the IWidgetDefinition representation of the JSON object.
@see com.ibm.mashups.iwidget.widget.IWidgetDefinition
	 */
	createIWidgetDefinition:function(json) {
        //create WidgetDefinition based on JSON object 
	},
	
	/**
Creates a widget and associates it with a span element on the page <br/>
@param{Object} span  DOMElement to associate the widget with.  Must not be NULL.
@return{com.ibm.mashups.iwidget.widget.IWidgetWrapper} returns the IWidgetWrapper representation of the JSON object. May be NULL.
	 */
	createWidget:function(span) {
	}
});
