/** Licensed Materials - Property of IBM, 5724-U69, (C) Copyright IBM Corp. 2008, 2010 - All Rights reserved.  **/
dojo.provide("com.ibm.mm.builder.edit");
if(!dojo._hasResource["com.ibm.mm.builder.dnd.Avatar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dnd.Avatar"] = true;
/**
 * @author Jarod(zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.dnd.Avatar");

dojo.declare("com.ibm.mm.builder.dnd.Avatar", dojo.dnd.Avatar, {

	construct: function(){
		
		var a = dojo.doc.createElement("div");
		a.className = "dojoDndAvatar";
		a.style.position = "absolute";
		a.style.zIndex = 1999;
		a.style.margin = "0px"; // to avoid dojo.marginBox() problems with table's margins
		var k = Math.min(5, this.manager.nodes.length);
		var source = this.manager.source, node;
		for(var i = 0; i < k; ++i){
			if(source.creator){
				// create an avatar representation of the node
				node = source._normalizedCreator(source.getItem(this.manager.nodes[i].id).data, "avatar").node;
			}else{
				// or just clone the node and hope it works
				node = this.manager.nodes[i].cloneNode(true);
				if(node.tagName.toLowerCase() == "tr"){
					// insert extra table nodes
					var table = document.createElement("table"),
						tbody = document.createElement("tbody");
					tbody.appendChild(node);
					table.appendChild(tbody);
					node = table;
				}
			}
			node.id = "";
			a.appendChild(node);
		}
		this.node = a;
	},
	
	update: function(){
		//no need to update avatar in mashups
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.dnd.Manager"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dnd.Manager"] = true;
/**
 * Lotus Mashups DND manager
 * @author Jarod(zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.dnd.Manager");




var dojoDndManagerOffsetX = dojo.dnd.manager().OFFSET_X;
var dojoDndManagerOffsetY = dojo.dnd.manager().OFFSET_Y;

var dojoDndManagerStartDrag = dojo.dnd.manager().startDrag;
dojo.dnd.manager().startDrag = function(source, nodes, copy){
	if (source && source.declaredClass &&
		source.declaredClass.indexOf("com.ibm.mm.builder.dnd") === 0) {
	
		dojo.dnd.manager().OFFSET_X = 1;
		dojo.dnd.manager().OFFSET_Y = 1;
	}
	dojoDndManagerStartDrag.call(this, source, nodes, copy);
};

var dojoDndManagerStopDrag = dojo.dnd.manager().stopDrag;
dojo.dnd.manager().stopDrag = function(){
	if (this.source && this.source.declaredClass &&
		this.source.declaredClass.indexOf("com.ibm.mm.builder.dnd") === 0) {
		
		dojo.dnd.manager().OFFSET_X = dojoDndManagerOffsetX;
		dojo.dnd.manager().OFFSET_Y = dojoDndManagerOffsetY;
	}
	dojoDndManagerStopDrag.call(this);
};

var dojoDndManagerOnMouseMove = dojo.dnd.manager().onMouseMove;
dojo.dnd.manager().onMouseMove = function(e){
	if (this.source && this.source.moving) {
		this.source.moving(e);
	
	} else {
		dojoDndManagerOnMouseMove.call(this, e);
	}
};

var dojoDndManagerMakeAvatar = dojo.dnd.manager().makeAvatar;
dojo.dnd.manager().makeAvatar = function(){
	if (this.source && this.source.declaredClass && 
		this.source.declaredClass.indexOf("com.ibm.mm.builder.dnd") === 0) {
		return new com.ibm.mm.builder.dnd.Avatar(this);
	
	} else {
		return dojoDndManagerMakeAvatar.call(this);
	}
};

}

if(!dojo._hasResource["com.ibm.mm.builder.dnd.QuickWireTarget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dnd.QuickWireTarget"] = true;
/**
 * @author Yi Ming Huang(huangyim@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.dnd.QuickWireTarget");

/**
 * FreeformSource is the drop target of one column in free form
 */
dojo.declare("com.ibm.mm.builder.dnd.QuickWireTarget", dojo.dnd.Target, {
	
	//accept: ["iWidgetDefinition", "iWidgetInstance"],
	accept: ["lm"],
	
	handler: null,
	
	onDndDrop: function(source, nodes, copy, target){
		try {
			this.inherited(arguments);
		} catch (e) {
			//the source node will be null for unknown reason.
		}
	},
	/**
	onDropExternal: function(source, nodes, copy){
		var sid = nodes[0].getAttribute("dnddata");
		if(nodes[0].getAttribute("dndtype") === "iWidgetDefinition"){
			sid = this.layout.createWidget(nodes[0].getAttribute("dnddata"));
		}
		//hide before do autowire
		com.ibm.mm.builder.utils.iwidgetUtil.hideWidget(sid);
		var self = this;
		this.handler = com.ibm.mm.builder.utils.iwidgetUtil.invokeCallbackByWidgetInstanceId(sid, function(){
			var payload = {
				sourceWidgetId: sid,
				targetWidgetId: self.targetId,
				callBackFuncContext: self,
				callbackFunc: "moveEffect"
			};
			var es = com.ibm.mashups.services.ServiceManager.getService("eventService");
			es.broadcastEvent("com.ibm.mashups.builder.createQuickWire", payload);
			com.ibm.mm.builder.utils.iwidgetUtil.showWidget(sid);
			self.disconnectHandler();
		});
	},
	*/
	
	onDropExternal: function(source, nodes, copy) {
		var type = dojo.attr(nodes[0], "dndtype");
		if(this._acceptType(type)) {
			var sourceLcId = com.ibm.pb.layout.LayoutParser.extractID(nodes[0]);
			var targetLcId = this.node.title;
			var payload = {
				sourceWidgetId: sourceLcId,
				targetWidgetId: targetLcId
			};
			var es = com.ibm.mashups.services.ServiceManager.getService("eventService");
			es.broadcastEvent("com.ibm.mashups.builder.createQuickWire", payload);
		}
	},
	
	disconnectHandler: function(){
		if (this.handler) {
			com.ibm.mashups.services.ServiceManager.getService("eventService").unsubscribeEvent(this.handler, null);
		}
	},
	
	_acceptType: function(type) {
		if(this.accept[type])
			return true;
		return false;
	}
});

com.ibm.mm.builder.dnd.QuickWireTargetMap = {};

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.WiringSettingsDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.WiringSettingsDialog"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.wiringscreen.WiringSettingsDialog");



com.ibm.mm.builder.iwidget.wiringscreen.WiringSettingsConstants = {
	SEMANTIC_TYPES_ONLY: 0,
	PAYLOAD_TYPES_ONLY: 1,
	SEMANTIC_OR_PAYLOAD_TYPES: 2,
	SETTING_MATCHING_TYPE: "matchingType"
};

dojo.declare("com.ibm.mm.builder.iwidget.wiringscreen.WiringSettingsDialog", [dijit._Widget, dijit._Templated], {
	notificationDialog:null,
	
	widgetId: null,
	
	dialogWidgetId: "Mashup_Wiring_Settings_Dlg",
	
	templateString:"<div style=\"padding: 10px;\" dojoAttachPoint=\"wiringSettingsDiv\">\n<div class=\"mumGreenTitleDiv\" dojoAttachPoint=\"matchingOptionsTitleDiv\"></div>\n<div class=\"mumCurrentWidgetContentDivSend\" dojoAttachPoint=\"matchingOptionsDiv\">\n    <div><input type=\"radio\" name=\"matchingOption\" dojoAttachPoint=\"matchingOption1\"><span dojoAttachPoint=\"matchingOption1Text\"></span></div>\n    <div><input type=\"radio\" name=\"matchingOption\" dojoAttachPoint=\"matchingOption2\"><span dojoAttachPoint=\"matchingOption2Text\"></span></div>\n    <div><input type=\"radio\" name=\"matchingOption\" dojoAttachPoint=\"matchingOption3\"><span dojoAttachPoint=\"matchingOption3Text\"></span></div>\n</div>\n<div class=\"mumCurrentWidgetBottomSend\"></div>\n<div class=\"bottomDiv\" dojoAttachPoint=\"bottomDiv\">\n\t<input type='submit' dojoAttachPoint='buttonDivDone'class='lotusFormButton'></input>\n</div>\n</div>\n",
	
	constants: com.ibm.mm.builder.iwidget.wiringscreen.WiringSettingsConstants,
						
	constructor:function(){
	},
	
	onSettingsSaved: function ( /*Map*/settings ) {
	},
	
	postCreate:function(){
		this.initContent();
	},
	
	setOuterContext: function ( ctx ) {
		this.outerContext = ctx;
	},
	
	setMatchingType: function ( currentMatchingType ) {
		//Should be set by the code opening the dialog.
		switch ( currentMatchingType ) {
			case 0: this.matchingOption1.checked = true; break;
			case 1: this.matchingOption2.checked = true; break;
			case 2: this.matchingOption3.checked = true; break;
			default: this.matchingOption1.checked = true;
		}
	},
	
	initContent:function(){
		var cws = com.ibm.mm.builder.coreWidgetsStrings;
		
		this.matchingOptionsTitleDiv.innerHTML = cws.I_WIRING_MATCHING_MODE;

		this.matchingOption1Text.innerHTML = cws.I_WIRING_ALIAS_MATCH;
		this.matchingOption1.value = this.constants.SEMANTIC_TYPES_ONLY;
		
		this.matchingOption2Text.innerHTML = cws.I_WIRING_PAYLOAD_TYPE_MATCH;
		this.matchingOption2.value = this.constants.PAYLOAD_TYPES_ONLY;
		
		this.matchingOption3Text.innerHTML = cws.I_WIRING_PAYLOAD_TYPE_OR_ALIAS_MATCH;
		this.matchingOption3.value = this.constants.SEMANTIC_OR_PAYLOAD_TYPES;
		
		dojo.attr(this.buttonDivDone,"title",cws.I_WIRING_DONE);
		dojo.attr(this.buttonDivDone,"value",cws.I_WIRING_DONE);
		
		dojo.connect( this.buttonDivDone, "onclick", dojo.hitch( this, this.makeSelectionAndClose ) );
		
		var contentDiv = document.createElement("div");
		contentDiv.appendChild(this.wiringSettingsDiv);
		this.notificationDialog = dijit.byId(this.dialogWidgetId);
		if (!this.notificationDialog) {
			this.notificationDialog = new com.ibm.mm.builder.widget.CustomDialog({
				id: this.dialogWidgetId,
				title: cws.I_WIRING_SETTINGS_DIALOG_NAME,
				needUnderLay: true,
				roundCorner: false,
				modelDialog: true,
				hasRightBottomResizer: false
			
			}, contentDiv);
		}
	},
	
	destroy:function() {
		this.notificationDialog.destroy();
	},
	
	show:function(widgetId) {
		this.notificationDialog.show();
	},
	
	hide:function(){
		if(this.notificationDialog) {
			this.notificationDialog.hide();
		}
	},
	
	_buildSettingsMap: function () {
		var settings = {};
		settings[ this.constants.SETTING_MATCHING_TYPE ] = this._getMatchingType();
		return settings;
	},
	
	_getMatchingType: function () {
		var choice;
		
		if ( this.matchingOption1.checked ) {
			choice = parseInt( this.matchingOption1.value );
		} else if ( this.matchingOption2.checked ) {
			choice = parseInt( this.matchingOption2.value );
		} else if ( this.matchingOption3.checked ) {
			choice = parseInt( this.matchingOption3.value );
		}
		
		return choice;	
	},
	
	makeSelection: function () {
		var settings = this._buildSettingsMap();
		this.onSettingsSaved( settings );
	},
	
	makeSelectionAndClose: function () {
		this.makeSelection();
		this.hide();
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.WirePaneWithSettings"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.WirePaneWithSettings"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.wiringscreen.WirePaneWithSettings");







(function(){
    var cws = com.ibm.mm.builder.coreWidgetsStrings;
    var htmlUtil = com.ibm.mm.builder.utils.htmlUtil;
    
    dojo.declare("com.ibm.mm.builder.iwidget.wiringscreen.WirePaneWithSettings", [dijit._Widget, dijit._Templated], {
    
        templateString:"<div dojoAttachPoint='wirePaneDiv' class='mumWirePaneDiv lotusui30' >\n    <div dojoAttachPoint='prompter' class='mumPrompter'>\n        <div dojoAttachPoint='closer' class='mumPrompterCloser'> </div>\n        <div dojoAttachPoint='contentNode' class='mumPrompterContent'>\n            <div dojoAttachPoint='contentTextNode' tabindex='0' class='mumPrompterContentText'></div>\n            <div dojoAttachPoint='contentLabelNode' class='mumPrompterContentLabel'></div>\n        </div>\n        <div dojoAttachPoint='arrowNode' class='mumPrompterArrow'></div>\n        <div dojoAttachPoint='arrowNodeMid' class='mumPrompterArrowMid'></div>\n        <div dojoAttachPoint='arrowNodeBottom' class='mumPrompterArrowBottom'></div>\n        <div dojoAttachPoint='bottomShadow' class='mumPrompterBottomShadow'></div>\n        <div dojoAttachPoint='lbCornerShadow' class='mumPrompterBottomCornerShadow'></div>\n    </div>\n    <div dojoAttachPoint=\"wirePaneWarningMessage\" class=\"lotusWarning lotusMessage\" style=\"margin: 5px 0px;\"></div>\n    <div dojoAttachPoint='wirePaneTitleDiv' class='mumWirePaneTitleDiv' tabindex=0 role=\"tablist\">\n        <div dojoAttachPoint='shadowCenter' class='titleCenterShadow'></div>\n        <div tabindex='0' dojoAttachPoint='wirePaneTitleDivRight' class='mumWirePaneTitleDivSendTabSend' role=\"tab\" id=\"wirePaneTabSend\">\n            <div dojoAttachPoint='leftDivOfSendTab' class='mumLeftDivOfSendTabSend'>\n                <div dojoAttachPoint='sendIconDiv' class='mumSendIconDivSend'></div>\n            </div>\n            <div dojoAttachPoint='midDivOfSendTab' class='mumMidDivOfSendTabSend'>\n                <div dojoAttachPoint='sendTextDiv' class='mumSendTextDiv'></div>\n            </div>\n            <div dojoAttachPoint='rightDivOfSendTab' class='mumRightDivOfSendTabSend'>\n                <div dojoAttachPoint='sendWireCountDiv' class='mumSendWireCountDiv'></div>\n            </div>\n        </div>\n        <div tabindex='0' dojoAttachPoint='wirePaneTitleDivLeft' class='mumWirePaneTitleDivReceiveTabSend' role=\"tab\" id=\"wirePaneTabReceive\">\n            <div dojoAttachPoint='leftDivOfReceiveTab' class='mumLeftDivOfReceiveTabSend'>\n                <div dojoAttachPoint='recIconDiv' class='mumReceiveIconDivSend'></div>\n            </div>\n            <div dojoAttachPoint='midDivOfReceiveTab' class='mumMidDivOfReceiveTabSend'>\n                <div dojoAttachPoint='receiveTextDiv' class='mumReceiveTextDiv'></div>\n            </div>\n            <div dojoAttachPoint='rightDivOfReceiveTab' class='mumRightDivOfReceiveTabSend'>\n                <div dojoAttachPoint='receiveWireCountDiv' class='mumReceiveWireCountDiv'></div>\n            </div>\n        </div>\n        <div dojoAttachPoint='shadowCorner' class='titleCornerShadow'></div>\n    </div>\n\t<div dojoAttachPoint=\"tabpanel\" role=\"tabpanel\" aria-labelledby=\"wirePaneTab\">\n    \t<div dojoAttachPoint='firstAreaTopDiv' class='firstAreaTopDivSend'></div>\n    \t<div dojoAttachPoint='firstAreaDiv' class='mumFirstAreaDivSend'>\n        \t<div dojoAttachPoint='firstRightShadow' class='mumSideShadow'></div>\n        \t<div dojoAttachPoint='wirePaneMatchingOptionsDiv'></div>\n        \t<div dojoAttachPoint='wirePaneCurrentWidgetDiv'></div>\n        \t<div dojoAttachPoint='wirePaneEventsDiv'></div>\n    \t</div>\n    \t<div dojoAttachPoint='firstAreaBottomDiv' class='mumFirstAreaBottomDivSend'></div>\n\t\t<div dojoAttachPoint='secondAreaDiv' class='mumSecondAreaDivSend'>\n        \t<div dojoAttachPoint='secondRightShadow' class='mumSideShadow'></div>\n        \t<div dojoAttachPoint='wirePaneWidgetsDiv'></div>\n        \t<div dojoAttachPoint='wirePaneWidgetEventsDiv'></div>\n    \t</div>\n    \t<div dojoAttachPoint='secondAreaBottomDiv' class='mumSecondAreaBottomDivSend'></div>\n    \t<div dojoAttachPoint='bottomDiv' class='bottomDiv'>\n        \t<div dojoAttachPoint='bottomQmarkDiv' class='bottomQmarkDiv'></div>\n        \t<input type='submit' dojoAttachPoint='buttonDivSettings' class='lotusFormButton'></input>\n        \t<input type='submit' dojoAttachPoint='buttonDivGraph' class='lotusFormButton'></input>\n\t\t\t<input type='submit' dojoAttachPoint='buttonDivDone'class='lotusFormButton'></input>\n    \t</div>\n\t</div>\n</div>\n",
        
        iContext: null,
        
        iwidgetId: "", //the widget uid 
        
		displayQName: "true",
		/*
         * The divs for display the corresponding info
         */
        wirePane: null,
        
        wirePaneDiv: null,
        
        wirePaneTitleDiv: null,
        
        wirePaneTitleDivLeft: null,
        
        wirePaneWarningMessage: null,
        
        sendIconDiv: null,
        
        sendWireCountDiv: null,
        
        receiveWireCountDiv: null,
        
        wirePaneTitleDivRight: null,
        
        recIconDiv: null,
        
        wirePaneCurrentWidgetDiv: null,
        
        wirePaneEventsDiv: null,
        
        wirePaneWidgetsDiv: null,
        
        wirePaneWidgetEventsDiv: null,
        
        wirePaneAdaptersDiv: null,
        
        firstAreaTopDiv: null,
        
        firstAreaDiv: null,
        
        firstAreaBottomDiv: null,
        
        secondAreaBottomDiv: null,
        
        secondAreaDiv: null,
        
        secondAreaTopDiv: null,
        
        thirdAreaDiv: null,
        
        bottomQmarkDiv: null,
        
        bottomDiv: null,
        
        prompter: null,
        
        widgetObj: null, // cache object, store all the widget-related info(name,icon...)
        highlightTimer: null,
        
        selectedEvent: "", //user selected event
        selectedWireWidget: "",
        
        //cache object, widgets which have match event
        widgets: null,
        
        //cache object, the events map for current event
        eventsMap: null,
        
        currentType: "", // current tab ( send/receive)
        grayTip: null, // The bottom Div for showing the Tip
        showPrompter: true,
        
        currentPageId: "", // Current page 
        localized: com.ibm.mashups.enabler.context.Factory.getLocalizedContext(), //TODO - does this need to change?
        wiringSettingsDialog: null, // dialog to open the wiring settings - controlled by the displaySettings option
        wiringSettings: null, // settings map - only available after the wiring settings dialog has been closed
        wiringSettingsConstants: com.ibm.mm.builder.iwidget.wiringscreen.WiringSettingsConstants, // constants for settings
        /**
         * current action step
         * 1: init
         * 2: choose event
         * 3: choose widget
         */
        actionStep: 1,
        
        clickedWidgetDiv: null, // the clicked widget div in the second pane
        allHanWires: 0,
        
        allPubWires: 0,
        
        titleFontStyle: {
            fontSize: "1.4em",
            fontFamily: "Arial,Helvetica,sans-serif",
            fontWeight: "bold"
        },
        
        defaultFontStyle: {
            fontSize: "1.4em",
            fontFamily: "Arial,Helvetica,sans-serif",
            fontWeight: "normal"
        },
        
        italicStyle: {
            fontSize: "1.4em",
            fontFamily: "Arial,Helvetica,sans-serif",
            fontWeight: "normal",
            fontStyle: "italic"
        },
        
        LOGGER: com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.iwidget.wiringscreen.WirePane2"),
        
        setSelectedEvent: function(eventName){
            this.selectedEvent = eventName;
        },
        
        destroy: function () {
        	if ( this.wiringSettingsDialog ) {
        		this.wiringSettingsDialog.destroy();
        	}
        	
        	this.inherited( arguments );
        },
        
        /** 
         * Init the wire pane, place divs into right position and set the css class
         */
        initWirePane: function(){
            var config = this.iContext.getiWidgetAttributes();
            var shouldShowSettings = config.getItemValue("displaySettings");
            var shouldShowWarning = config.getItemValue("displayPortletsAndWidgetsWarningMessage");
            
            shouldShowSettings = ( shouldShowSettings === "true" ? true : false );
            shouldShowWarning = ( shouldShowWarning === "true" ? true : false );
            
            if ( shouldShowWarning ) {
				this.wirePaneWarningMessage.innerHTML = cws.I_WIRING_PORTLETS_AND_WIDGETS;
            } else {
            	this.hideElement(this.wirePaneWarningMessage );
            }
            
            this.grayTip = document.createElement("div");
            this.grayTip.innerHTML = cws.I_WIRING_NO_MATCH_WIDGET;
            
            //Init the 2 main panes, hide the second at first
            dojo.fx.wipeOut({
                node: this.secondAreaDiv,
                duration: 10
            }).play();
            
            this.hideElement(this.secondAreaBottomDiv);
            
            //Init the title (text, icon)
            this.createTitleDiv();
            
            //Current widget's event
            this.wirePaneEventsDiv.setAttribute("id", "wirePaneEventsDiv_id");
            
            this.wirePaneWidgetsDiv.style.display = "none";
            
            dojo.fx.wipeOut({
                node: this.wirePaneWidgetEventsDiv,
                duration: 10
            }).play();
            
            // Buttons on the right-bottom
            dojo.attr(this.buttonDivDone, "title", cws.I_WIRING_DONE);
            dojo.attr(this.buttonDivDone, "value", cws.I_WIRING_DONE);
            dojo.attr(this.buttonDivGraph, "title", cws.I_WIRING_SHOW_GRAPH);
            dojo.attr(this.buttonDivGraph, "value", cws.I_WIRING_SHOW_GRAPH);
            
            dojo.attr(this.wirePaneTitleDivLeft, "title", cws.I_WIRING_TITLE_RECEIVE + " " + this.allHanWires);
            dojo.attr(this.wirePaneTitleDivRight, "title", cws.I_WIRING_TITLE_SEND + " " + this.allPubWires);
            
            this.connect(this.closer, "onclick", this.closePrompter);
            
            this.connect(this.bottomQmarkDiv, "onclick", this.onClickQmark);
            
            var closeFun = function(){
                com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.iContext.widgetId);
                com.ibm.mm.builder.utils.wireUtil.removeHighlight();
            };
            
            this.connect(this.buttonDivDone, "onclick", dojo.hitch(this, closeFun));
            
            this.connect(this.buttonDivGraph, "onclick", dojo.hitch(this, function(){
                this.onClickShowGraph();
                com.ibm.mm.builder.utils.wireUtil.removeHighlight();
            }));
            
            if (shouldShowSettings) {
                dojo.attr(this.buttonDivSettings, "title", cws.I_COMMON_ACTION_SETTINGS);
                dojo.attr(this.buttonDivSettings, "value", cws.I_COMMON_ACTION_SETTINGS);
                
                dojo.connect(this.buttonDivSettings, "onclick", dojo.hitch(this, this.openWiringSettings));
            }
            else {
                this.hideElement(this.buttonDivSettings);
            }
            
            if (this.iContext.dialogContainer) {
                this.connect(this.iContext.dialogContainer.closeButtonNode, "onclick", dojo.hitch(this, closeFun));
            }           
        },
        
        /**
         * Util function, hide the div
         * @param {Object} div
         */
        hideElement: function(div){
            div.style.display = "none";
        },
        
        showElement: function(div){
            div.style.display = "";
        },
        
        /**
         * Display the prompter on the left side based on action step
         * @param {Object} step // in which step of current action, value should be 1,2,3
         * @param {Object} domNode
         */
        displayPrompter: function(step){
            //save the status for restore from hidden
            this.actionStep = step;
            
            if (this.showPrompter === false) {
                return;
            }
            var align = {
                'TL': 'TR',
                'BR': 'BL'
            };
            
            var properColor = this.getProperColor(step);
            
            var closerNode = dojo.query(".mumPrompterCloser", this.prompter)[0];
            htmlUtil.setClass(closerNode, "mumPrompterCloser");
            dojo.addClass(closerNode, "mumCloser" + properColor);
            
            //for a11y
            closerNode.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/" + properColor.toLowerCase() + "_closer.png' alt=''>";
            
            var contentNode = dojo.query(".mumPrompterContent", this.prompter)[0];
            htmlUtil.setClass(contentNode, "mumPrompterContent");
            dojo.addClass(contentNode, "mumContent" + properColor);
            
            var arrowNode = dojo.query(".mumPrompterArrow", this.prompter)[0];
            htmlUtil.setClass(arrowNode, "mumPrompterArrow");
            dojo.addClass(arrowNode, "mumPrompterArrow" + properColor);
            
            var textNode = dojo.query(".mumPrompterContentText", this.prompter)[0];
            var labelNode = dojo.query(".mumPrompterContentLabel", this.prompter)[0];
            htmlUtil.setClass(labelNode, "mumPrompterContentLabel");
            
            dojo.addClass(labelNode, "mumLabel" + properColor);
            dojo.attr(textNode, "keepBlankSpace", "");
            
            var truncatedWidgetName = htmlUtil.truncateWord(textNode, this.widgetObj.widgetname, 120);
			// always truncate word no matter it is fontsizeEnlareged
            var truncatedSelectedEvent = htmlUtil.truncateWord(textNode, this.selectedEventTitle, 120, true);
			var truncatedWiredWidget = htmlUtil.truncateWord(textNode, this.selectedWireWidget, 120);
			var prompterFont = {fontSize: "1.2em"};
            switch (step) {
                case "1":
                    if (this.currentType == "Send") {
                        textNode.innerHTML = htmlUtil.getStrWithLimit(
							dojo.string.substitute(cws.I_WIRING_PROMPTER_SEND_1, ["" + truncatedWidgetName + ""]), 
							textNode, 585, prompterFont);
                    }
                    else {
                        textNode.innerHTML = htmlUtil.getStrWithLimit(
							dojo.string.substitute(cws.I_WIRING_PROMPTER_RECEIVE_1, ["" + truncatedWidgetName + ""]), 
							textNode, 530, prompterFont);
                    }
                    labelNode.innerHTML = cws.I_WIRING_PROMPTER_STEP_1;
                    htmlUtil.setClass(this.prompter, "mumPrompterAtEvents");
                    break;
                case "2":
                    if (this.currentType == "Send") {
                        textNode.innerHTML = htmlUtil.getStrWithLimit(
							dojo.string.substitute(cws.I_WIRING_PROMPTER_SEND_2, ["" + truncatedSelectedEvent + ""]), 
							textNode, 585, prompterFont);
                    }
                    else {
                        textNode.innerHTML = htmlUtil.getStrWithLimit(
							dojo.string.substitute(cws.I_WIRING_PROMPTER_RECEIVE_2, ["" + truncatedSelectedEvent + ""]),
							textNode, 530, prompterFont);
                    }
                    labelNode.innerHTML = cws.I_WIRING_PROMPTER_STEP_2;
                    htmlUtil.setClass(this.prompter, "mumPrompterAtWidgets");
                    break;
                case "3":
                    if (this.currentType == "Send") {
                        textNode.innerHTML = htmlUtil.getStrWithLimit(
							dojo.string.substitute(cws.I_WIRING_PROMPTER_SEND_3, ["" + truncatedWiredWidget + "", "" + truncatedSelectedEvent + ""]), 
							textNode, 585, prompterFont);
                    }
                    else {
                        textNode.innerHTML = htmlUtil.getStrWithLimit(
							dojo.string.substitute(cws.I_WIRING_PROMPTER_RECEIVE_3, ["" + truncatedWiredWidget + "", "" + truncatedWidgetName + ""]), 
							textNode, 530, prompterFont);
                    }
                    labelNode.innerHTML = cws.I_WIRING_PROMPTER_STEP_3;
                    htmlUtil.setClass(this.prompter, "mumPrompterAtWidgetEvents");
                    break;
            }
            this.prompter.style.visibility = "visible";
            
            //		var borderTop = htmlUtil.getCurrentStyle(this.prompter,'border-top-width');
            //		var borderBottom = htmlUtil.getCurrentStyle(this.prompter,'border-bottom-width');
            
			window.setTimeout(dojo.hitch(this, function() {
				var coord = dojo.coords(this.prompter);
				var coordArrow = dojo.coords(this.arrowNode);
				var temp = coord.h - coordArrow.h + coordArrow.t;
				this.arrowNodeMid.style.height = temp + "px";
			}), 200);	// set innerHTML will be slow
        },
        
        closePrompter: function(){
            this.showPrompter = false;
            this.prompter.style.visibility = "hidden";
            this.bottomQmarkDiv.style.visibility = "visible";
        },
        
        onClickQmark: function(){
            this.showPrompter = true;
            this.prompter.style.visibility = "visible";
            this.displayPrompter(this.actionStep);
            this.bottomQmarkDiv.style.visibility = "hidden";
        },
        
        /**
         * This function will be invoked when user click the "Show Graph" button
         * Hide the wire interface and display the wiring graph
         */
        onClickShowGraph: function(){
        
            com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayWireGraph", this.iwidgetId);
            //		this.iContext.scope.displayWireGraph(this.iwidgetId,true);
        },
        /**
         * Get the proper color name based on current tab and action step
         * @param {Object} step: action step, should be 1/2/3
         * @return Blue or Green
         */
        getProperColor: function(step){
            switch (step) {
                case "1":
                    if (this.currentType == "Send") {
                        return "Green";
                    }
                    else {
                        return "Blue";
                    }
                    break;
                case "2":
                    if (this.currentType == "Send") {
                        return "Blue";
                    }
                    else {
                        return "Green";
                    }
                    break;
                case "3":
                    if (this.currentType == "Send") {
                        return "Blue";
                    }
                    else {
                        return "Green";
                    }
                    break;
            }
        },
        /**
         * Util function
         * Get the proper text for event name display
         * @param {Object} name
         */
        getProperName: function(name){
            var result = "<span title='" + name + "' >";
            if (name.length >= 18) {
                result = result + name.substring(0, 14) + "...";
            }
            else {
                result = result + name;
            }
            result = result + "</span>";
            return result;
        },
        
        /**
         * Util function
         * Get the proper text for widget title display
         * @param {Object} name
         */
        getProperTitle: function(name, len){
            var result = "<span tabindex='0' title='" + name + "' >";
            if (len === null) {
                len = 25;
            }
            if (name.length >= len) {
                result = result + name.substring(0, len - 4) + "...";
            }
            else {
                result = result + name;
            }
            result = result + "</span>";
            return result;
        },
        
        /**
         * Util function
         * Get the proper text for combined common data type
         * @param {Object} type
         */
        getShownType: function(type){
            var checker = com.ibm.mm.builder.utils.wireUtil.dataTypeChecker();
			if(this.displayQName=="false") {	// remove the qname in {}
				type = type.replace(/^\{.*}/, "");
			}
            return checker.getTypeLabel(type);
        },
        
        /**
         * Own wipeIn function to avoid the "height=auto" problem of dojo.fx.wipeIn
         * @param {Object} args
         */
        wipeIn: function(args){
            args.node = dojo.byId(args.node);
            var node = args.node, s = node.style, o;
            
            var anim = dojo.animateProperty(dojo.mixin({
                properties: {
                    height: {
                        // wrapped in functions so we wait till the last second to query (in case value has changed)
                        start: function(){
                            // start at current [computed] height, but use 1px rather than 0
                            // because 0 causes IE to display the whole panel
                            o = s.overflow;
                            s.overflow = "hidden";
                            if (s.visibility == "hidden" || s.display == "none") {
                                s.height = "1px";
                                s.display = "";
                                s.visibility = "";
                                return 1;
                            }
                            else {
                                var height = dojo.style(node, "height");
                                return Math.max(height, 1);
                            }
                        },
                        end: function(){
                            return node.scrollHeight;
                        }
                    }
                }
            }, args));
            
            this.connect(anim, "onEnd", function(){
                //s.height = "auto";
                s.overflow = o;
            });
            
            return anim; // dojo._Animation
        },
        
        /**
         * Util function
         * Generate a div element with the given css class
         * @param {string} className : the css class name for the div
         */
        createDivWithClass: function(className){
            var tempDiv = document.createElement("div");
            dojo.addClass(tempDiv, className);
            return tempDiv;
        },
        
        /**
         * Adjust the div class when switch between "Send" and "Receive" model
         */
        adjustDivsStyle: function(){
			this.tabpanel.setAttribute("aria-labelledby", "wirePaneTab" + this.currentType);
            this.adjustTitleDiv();
            htmlUtil.setClass(this.firstAreaTopDiv, "firstAreaTopDiv" + this.currentType);
            htmlUtil.setClass(this.firstAreaDiv, "mumFirstAreaDiv" + this.currentType);
            htmlUtil.setClass(this.secondAreaDiv, "mumSecondAreaDiv" + this.currentType);
            htmlUtil.setClass(this.firstAreaBottomDiv, "mumFirstAreaBottomDiv" + this.currentType);
            htmlUtil.setClass(this.secondAreaBottomDiv, "mumSecondAreaBottomDiv" + this.currentType);
            this.hideElement(this.secondAreaBottomDiv);
        },
        
        /**
         * This function will be invoke when user click on the left(receive) tab on wire pane title
         * Switch between "Send" and "Receive" and change the pane content
         */
        onClickTitlePaneLeft: function(e){
            if (this.currentType == "Send") {
                this.currentType = "Receive";
                
                htmlUtil.setClass(this.wirePaneTitleDivLeft, "mumWirePaneTitleDivLeftClick");
                htmlUtil.setClass(this.wirePaneTitleDivRight, "mumWirePaneTitleDivSendTab");
				
				dijit.setWaiState(this.wirePaneTitleDivLeft, "pressed", "true");
				dijit.setWaiState(this.wirePaneTitleDivLeft, "selected", "true");
				dojo.attr(this.wirePaneTitleDivLeft, "tabindex", "0");
				
				dijit.setWaiState(this.wirePaneTitleDivRight, "pressed", "false");
				dijit.setWaiState(this.wirePaneTitleDivRight, "selected", "false");
                dojo.attr(this.wirePaneTitleDivRight, "tabindex", "-1");
				
                htmlUtil.setClass(this.sendIconDiv, "mumSendIconDiv");
                htmlUtil.setClass(this.recIconDiv, "mumReceiveIconDivClick");
                
                this.adjustDivsStyle();
                
                this.createReceiveEventsDiv();
                dojo.fx.wipeOut({
                    node: this.secondAreaDiv,
                    duration: 10
                }).play();
                this.hideElement(this.secondAreaBottomDiv);
            }
            this.displayPrompter("1");
			dijit.focus(this.wirePaneTitleDivLeft);
        },
		
        onKeyPresTitlePane: function(e){
			var key = e.keyCode;
			if (key === dojo.keys.LEFT_ARROW) {
                this.onClickTitlePaneLeft(e);
			} else if (key === dojo.keys.RIGHT_ARROW) {
				this.onClickTitlePaneRight(e);
			}
        },
        
        /**
         * This function will be invoke when user click on the right(send) tab on wire pane title
         * Switch between "Send" and "Receive" and change the pane content
         */
        onClickTitlePaneRight: function(e){
            if (this.currentType == "Receive") {
                this.currentType = "Send";
                
                htmlUtil.setClass(this.wirePaneTitleDivLeft, "mumWirePaneTitleDivReceiveTab");
                htmlUtil.setClass(this.wirePaneTitleDivRight, "mumWirePaneTitleDivRightClick");
                
				dijit.setWaiState(this.wirePaneTitleDivRight, "pressed", "true");
				dijit.setWaiState(this.wirePaneTitleDivRight, "selected", "true");
				dojo.attr(this.wirePaneTitleDivRight, "tabindex", "0");
				
				dijit.setWaiState(this.wirePaneTitleDivLeft, "pressed", "false");
				dijit.setWaiState(this.wirePaneTitleDivLeft, "selected", "false");
                dojo.attr(this.wirePaneTitleDivLeft, "tabindex", "-1");
				
                htmlUtil.setClass(this.sendIconDiv, "mumSendIconDivClick");
                htmlUtil.setClass(this.recIconDiv, "mumReceiveIconDiv");
                
                this.adjustDivsStyle();
                
                this.createSendEventsDiv();
                //wipe out other panes, only remain the first event pane
                dojo.fx.wipeOut({
                    node: this.secondAreaDiv,
                    duration: 10
                }).play();
                this.hideElement(this.secondAreaBottomDiv);
            }
            this.displayPrompter("1");
			dijit.focus(this.wirePaneTitleDivRight);
        },
        
        
        onMouseOverCurrentWidget: function(e){
            var widgetDiv = e.currentTarget;
            dojo.addClass(widgetDiv, "mumMouseOverCurrentWidget" + this.currentType);
        },
        
        onMouseOutCurrentWidget: function(e){
            var widgetDiv = e.currentTarget;
            dojo.removeClass(widgetDiv, "mumMouseOverCurrentWidget" + this.currentType);
        },
        onKeyPressEvent: function(e){
            switch (e.keyCode) { // JSLINT-IGNORE: <support future extend>
                case dojo.keys.ENTER:
                    this.onClickEvent(e);
                    break;
            }
        },
        /**
         * This function will be invoke when user choose one event
         * Display the second widgets pane based on the selected event
         */
        onClickEvent: function(e){
        
            var eventDiv = e.currentTarget;
            
            //Display the return image
            var returnImgs = dojo.query(".mumEventDivReturnImg" + this.currentType, eventDiv);
            returnImgs[0].style.visibility = "visible";
			returnImgs[0].setAttribute("role", "button");
            
            /*
             * Hide all other events
             */
            if (eventDiv.getAttribute("isClicked") != "true") {
            
                var eventName = eventDiv.getAttribute("eventName");
                this.selectedEvent = eventName;
                this.selectedEventTitle = eventDiv.getAttribute("eventTitle");
                this.widgets = this.eventsMap[this.currentType + "-" + eventName];
                
                //fade all other events
                var otherEvents = dojo.query(".mumEventDiv", this.wirePaneEventsDiv);
                if (otherEvents.length > 1) {
                    for (var i = 0; i < otherEvents.length; i++) {
                        var event = otherEvents[i];
                        if (event.getAttribute("eventName") != eventName) {
                            dojo.fx.combine([dojo.fadeOut({
                                node: event,
                                duration: 1000
                            }), dojo.fx.wipeOut({
                                node: event,
                                duration: 1000
                            })]).play();
                            event.setAttribute("isClicked", "false");
                        }
                    }
                }
                eventDiv.setAttribute("isClicked", "true");
                htmlUtil.setClass(eventDiv, "mumEventDivClicked" + this.currentType);
                //new event , hide the widget's event pane
                var matchWidgetCount = this.createWidgetsDiv();
                
                //show new link pane
                //htmlUtil.setClass(this.firstAreaDiv, "mumFirstAreaDivClick" + this.currentType);
                htmlUtil.setClass(this.firstAreaBottomDiv, "mumFirstAreaBottomDivExpand" + this.currentType);
                this.showElement(this.secondAreaBottomDiv);
                
                dojo.fx.wipeIn({
                    node: this.secondAreaDiv,
                    duration: 1000
                }).play();
                this.showElement(this.secondAreaBottomDiv);
                this.displayPrompter("2");
                
            }
        },
        onKeyPressEventReturnImg: function(e){
            switch (e.keyCode) { // JSLINT-IGNORE: <support future extend>
                case dojo.keys.ENTER:
                    this.onClickEventReturnImg(e);
                    break;
            }
        },
        /**
         * This function will be invoke when user click on the return image of one event.It will
         * 1. hide the return image
         * 2. display all other events
         * 3. hide the second pane
         * @param {event} e: the "onclick" event of the return image in selected event's div
         */
        onClickEventReturnImg: function(e){
        
            var eventDiv = e.currentTarget.parentNode;
            
            //restore to the org status, need to judget whether this event has wired with other event or not.
            htmlUtil.setClass(eventDiv, "mumEventDiv");
            var countDiv = dojo.query(".mumEventDivCount" + this.currentType, eventDiv);
            var count = parseInt(countDiv[0].innerHTML, 10);
            if (count > 0) {
                dojo.addClass(eventDiv, "mumEventDivWired");
            }
            
            if (eventDiv.getAttribute("isClicked") == "false") {
                return;
            }
            //hide the return image and the separator bar
            var returnImg = e.currentTarget;
            returnImg.style.visibility = "hidden";
            
            //fade all other events
            var otherEvents = dojo.query(".mumEventDiv", this.firstAreaDiv);
            if (otherEvents.length == 1) {
                otherEvents[0].setAttribute("isClicked", "false");
                dojo.stopEvent(e);
            }
            else 
                if (otherEvents.length > 1) {
                    for (var j = 0; j < otherEvents.length; j++) {
                        var event = otherEvents[j];
                        dojo.fx.combine([dojo.fadeIn({
                            node: event,
                            duration: 1000
                        }), this.wipeIn({
                            node: event,
                            duration: 1000
                        })]).play();
                        event.setAttribute("isClicked", "false");
                    }
                    dojo.stopEvent(e);
                }
            
            htmlUtil.setClass(this.firstAreaBottomDiv, "mumFirstAreaBottomDiv" + this.currentType);
            
            dojo.fx.wipeOut({
                node: this.secondAreaDiv,
                duration: 500
            }).play();
            this.hideElement(this.secondAreaBottomDiv);
            dojo.fx.wipeOut({
                node: this.wirePaneWidgetEventsDiv,
                duration: 10
            }).play();
            
            this.displayPrompter("1");
        },
        onKeyPressWidget: function(e){
            switch (e.keyCode) { // JSLINT-IGNORE:
                case dojo.keys.ENTER:
                    this.onClickWidget(e);
                    break;
            }
        },
        /**
         * This function will be invoked when user click on one widget in the second area
         * @param {Event} e: the event object of the widget div's "onclick"
         */
        onClickWidget: function(e){
            var aWidgetDiv = e.currentTarget;
            this.selectedWireWidget = aWidgetDiv.getAttribute("widgetName");
            this.clickedWidgetDiv = aWidgetDiv;
            // Find the return image button
            var returnImgs = dojo.query(".mumWidgetDivReturnImg" + this.currentType, aWidgetDiv);
            returnImgs[0].style.visibility = "visible";
            //A11Y        
            returnImgs[0].setAttribute("tabindex", "0");
			returnImgs[0].setAttribute("role", "button");
            
            var widgetId = e.currentTarget.getAttribute("widgetId");
            
            htmlUtil.setClass(aWidgetDiv, "mumWidgetClicked" + this.currentType);
            //dojo.addClass(aWidgetDiv, "mumWidgetClicked" + this.currentType);
            
            if (aWidgetDiv.getAttribute("isClicked") == "true") {
                return;
            }
            //fade out all other widgets
            var widgetDivs = dojo.query(".mumWireWidget" + this.currentType, this.wirePaneWidgetsDiv);
            if (widgetDivs.length > 0) {
                for (var i = 0; i < widgetDivs.length; i++) {
                    var widgetDiv = widgetDivs[i];
                    if (widgetDiv.getAttribute("widgetId") != widgetId) {
                        dojo.fx.combine([dojo.fadeOut({
                            node: widgetDiv,
                            duration: 1000
                        }), dojo.fx.wipeOut({
                            node: widgetDiv,
                            duration: 1000
                        })]).play();
                        widgetDiv.setAttribute("isClicked", false);
                    }
                }
            }
            //make the selected widget div
            aWidgetDiv.setAttribute("isClicked", "true");
            this.createWidgetEventsDiv(widgetId);
            //display the event-event wire pane
            dojo.fx.wipeIn({
                node: this.wirePaneWidgetEventsDiv,
                duration: 1000
            }).play();
            dojo.fadeIn({
                node: this.wirePaneWidgetEventsDiv,
                duration: 1000
            }).play();
            this.displayPrompter("3");
            
            //Remove the widget highlight
            window.clearTimeout(this.highlightTimer);
            dojo.publish(com.ibm.mm.builder.eventTopics.WirePane_OutWidget, [widgetId]);
        },
        onKeyPressWidgetReturnImg: function(e){
            switch (e.keyCode) { // JSLINT-IGNORE: <support future extend>
                case dojo.keys.ENTER:
                    this.onClickWidgetReturnImg(e);
                    break;
            }
        },
        /**
         * This function will be invoked when user click on the return image button
         * on the right side of the selected widget's div
         * @param {Event} e: the "onclick" event of the widget div's return image
         */
        onClickWidgetReturnImg: function(e){
        
            //hide the return image
            e.currentTarget.style.visibility = "hidden";
            var aWidgetDiv = e.currentTarget.parentNode;
            
            if (aWidgetDiv.getAttribute("isClicked") == "false") {
                return;
            }
            
            htmlUtil.setClass(aWidgetDiv, "mumWireWidget" + this.currentType);
            
            //fade in other widgets
            var widgetDivs = dojo.query(".mumWireWidget" + this.currentType, this.wirePaneWidgetsDiv);
            if (widgetDivs.length > 1) {
                for (var i = 0; i < widgetDivs.length; i++) {
                    var widgetDiv = widgetDivs[i];
                    dojo.fadeIn({
                        node: widgetDiv,
                        duration: 1000
                    }).play();
                    this.wipeIn({
                        node: widgetDiv,
                        duration: 1000
                    }).play();
                    widgetDiv.setAttribute("isClicked", "false");
                }
            }
            //restore the widget div status
            aWidgetDiv.setAttribute("isClicked", "false");
            dojo.fx.wipeOut({
                node: this.wirePaneWidgetEventsDiv,
                duration: 1000
            }).play();
            dojo.fadeOut({
                node: this.wirePaneWidgetEventsDiv,
                duration: 1000
            }).play();
            dojo.stopEvent(e);
            this.displayPrompter("2");
        },
        
        onMouseOverWidget: function(e){
            var widgetDiv = e.currentTarget;
            if (widgetDiv.getAttribute("isClicked") == "true") {
                return;
            }
            var widgetId = widgetDiv.getAttribute("widgetId");
            var _this = this;
            this.highlightTimer = window.setTimeout(function(){
                com.ibm.mm.builder.utils.wireUtil.highlightWidget(widgetId);
                //com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.highlightWidget", widgetId);
                //			_this.iContext.iEvents.publishEvent("widgetHighlighted", widgetId);
            }, 300);
        },
        
        onMouseOutWidget: function(e){
            var widgetDiv = e.currentTarget;
            if (widgetDiv.getAttribute("isClicked") == "true") {
                return;
            }
            var widgetId = widgetDiv.getAttribute("widgetId");
            var widget = this.getWidgetFromMap(widgetId);
            if (widget.totalWiredEvents > 0) {
                dojo.addClass(widgetDiv, "mumHasWiredEvent");
            }
            window.clearTimeout(this.highlightTimer);
			com.ibm.mm.builder.utils.wireUtil.removeHighlight();
            //com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.removeWidgetHighlight", widgetId);
            //		this.iContext.iEvents.publishEvent("widgetHighlightRemoved",widgetId);
        },
        
        /**
         * Invoke when user click on one widget's event div in the second pane
         * which has been click before(already display the wire div)
         * It will remove the wire div and restore the event back to normal status
         * @param {Object} aEventDiv: the clicked div
         */
        restoreEventDiv: function(aEventDiv){
        
            if (aEventDiv.getAttribute("isClicked")) { // Click before, now in expand status
                aEventDiv.setAttribute("isClicked", "false");
                htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDiv");
                var actionDivs = dojo.query(".mumWidgetPaneEventActionDiv", aEventDiv);
                if (actionDivs && actionDivs.length > 0) {
                    for (var i = 0; i < actionDivs.length; i++) {
                        var actionDiv = actionDivs[i];
                        aEventDiv.removeChild(actionDiv);
                    }
                }
            }
        },
        
        /**
         * Invoke when user click on a matched event and want to connect
         * 1. restore all other event back to normal status
         * 2. generate a connection div and append to this event's div
         * @param {Event} e The "onclick" event of the selected event div
         */
        onClickConEventDiv: function(e){
        
            var aEventDiv = e.currentTarget;
            
            // Fetch all needed info and fill them into the new generated event connection div
            var id = aEventDiv.getAttribute("belongId");
            var eventName = aEventDiv.getAttribute("eventName");
            //here
            var aEvent = this.getEventFromWidget(id, eventName);
            
            var aEventInfoDiv = document.createElement("div");
            htmlUtil.setClass(aEventInfoDiv, "mumWidgetPaneEventInfoDiv" + this.currentType);
            
            // the text and checkbox 
            var checkMarkDiv = dojo.query(".checkMarkDiv", aEventDiv)[0];
            if (aEvent.isWired) {
                htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDiv");
                this.disconnectEvent(id, eventName);
                checkMarkDiv.innerHTML = "<input type='checkbox' dojoType='Checkbox' title='" + aEventDiv.firstChild.title + "'/>";
                aEventDiv.setAttribute("isChecked", "");
            }
            else {
                this.connectEvent(id, eventName);
                checkMarkDiv.innerHTML = "<input type='checkbox' dojoType='Checkbox' checked=true title='" + aEventDiv.firstChild.title + "'/>";
                htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDivCheck" + this.currentType);
                aEventDiv.setAttribute("isChecked", "checked");
            }
			// still focus to the check box
			checkMarkDiv.childNodes[0].focus();
        },
        
        onMouseOverConEventDiv: function(e){
            var aEventDiv = e.currentTarget;
            var checked = aEventDiv.getAttribute("isChecked");
            if (checked == "checked") {
                htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDivCheckMouseOver" + this.currentType);
            }
            else {
                htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDivMouseOver");
            }
        },
        
        onMouseOutConEventDiv: function(e){
            var aEventDiv = e.currentTarget;
            var checked = aEventDiv.getAttribute("isChecked");
            if (checked == "checked") {
                htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDivCheck" + this.currentType);
            }
            else {
                htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDiv");
            }
        },
        
        onClickWidgetPaneEventReturnImg: function(e){
        
            var aEventDiv = e.currentTarget.parentNode;
            
            var infoDiv = dojo.query(".mumWidgetPaneEventInfoDiv" + this.currentType, aEventDiv);
            var returnImg = dojo.query(".mumWidgetPaneEventReturnImg", aEventDiv);
            aEventDiv.removeChild(returnImg[0]);
            
            dojo.removeClass(infoDiv[0], "mumFloatLeft");
            
            var allEventsDiv = dojo.query(".mumWidgetPaneEventDiv", this.mumWidgetEventsDiv);
            var anotherEvent = null;
            for (var m = 0; m < allEventsDiv.length; m++) {
                anotherEvent = allEventsDiv[m];
                dojo.fadeIn({
                    node: anotherEvent,
                    duration: 1000
                }).play();
                dojo.fx.wipeIn({
                    node: anotherEvent,
                    duration: 1000
                }).play();
            }
            
            var allGrayEventsDiv = dojo.query(".mumWidgetPaneEventDivGray", this.mumWidgetEventsDiv);
            for (var n = 0; n < allGrayEventsDiv.length; n++) {
                anotherEvent = allGrayEventsDiv[n];
                dojo.fadeIn({
                    node: anotherEvent,
                    duration: 1000
                }).play();
                dojo.fx.wipeIn({
                    node: anotherEvent,
                    duration: 1000
                }).play();
            }
            
            dojo.stopEvent(e);
        },
        
        /**
         * Fetch the widget object from the cache
         * @param {Object} id: the widget id
         */
        getWidgetFromMap: function(id){
            var widget;
            for (var i = 0; i < this.widgets.length; i++) {
                widget = this.widgets[i];
                if (id == widget.id) {
                    return widget;
                }
            }
            return null;
        },
        
        /**
         * Get the event object from cache based on the widget id and event name
         * @param {Object} id : the id of the widget
         * @param {Object} eventName : the name of the event
         */
        getEventFromWidget: function(id, eventName){
            var event;
            for (var i = 0; i < this.widgets.length; i++) {
                var widget = this.widgets[i];
                if (id == widget.id) {
                    var events = widget.events;
                    for (var j = 0; j < events.length; j++) {
                        event = events[j];
                        
                        if (event.name == eventName) {
                            break;
                        }
                    }
                    break;
                }
            }
            return event;
        },
        
        /**
         * Update the cache after add/remove wire on the interaction interface
         * @param {string} sourceId
         * @param {string} sourceEvent
         * @param {string} targetId
         * @param {string} targetEvent
         */
        updateEventsMap: function(sourceId, sourceEvent, targetId, targetEvent, isAddWire){
            //var widgetsArray = com.ibm.mm.builder.utils.wireUtil.getAllMatchHandleEvents(sourceId, sourceEvent,this.iContext.scope.layouts);
            //this.eventsMap["Send-" + sourceEvent] = widgetsArray;
            //this.widgets = widgetsArray;
            var eventName = targetEvent;
            var widgetId = targetId;
            if (this.currentType == "Receive") {
                eventName = sourceEvent;
                widgetId = sourceId;
            }
            var wireVar = -1;
            if (isAddWire) {
                wireVar = 1;
            }
            for (var i = 0; i < this.widgets.length; i++) {
                var widget = this.widgets[i];
                if (widgetId == widget.id) {
                    //Find the widget
                    widget.totalWiredEvents += wireVar;
                    var events = widget.events;
                    for (var j = 0; j < events.length; j++) {
                        var event = events[j];
                        
                        if (event.name == eventName) {
                            //Find the event
                            event.isWired = isAddWire;
                        }
                    }
                    break;
                }
            }
        },
        
        getWireModel: function(){
            // get current page
            var navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
            
            var currentPage = navModel.find(this.currentPageId).start();
            var lm = navModel.getLayoutModel(currentPage);
            var wiringModel = lm.getWireModel();
            
            return wiringModel;
        },
        
        getLayoutModel: function(){
            // get current page
            var navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
            
            var currentPage = navModel.find(this.currentPageId).start();
            var lm = navModel.getLayoutModel(currentPage);
            return lm;
        },
        
        getLayoutControl: function(lcId){
            var lc = this.getLayoutModel().find(lcId).start();
            return lc;
            
        },
     	
        addWire: function(sourceId, sourceEvent, targetId, targetEvent, needUpdate){
        
            // Update WireModel 
            // Create the JSON object
            // Get WidgetWindow for layout control
            var currentPageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
            var navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
            var currentPage = navModel.find(this.currentPageId).start();
            
            var widgetModel = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
            var sourcelc = this.getLayoutControl(sourceId);
            var sourceWidgetWindow = widgetModel.getWidgetWindow(sourcelc).start();
            
            var sourceEventProvider = widgetModel.getHierarchicalEventProvider(sourceWidgetWindow).start();
            //var sourceEventObject = sourceEventProvider.getEvent(sourceEvent);
            var sourceEventObject = com.ibm.mm.builder.utils.wireUtil.getEventByNameAndType(
					sourceEventProvider, sourceEvent, com.ibm.mashups.enabler.widget.Constants.FILTER_PUBLISHED_EVENTS);
            
            var targetlc = this.getLayoutControl(targetId);
            var targetWidgetWindow = widgetModel.getWidgetWindow(targetlc).start();
            
            var targetEventProvider = widgetModel.getHierarchicalEventProvider(targetWidgetWindow).start();
            //var targetEventObject = targetEventProvider.getEvent(targetEvent);
            var targetEventObject = com.ibm.mm.builder.utils.wireUtil.getEventByNameAndType(
					targetEventProvider, targetEvent, com.ibm.mashups.enabler.widget.Constants.FILTER_HANDLED_EVENTS);
            
            var ctx = {};
            ctx.sourceWidgetId = sourceWidgetWindow;
            ctx.sourcePageId = currentPage;
            ctx.sourceEventId = sourceEventObject;
            ctx.targetWidgetId = targetWidgetWindow;
            ctx.targetPageId = currentPage;
            ctx.targetEventId = targetEventObject;
            
            
            // create the wire
            var wireModel = this.getWireModel();
            
            var wire = wireModel.create(ctx);
            
            // insert the wire
            if (wire) {
                wireModel.insert(wire, null);
            }
			
			if (needUpdate) {
                    this.updateEventsMap(sourceId, sourceEvent, targetId, targetEvent, true);
            }
            com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
            
        },
        
        
        removeWire: function(sourceId, sourceEvent, targetId, targetEvent, needUpdate){
            // Remove Wire from WireModel 
            var wireModel = this.getWireModel();
            var widgetModel = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
            var sourcelc = this.getLayoutControl(sourceId);
            var sourceWidgetWindow = widgetModel.getWidgetWindow(sourcelc).start();
            
            var targetlc = this.getLayoutControl(targetId);
            var targetWidgetWindow = widgetModel.getWidgetWindow(targetlc).start();
            
            var targetEventProvider = widgetModel.getHierarchicalEventProvider(targetWidgetWindow).start();
            var sourceEventProvider = widgetModel.getHierarchicalEventProvider(sourceWidgetWindow).start();
            //var targetEventObj = targetEventProvider.getEvent(targetEvent);
            //var sourceEventObj = sourceEventProvider.getEvent(sourceEvent);
            var targetEventObj = com.ibm.mm.builder.utils.wireUtil.getEventByNameAndType(
					targetEventProvider, targetEvent, com.ibm.mashups.enabler.widget.Constants.FILTER_HANDLED_EVENTS);
            var sourceEventObj = com.ibm.mm.builder.utils.wireUtil.getEventByNameAndType(
					sourceEventProvider, sourceEvent, com.ibm.mashups.enabler.widget.Constants.FILTER_PUBLISHED_EVENTS);
			
            // Find the wire
            var aWire = null;
            
            var wireIter = wireModel.iterator();
            if (wireIter !== null) {
                wireIter.setCursorPosition(0);
                while (wireIter.hasNext()) {
                    var wireNode = wireIter.next();
                    // Need to see if this wire has the current layoutControl as target
                    if (wireNode.getTargetWidget().getID() == targetWidgetWindow.getID() &&
                    wireNode.getSourceWidget().getID() == sourceWidgetWindow.getID()) {
                        if (wireNode.getTargetEvent().getID() == targetEventObj.getID() &&
                        wireNode.getSourceEvent().getID() == sourceEventObj.getID()) {
                            aWire = wireNode;
                        }
                    }
                    
                }
            }
            
            if (aWire !== null) {
                // Remove the wire
                wireModel.remove(aWire);
            }
			
			if (needUpdate) {
                    this.updateEventsMap(sourceId, sourceEvent, targetId, targetEvent, false);
            }

        },
        
        disconnectEvent: function(id, eventName){
            if (this.currentType == "Send") {
                this.removeWire(this.iwidgetId, this.selectedEvent, id, eventName, true);
            }
            else {
                this.removeWire(id, eventName, this.iwidgetId, this.selectedEvent, true);
            }
            this.updateEventWireCount(id, -1);
        },
        
        connectEvent: function(id, eventName){
            if (this.currentType == "Send") {
                this.addWire(this.iwidgetId, this.selectedEvent, id, eventName, true);
            }
            else {
                this.addWire(id, eventName, this.iwidgetId, this.selectedEvent, true);
            }
            this.updateEventWireCount(id, 1);
        },
        
        /**
         * Update the wire count on the UI
         * @param {string} id: target widget id
         * @param {number} num: wire added(1)/ wire removed (-1)
         */
        updateEventWireCount: function(id, num){
            var eventDivs = dojo.query(".mumEventDivClicked" + this.currentType, this.wirePaneEventsDiv);
            for (var i = 0; i < eventDivs.length; i++) {
                var eventDiv = eventDivs[i];
                if (eventDiv.getAttribute("eventName") == this.selectedEvent) {
                    var countDiv = dojo.query(".mumEventDivCount" + this.currentType, eventDiv)[0];
                    var count;
                    if (countDiv.innerHTML == "" || countDiv.innerHTML === null) {
                        count = 0;
                    }
                    else {
                        count = parseInt(countDiv.innerHTML, 10);
                    }
                    count = count + num;
                    htmlUtil.setClass(countDiv, "mumEventDivCount" + this.currentType);
                    if (count > 0) {
                        countDiv.innerHTML = count;
                        if (count == 1) {
                            dojo.addClass(countDiv, "mumEventDivCountSingleWire" + this.currentType);
                        }
                        else {
                            dojo.addClass(countDiv, "mumEventDivCountMultiWire" + this.currentType);
                        }
                        
                    }
                    else {
                        countDiv.innerHTML = "";
                    }
                    
                    //for a11y
                    this._insertEventA11yHint(this.currentType, eventDiv, count);
                }
            }
            var curWireIcon = dojo.query(".mumCurrentWidgetArrow" + this.currentType, this.wirePaneCurrentWidgetDiv)[0];
            var currentWidgetName = dojo.query(".mumCurrentWidgetName" + this.currentType, this.wirePaneCurrentWidgetDiv)[0];
            if (this.currentType == "Send") {
                this.allPubWires += num;
                if (builderConfig.isBidi) {
                    this.sendIconDiv.innerHTML = "(" + this.allPubWires + ")";
                }
                else {
                    this.sendWireCountDiv.innerHTML = "(" + this.allPubWires + ")";
                }
                //update the UI of the current widget
                if (this.allPubWires === 0) {
                    dojo.addClass(curWireIcon, "mumHiddenElement");
                    htmlUtil.setNodeTitleWithStyle(currentWidgetName.title, currentWidgetName, 375, this.titleFontStyle);
                }
                else 
                    if (this.allPubWires == 1 && num == 1) {
                        dojo.removeClass(curWireIcon, "mumHiddenElement");
                        htmlUtil.setNodeTitleWithStyle(currentWidgetName.title, currentWidgetName, 345, this.titleFontStyle);
                    }
           		dojo.attr(this.wirePaneTitleDivRight, "title", cws.I_WIRING_TITLE_SEND + " " + this.allPubWires);
            }
            else {
                this.allHanWires += num;
                if (builderConfig.isBidi) {
                    this.recIconDiv.innerHTML = "(" + this.allHanWires + ")";
                }
                else {
                    this.receiveWireCountDiv.innerHTML = "(" + this.allHanWires + ")";
                }
                //update the UI of the current widget
                if (this.allHanWires === 0) {
                    dojo.addClass(curWireIcon, "mumHiddenElement");
                    htmlUtil.setNodeTitleWithStyle(currentWidgetName.title, currentWidgetName, 375, this.titleFontStyle);
                }
                else 
                    if (this.allHanWires == 1 && num == 1) {
                        dojo.removeClass(curWireIcon, "mumHiddenElement");
                        htmlUtil.setNodeTitleWithStyle(currentWidgetName.title, currentWidgetName, 345, this.titleFontStyle);
                    }
				dojo.attr(this.wirePaneTitleDivLeft, "title", cws.I_WIRING_TITLE_RECEIVE + " " + this.allHanWires);
            }
            //update the UI of the selected widget
            var widget = this.getWidgetFromMap(id);
            var arrow = dojo.query(".mumWireIndicator" + this.currentType, this.clickedWidgetDiv)[0];
            var widgetname = dojo.query(".mumWireWidgetTitle", this.clickedWidgetDiv)[0];
            
            if (widget.totalWiredEvents > 0) {
                arrow.style.display = "";
                htmlUtil.setNodeTitleWithStyle(widgetname.title, widgetname, 345, this.titleFontStyle);
            }
            else {
                htmlUtil.setNodeTitleWithStyle(widgetname.title, widgetname, 375, this.titleFontStyle);
                arrow.style.display = "none";
            }
        },
		
		        /**
         * Update the wire count on the UI
         * @param {string} id: target widget id
         * @param {number} num: wire added(1)/ wire removed (-1)
         */
        resetEventWireCount: function(){

            if (builderConfig.isBidi) {
                 this.sendIconDiv.innerHTML = "(" + this.allPubWires + ")";
             }
            else {
                this.sendWireCountDiv.innerHTML = "(" + this.allPubWires + ")";
             }

 
             if (builderConfig.isBidi) {
                this.recIconDiv.innerHTML = "(" + this.allHanWires + ")";
            }
            else {
                this.receiveWireCountDiv.innerHTML = "(" + this.allHanWires + ")";
            }

        },
        
        createWidgetEventsDiv: function(id){
            this.wirePaneWidgetEventsDiv.innerHTML = "";
            var widgetsTitleDiv = document.createElement("div");
            if (this.currentType == "Send") {
                htmlUtil.setClass(widgetsTitleDiv, "mumWireWidgetsTitleDivSend");
                htmlUtil.setNodeTitleWithStyle(cws.I_WIRING_WIDGETEVENTS_SEND, widgetsTitleDiv, 425, this.titleFontStyle);
            }
            else if (this.currentType == "Receive") {
                htmlUtil.setClass(widgetsTitleDiv, "mumWireWidgetsTitleDivReceive");
                htmlUtil.setNodeTitleWithStyle(cws.I_WIRING_WIDGETEVENTS_RECEIVE, widgetsTitleDiv, 425, this.titleFontStyle);
            }
			dojo.attr(widgetsTitleDiv, "tabindex", "0");
			
            htmlUtil.setClass(this.wirePaneWidgetEventsDiv, "mumWidgetEventsDiv" + this.currentType);
            var mumWidgetEventsContentDiv = this.createDivWithClass("mumWidgetEventsContentDiv" + this.currentType);
			mumWidgetEventsContentDiv.setAttribute("role", "menu");
			// #17333 add hover class
			dojo.disconnect(this.eventsDivOverHandler);
			dojo.disconnect(this.eventsDivOutHandler);
	        this.eventsDivOverHandler = dojo.connect(mumWidgetEventsContentDiv,'onmouseover',mumWidgetEventsContentDiv,function() {
				dojo.addClass(this, 'hover');
	        },true);
	        this.eventsDivOutHandler = dojo.connect(mumWidgetEventsContentDiv,'onmouseout',mumWidgetEventsContentDiv,function() {
	        	dojo.removeClass(this,'hover');
	        },true);       
			
            for (var i = 0; i < this.widgets.length; i++) {
                var aWidget = this.widgets[i];
                if (aWidget.id == id) {
                
                    var events = aWidget.events;
                    for (var j = 0; j < events.length; j++) {
                        var aEvent = events[j];
                        var eventName = aEvent.name;
                        var aEventDiv = document.createElement("div");
                        aEventDiv.setAttribute("belongId", id);
                        aEventDiv.setAttribute("eventName", eventName);
                        
                        if (aEvent.isMatch) {
                        
                            this.connect(aEventDiv, "onclick", this.onClickConEventDiv);
                            this.connect(aEventDiv, "onmouseover", this.onMouseOverConEventDiv);
                            this.connect(aEventDiv, "onmouseout", this.onMouseOutConEventDiv);
                            
                            var checkMarkDiv = document.createElement("div");
                            dojo.addClass(checkMarkDiv, "checkMarkDiv");
                            dojo.addClass(checkMarkDiv, "mumFloatLeft");
                            
                            if (aEvent.isWired) {
                                checkMarkDiv.innerHTML = "<input type='checkbox' dojoType='Checkbox' checked=true>";
                                aEventDiv.setAttribute("isChecked", "checked");
                                htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDivCheck" + this.currentType);
                            }
                            else {
                                htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDiv");
                                checkMarkDiv.innerHTML = "<input type='checkbox' dojoType='Checkbox'>";
                                aEventDiv.setAttribute("isChecked", "");
                            }
                            
                            var aEventInfoDiv = this.createDivWithClass("mumWidgetPaneEventInfoDiv" + this.currentType);
							aEventInfoDiv.setAttribute("role", "menuitem");
                            dojo.attr(aEventInfoDiv, "tabindex", "0");
							
                            var title = "";
                            var description = "";
                            var oneEvent = null;

                            var layoutControl = this.getLayoutControl(id);
                            
                            oneEvent = null;
                            
                            if (layoutControl) {
                                // get widgetmodel
                                var widgetModel = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
                                
                                // get widgetWindow
                                var widgetWindow = widgetModel.getWidgetWindow(layoutControl).start();
                                var eventProvider = widgetModel.getHierarchicalEventProvider(widgetWindow).start();
                                // Find target event
                                oneEvent = eventProvider.getEvent(eventName);
                            }
                            
							title = oneEvent.getTitle(dojo.locale) || oneEvent.getTitle(ibmConfig["default.locale"]) || oneEvent.getName();
							description = oneEvent.getDescription(dojo.locale) || oneEvent.getName();
                            
                            var eventDivText1 = this.createDivWithClass("mumWidgetPaneEventInfoText" + this.currentType);
                            dojo.addClass(eventDivText1, "mumEventDivText1");
                            var eventDivText3 = this.createDivWithClass("mumWidgetPaneEventInfoText" + this.currentType);
                            dojo.addClass(eventDivText3, "mumEventDivText3");
                            
                            eventDivText1.title = title;
                            eventDivText1.innerHTML = htmlUtil.escapeString(title);
                            
                            this._setupEventTypeDiv(eventDivText3, aEvent.payloadType);
                            
                            var wrapperDiv1 = document.createElement("div");
                            wrapperDiv1.appendChild(eventDivText1);
                            
                            var wrapperDiv3 = document.createElement("div");
                            wrapperDiv3.appendChild(eventDivText3);
                            
                            //A11Y
                            if (aEvent.isWired) {
                                checkMarkDiv.innerHTML = "<input type='checkbox' dojoType='Checkbox' checked=true title='" + aEventInfoDiv.title + "' />";
                                aEventDiv.setAttribute("isChecked", "checked");
                                htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDivCheck" + this.currentType);
                            }
                            else {
                                htmlUtil.setClass(aEventDiv, "mumWidgetPaneEventDiv");
                                checkMarkDiv.innerHTML = "<input type='checkbox' dojoType='Checkbox' title='" + aEventInfoDiv.title + "' />";
                                aEventDiv.setAttribute("isChecked", "");
                            }
                            aEventInfoDiv.appendChild(checkMarkDiv);
                            
                            var storeEventDivInnerHTML = aEventInfoDiv.innerHTML;
                            
                            //construct the event content
                            var eventContent;
                            var eventTitle = null;
                            if (this.currentType == "Send") {
                                // To fix bug 3218 3228
                                eventTitle = dojo.string.substitute(cws.I_WIRING_EVENT_TITLE_RECEIVE, [title, this.getShownType(aEvent.payloadType), description]);
                                aEventInfoDiv.title = eventTitle;
                                //construct the event content
                                eventContent = dojo.string.substitute(cws.I_WIRING_EVENT_CONTENT_RECEIVE, [wrapperDiv1.innerHTML, '<div class="mumWidgetPaneEventInfoTextMid">', '</div>', wrapperDiv3.innerHTML]);
                                
                            }
                            else {
                                // To fix bug 3218 3228
                                eventTitle = dojo.string.substitute(cws.I_WIRING_EVENT_TITLE_SEND, [eventName, this.getShownType(aEvent.payloadType), description]);
                                aEventInfoDiv.title = eventTitle;
                                eventContent = dojo.string.substitute(cws.I_WIRING_EVENT_CONTENT_SEND, [wrapperDiv1.innerHTML, '<div class="mumWidgetPaneEventInfoTextMid">', '</div>', wrapperDiv3.innerHTML]);
                            }
                            aEventInfoDiv.innerHTML = aEventInfoDiv.innerHTML + eventContent;
                            
                            eventDivText1 = dojo.query(".mumEventDivText1", aEventInfoDiv)[0];
                            var div1Width = htmlUtil.getStrWidth(eventDivText1.innerHTML, eventDivText1, this.defaultFontStyle);
                            
                            eventDivText3 = dojo.query(".mumEventDivText3", aEventInfoDiv)[0];
                            var div3Width = htmlUtil.getStrWidth(eventDivText3.innerHTML, eventDivText3, this.defaultFontStyle);
                            
                            var eventDivText2 = dojo.query(".mumWidgetPaneEventInfoTextMid", aEventInfoDiv)[0];
                            var div2Width = htmlUtil.getStrWidth(eventDivText2.innerHTML, eventDivText2, this.italicStyle);
                            eventDivText2.title = eventDivText2.innerHTML;
                            
                            var totalWidth = dojo.isIE ? 380 : 395;
                            
                            if (div1Width + div2Width + div3Width > totalWidth) {
                            
                                var widthLeft = totalWidth - div2Width; //the center text will never be truncated.
                                var widthLeftFor3 = widthLeft - div1Width;
                                var widthLeftFor1 = widthLeft - div3Width;
                                
                                if (widthLeftFor3 > 60) { //try to only truncate one only
                                    div3Width = widthLeftFor3;
                                    htmlUtil.setNodeTitleWithStyle(eventDivText3.innerHTML, eventDivText3, div3Width, this.defaultFontStyle);
                                }
                                else 
                                    if (widthLeftFor1 > 60) {
                                        div1Width = widthLeftFor1;
                                        htmlUtil.setNodeTitleWithStyle(eventDivText1.innerHTML, eventDivText1, div1Width, this.defaultFontStyle);
                                    }
                                    else {
                                        div1Width = widthLeft * 0.6;
                                        div3Width = widthLeft * 0.4;
                                        htmlUtil.setNodeTitleWithStyle(eventDivText1.innerHTML, eventDivText1, div1Width, this.defaultFontStyle);
                                        htmlUtil.setNodeTitleWithStyle(eventDivText3.innerHTML, eventDivText3, div3Width, this.defaultFontStyle);
                                    }
                            }
                            aEventDiv.appendChild(aEventInfoDiv);
                        }
                        mumWidgetEventsContentDiv.appendChild(aEventDiv);
                        
                    }
                    break;
                }
            }
            var mumWidgetEventsBottomDiv = this.createDivWithClass("mumWidgetEventsBottomDiv" + this.currentType);
            
            this.wirePaneWidgetEventsDiv.appendChild(widgetsTitleDiv);
            this.wirePaneWidgetEventsDiv.appendChild(mumWidgetEventsContentDiv);
            this.wirePaneWidgetEventsDiv.appendChild(mumWidgetEventsBottomDiv);
        },
        
        /**
         * This function will be invoked when user click on one event in first area.
         * 1. Init and display the second area
         * 2. Render every other widget based on the info fetched by wireUtil
         * 3. Place the return image button and the tip
         */
        createWidgetsDiv: function(){
            //reset the whole widgets pane
            this.wirePaneWidgetsDiv.innerHTML = "";
            this.wirePaneWidgetEventsDiv.innerHTML = "";
            this.hideElement(this.wirePaneWidgetEventsDiv);
            htmlUtil.setClass(this.wirePaneWidgetsDiv, "mumPaneDiv");
            //Init the tip div
            htmlUtil.setClass(this.grayTip, "mumWireWidgetTip" + this.currentType);
            this.grayTip.innerHTML = cws.I_WIRING_NO_MATCH_WIDGET;
            //Init the title
            var widgetsTitleDiv = document.createElement("div");
            if (this.currentType == "Send") {
                htmlUtil.setClass(widgetsTitleDiv, "mumWireWidgetsTitleDivSend");
                htmlUtil.setNodeTitleWithStyle(cws.I_WIRING_WIDGETS_SEND, widgetsTitleDiv, 425, this.titleFontStyle);
                //            widgetsTitleDiv.innerHTML = this.getProperTitle(cws.I_WIRING_WIDGETS_SEND,40);
            }
            else 
                if (this.currentType == "Receive") {
                    htmlUtil.setClass(widgetsTitleDiv, "mumWireWidgetsTitleDivReceive");
                    htmlUtil.setNodeTitleWithStyle(cws.I_WIRING_WIDGETS_RECEIVE, widgetsTitleDiv, 425, this.titleFontStyle);
                //                widgetsTitleDiv.innerHTML = this.getProperTitle(cws.I_WIRING_WIDGETS_RECEIVE,40);
                }
			dojo.attr(widgetsTitleDiv, "tabindex", "0");
            // The content pane in the middle
            var wirePaneWidgetsContentDiv = this.createDivWithClass("mumWidgetsContentDiv" + this.currentType);
			wirePaneWidgetsContentDiv.setAttribute("role", "menu");
            this.wirePaneEventsDiv.appendChild(wirePaneWidgetsContentDiv);
            
            var matchWidgetCount = 0;
            var preFetchId;
            //Render every other widgets in the widgets pane if they have at least one event can be wired with current widget's event
            for (var i = 0; i < this.widgets.length; i++) {
                var aWidget = this.widgets[i];
                if (aWidget.hasMatchEvent) { // has event can be wired to this widgets, create div
                    matchWidgetCount++;
                    preFetchId = aWidget.id;
                    var aWidgetDiv = document.createElement("div");
                    aWidgetDiv.setAttribute("widgetId", aWidget.id);
                    aWidgetDiv.setAttribute("isClicked", "false");
                    aWidgetDiv.setAttribute("widgetName", aWidget.type);
                    //A11Y
                    aWidgetDiv.setAttribute("title", aWidget.type);
                    aWidgetDiv.setAttribute("tabindex", "0");
					aWidgetDiv.setAttribute("role", "menuitem");
                    dojo.addClass(aWidgetDiv, "mumWireWidget" + this.currentType);
                    
                    //arrow to indicate is currently wired with the widget
                    var wireIndicator = document.createElement("div");
                    this.connect(aWidgetDiv, "onmouseover", this.onMouseOverWidget);
                    this.connect(aWidgetDiv, "onmouseout", this.onMouseOutWidget);
                    this.connect(aWidgetDiv, "onclick", this.onClickWidget);
                    //A11Y
                    //dojo.connect(aWidgetDiv, "onfocus", this, "onMouseOverWidget");
                    //dojo.connect(aWidgetDiv, "onblur", this, "onMouseOutWidget");
                    this.connect(aWidgetDiv, "onkeypress", this.onKeyPressWidget);
                    
                    var widgetUtil = com.ibm.mm.builder.utils.iwidgetUtil;
                    var titleIcon = widgetUtil.getWidgetIconCSA2(aWidget.id);
                    
                    var aWidgetImg = document.createElement("div");
                    aWidgetImg.innerHTML = "<img src='" + titleIcon + "' class='mumWirePaneWidgetIcon' alt=''>";
                    htmlUtil.setClass(aWidgetImg, "mumWireWidgetImg");
                    aWidgetDiv.appendChild(aWidgetImg);
                    
                    var aWidgetTitle = document.createElement("div");
                    htmlUtil.setClass(aWidgetTitle, "mumWireWidgetTitle");
                    aWidgetDiv.appendChild(aWidgetTitle);
                    
                    wireIndicator.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/" + (this.currentType === "Send" ? "receive" : "send") + (builderConfig.isBidi ? "_arrow_rtl.png' alt=''>" : "_arrow.png' alt=''>");
                    htmlUtil.setClass(wireIndicator, "mumWireIndicator" + this.currentType);
                    
                    //deal with the inidcator
                    wireIndicator.style.display = "none";
                    //                wireIndicator.style.visibility = "hidden";
                    if (aWidget.totalWiredEvents > 0) {
                        dojo.addClass(aWidgetDiv, "mumHasWiredEvent");
                        wireIndicator.style.display = "";
                        htmlUtil.setNodeTitleWithStyle(aWidget.type, aWidgetTitle, 345, this.titleFontStyle);
                        //                    wireIndicator.style.visibility = "visible";
                    }
                    else {
                        htmlUtil.setNodeTitleWithStyle(aWidget.type, aWidgetTitle, 375, this.titleFontStyle);
                    }
                    
                    var widgetDivReturnImg = document.createElement("div");
					widgetDivReturnImg.setAttribute("role", "button");
                    htmlUtil.setClass(widgetDivReturnImg, "mumWidgetDivReturnImg" + this.currentType);
                    this.connect(widgetDivReturnImg, "onclick", this.onClickWidgetReturnImg);
                    
                    //A11Y-todo
                    this.connect(widgetDivReturnImg, "onkeypress", this.onKeyPressWidgetReturnImg);
                    dojo.attr(widgetDivReturnImg, "title", cws["I_WIRING_OTHER_WIDGETS_" + this.currentType.toUpperCase()]);
                    widgetDivReturnImg.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/" + (this.currentType == "Send" ? "blue" : "green") + "_expand.png' alt=''>";
                    
                    
                    widgetDivReturnImg.style.visibility = "hidden";
                    widgetDivReturnImg.setAttribute("tabindex", "0");
                    aWidgetDiv.appendChild(widgetDivReturnImg);
                    aWidgetDiv.appendChild(wireIndicator);
                    wirePaneWidgetsContentDiv.appendChild(aWidgetDiv);
                }
            }
            this.wirePaneWidgetEventsDiv.innerHTML = "";
            //this.wirePaneWidgetsDiv.appendChild(this.wirePaneWidgetEventsDiv);
            
            //The bottom pane, only contains one round corner image
            var wirePaneWidgetsBottomDiv = this.createDivWithClass("mumWidgetsBottomDiv" + this.currentType);
            
            this.wirePaneWidgetsDiv.appendChild(widgetsTitleDiv);
            //If there is no widget which contains event can be wired with this widget's event, show the tip
            if (matchWidgetCount === 0) {
                wirePaneWidgetsContentDiv.appendChild(this.grayTip);
            }
            
            this.wirePaneWidgetsDiv.appendChild(wirePaneWidgetsContentDiv);
            this.wirePaneWidgetsDiv.appendChild(wirePaneWidgetsBottomDiv);
            
            this.wirePaneWidgetsDiv.style.display = "";
            this.LOGGER.exiting("WirePane_createWidgetsDiv");
            return matchWidgetCount;
        },
        
        /**
         * This function will be invoked every time a new wire pane is poped up.
         * Fetch all related events' and wire data for current widget. Wrap them into Object "eventsMap".
         */
        initAllData: function(){
        	if ( typeof this.matchingType === "undefined" ) {
        		var config = this.iContext.getiWidgetAttributes();
        		var mType = config.getItemValue( "matchingType" );
        		if ( !mType ) {
        			mType = config.getItemValue("defaultMatchingType");
        		}
        		this.matchingType = parseInt( mType );
        	}
        	
            this.eventsMap = {};
            var hEvents = null;
            var pEvents = null;
            var hanEvent = null;
            var pubEvent = null;

            var currentPID = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
            this.currentPageId = currentPID;
            
            
            var layoutControl = this.getLayoutControl(this.iwidgetId);
            
            //			var hEvents = widgetWrapper.getWidgetHandledEvents();
            hEvents = com.ibm.mm.builder.utils.wireUtil.getWidgetHandledEventsCSA2(layoutControl);
            //			var pEvents = widgetWrapper.getWidgetPublishedEvents();
            pEvents = com.ibm.mm.builder.utils.wireUtil.getWidgetPublishedEventsCSA2(layoutControl);
            
            /* *** */
            this.allHanWires = 0;
            this.allPubWires = 0;
            var lcArray = null;
            // LayoutModel has the controls
            if (hEvents) {
                for (var n = 0; n < hEvents.length; n++) {
                    hanEvent = hEvents[n];
                    
                    lcArray = com.ibm.mm.builder.utils.wireUtil.getAllMatchPubEventsCSA2(layoutControl, hanEvent.getName(), currentPID, this.matchingType);
                    for (var i = 0; i < lcArray.length; i++) {
                        this.allHanWires = this.allHanWires + lcArray[i].wiredEvents.length;
                    }
                    this.eventsMap["Receive-" + hanEvent.getName()] = lcArray;
                }
            }
            
            if (pEvents) {
                for (var m = 0; m < pEvents.length; m++) {
                    pubEvent = pEvents[m];
                    
                    lcArray = com.ibm.mm.builder.utils.wireUtil.getAllMatchHandleEventsCSA2(layoutControl, pubEvent.getName(), currentPID, this.matchingType);
                    for (var j = 0; j < lcArray.length; j++) {
                        this.allPubWires = this.allPubWires + lcArray[j].wiredEvents.length;
                    }
                    this.eventsMap["Send-" + pubEvent.getName()] = lcArray;
                }
            }
        },
        
        /**
         * Generate the receive Events pane of current widget
         */
        createReceiveEventsDiv: function(){
        
            this.createCurrentWidgetDiv();
            
            this.wirePaneEventsDiv.innerHTML = "";
            htmlUtil.setClass(this.wirePaneEventsDiv, "mumEventsDiv");
            htmlUtil.setClass(this.grayTip, "mumWireWidgetTipSend");
            this.grayTip.innerHTML = cws.I_WIRING_NO_RECEIVE_EVENTS;
			dojo.attr(this.grayTip, "tabindex", "0");
			dojo.attr(this.grayTip, "title", cws.I_WIRING_NO_RECEIVE_EVENTS);
            
            var eventsTitleDiv = document.createElement("div");
			dojo.attr(eventsTitleDiv, "tabindex", "0");
            htmlUtil.setClass(eventsTitleDiv, "mumEventsTitleDivReceive");
            
            htmlUtil.setNodeTitleWithStyle(cws.I_WIRING_EVENTS_RECEIVE, eventsTitleDiv, 425, this.titleFontStyle);
            
            this.wirePaneEventsDiv.appendChild(eventsTitleDiv);
            
            var hEvents = [];
            
            var layoutControl = this.getLayoutControl(this.iwidgetId);
            hEvents = com.ibm.mm.builder.utils.wireUtil.getWidgetHandledEventsCSA2(layoutControl);
            
            var wirePaneEventsContentDiv = this.createDivWithClass("mumEventsContentDiv" + this.currentType);
			wirePaneEventsContentDiv.setAttribute("role", "menu");
            this.wirePaneEventsDiv.appendChild(wirePaneEventsContentDiv);
            
            var hasEventToShow = false;
            
            for (var n = 0; n < hEvents.length; n++) {
                var hanEvent = hEvents[n];
                
                var eventDiv = document.createElement("div");
                htmlUtil.setClass(eventDiv, "mumEventDiv");
                
                wirePaneEventsContentDiv.appendChild(eventDiv);
                hasEventToShow = true;
                
                var title = "";
                var description = "";
                var shownType = "";
                var shownEventName = "";

				title = hanEvent.getTitle(dojo.locale) || hanEvent.getTitle(ibmConfig["default.locale"]) || hanEvent.getName();
                description = hanEvent.getDescription(dojo.locale) || hanEvent.getName();
                shownType = hanEvent.getPayloadType();
                shownEventName = hanEvent.getName();
                
                // To fix bug 3218 3228
                var eventTitle = dojo.string.substitute(cws.I_WIRING_EVENT_TITLE_RECEIVE, [title, this.getShownType(shownType), description]);
                eventDiv.title = eventTitle;
                
                var widgetsArray = this.eventsMap["Receive-" + shownEventName];
                var wiredEventCount = 0;
                for (var i = 0; i < widgetsArray.length; i++) {
                    wiredEventCount = wiredEventCount + widgetsArray[i].totalWiredEvents;
                }
                
                var eventDivCount = document.createElement("div");
                htmlUtil.setClass(eventDivCount, "mumEventDivCount" + this.currentType);
                
                //if this event already has wired with other events
                if (wiredEventCount > 0) {
                    eventDivCount.innerHTML = wiredEventCount;
                    dojo.addClass(eventDiv, "mumEventDivWired");
                    if (wiredEventCount == 1) {
                        dojo.addClass(eventDivCount, "mumEventDivCountSingleWire" + this.currentType);
                    }
                    else {
                        dojo.addClass(eventDivCount, "mumEventDivCountMultiWire" + this.currentType);
                    }
                }
                
                var eventDivReturnImg = document.createElement("div");
				eventDivReturnImg.setAttribute("role", "button");
                eventDivReturnImg.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/blue_expand.png' alt=''>";
                
                htmlUtil.setClass(eventDivReturnImg, "mumEventDivReturnImg" + this.currentType);
                this.connect(eventDivReturnImg, "onclick", this.onClickEventReturnImg);
                eventDivReturnImg.style.visibility = "hidden";
                //A11Y
                this.connect(eventDivReturnImg, "onkeypress", this.onKeyPressEventReturnImg);
                eventDivReturnImg.setAttribute("tabindex", "0");
                dojo.attr(eventDivReturnImg, "title", cws["I_WIRING_OTHER_EVENTS_" + this.currentType.toUpperCase()]);
                
                var eventDivVline = document.createElement("div");
                htmlUtil.setClass(eventDivVline, "grayBar");
                eventDivVline.style.visibility = "hidden";
                
                eventDiv.setAttribute("eventName", shownEventName);
                eventDiv.setAttribute("eventTitle", title);
                eventDiv.setAttribute("isClicked", "false");
				eventDiv.setAttribute("role", "menuitem");
				
                //A11Y
                eventDiv.setAttribute("tabindex", "0");
                eventDiv.appendChild(eventDivCount);
                
                var eventDivText1 = this.createDivWithClass("mumEventDivTextReceive");
                dojo.addClass(eventDivText1, "mumEventDivText1");
                eventDivText1.title = title;
                eventDivText1.innerHTML = htmlUtil.escapeString(title);
                
                var eventDivText3 = this.createDivWithClass("mumEventDivTextReceive");
                dojo.addClass(eventDivText3, "mumEventDivText3");
                
				this._setupEventTypeDiv(eventDivText3, shownType);
                
                var wrapperDiv1 = document.createElement("div");
                wrapperDiv1.appendChild(eventDivText1);
                
                var wrapperDiv3 = document.createElement("div");
                wrapperDiv3.appendChild(eventDivText3);
                
                var storeEventDivInnerHTML = eventDiv.innerHTML;
                
                //construct the event content
                var eventContent = dojo.string.substitute(cws.I_WIRING_EVENT_CONTENT_RECEIVE, [wrapperDiv1.innerHTML, '<div class="mumEventDivText2">', '</div>', wrapperDiv3.innerHTML]);
                eventDiv.innerHTML = eventDiv.innerHTML + eventContent;
                
                eventDivText1 = dojo.query(".mumEventDivText1", eventDiv)[0];
                var div1Width = htmlUtil.getStrWidth(eventDivText1.innerHTML, eventDivText1, this.defaultFontStyle);
                
                eventDivText3 = dojo.query(".mumEventDivText3", eventDiv)[0];
                var div3Width = htmlUtil.getStrWidth(eventDivText3.innerHTML, eventDivText3, this.defaultFontStyle);
                
                var eventDivText2 = dojo.query(".mumEventDivText2", eventDiv)[0];
                var div2Width = htmlUtil.getStrWidth(eventDivText2.innerHTML, eventDivText2, this.italicStyle);
                eventDivText2.title = eventDivText2.innerHTML;
                
                var totalWidth = dojo.isIE ? 370 : 380;
                
                if (div1Width + div2Width + div3Width > totalWidth) {
                
                    var widthLeft = totalWidth - div2Width; //the center text will never be truncated.
                    var widthLeftFor3 = widthLeft - div1Width;
                    var widthLeftFor1 = widthLeft - div3Width;
                    
                    if (widthLeftFor3 > 60) { //try to only truncate one only
                        div3Width = widthLeftFor3;
                        htmlUtil.setNodeTitleWithStyle(eventDivText3.innerHTML, eventDivText3, div3Width, this.defaultFontStyle);
                    }
                    else 
                        if (widthLeftFor1 > 60) {
                            div1Width = widthLeftFor1;
                            htmlUtil.setNodeTitleWithStyle(eventDivText1.innerHTML, eventDivText1, div1Width, this.defaultFontStyle);
                        }
                        else {
                            div1Width = widthLeft * 0.6;
                            div3Width = widthLeft * 0.4;
                            htmlUtil.setNodeTitleWithStyle(eventDivText1.innerHTML, eventDivText1, div1Width, this.defaultFontStyle);
                            htmlUtil.setNodeTitleWithStyle(eventDivText3.innerHTML, eventDivText3, div3Width, this.defaultFontStyle);
                        }
                }
                eventDiv.appendChild(eventDivReturnImg);
                this.connect(eventDiv, "onclick", this.onClickEvent);
                //A11Y
                this.connect(eventDiv, "onkeypress", this.onKeyPressEvent);
                this._insertEventA11yHint("Receive", eventDiv, wiredEventCount);
            }
            
            if (!hasEventToShow) {
                wirePaneEventsContentDiv.appendChild(this.grayTip);
            }
            
            var wirePaneEventsBottomDiv = this.createDivWithClass("mumEventsBottomDiv" + this.currentType);
            this.wirePaneEventsDiv.appendChild(wirePaneEventsBottomDiv);
        },
        
        /**
         * Generate the send Events pane of current widget
         */
        createSendEventsDiv: function(){
        
            this.createCurrentWidgetDiv();
            
            //reset the whole wire pane
            this.wirePaneEventsDiv.innerHTML = "";
            htmlUtil.setClass(this.wirePaneEventsDiv, "mumEventsDiv");
            htmlUtil.setClass(this.grayTip, "mumWireWidgetTipReceive");
            this.grayTip.innerHTML = cws.I_WIRING_NO_SEND_EVENTS;
			dojo.attr(this.grayTip, "tabindex", "0");
			dojo.attr(this.grayTip, "title", cws.I_WIRING_NO_SEND_EVENTS);
            //Init the title
            var eventsTitleDiv = document.createElement("div");
            htmlUtil.setClass(eventsTitleDiv, "mumEventsTitleDivSend");
            htmlUtil.setNodeTitleWithStyle(cws.I_WIRING_EVENTS_SEND, eventsTitleDiv, 425, this.titleFontStyle);
            dojo.attr(eventsTitleDiv, "tabindex", "0");
			
            //        eventsTitleDiv.innerHTML = this.getProperTitle(cws.I_WIRING_EVENTS_SEND,40);
            
            this.wirePaneEventsDiv.appendChild(eventsTitleDiv);
            //Fetch the send events' info
            
            var pEvents = [];
            var layoutControl = this.getLayoutControl(this.iwidgetId);
            pEvents = com.ibm.mm.builder.utils.wireUtil.getWidgetPublishedEventsCSA2(layoutControl);
            
            var wirePaneEventsContentDiv = this.createDivWithClass("mumEventsContentDiv" + this.currentType);
			wirePaneEventsContentDiv.setAttribute("role", "menu");
            this.wirePaneEventsDiv.appendChild(wirePaneEventsContentDiv);
            
            var hasEventToShow = false;
            
            //Generate the event div recuisively
            for (var n = 0; n < pEvents.length; n++) {
                var pubEvent = pEvents[n];
                
                var eventDiv = document.createElement("div");
				eventDiv.setAttribute("role", "menuitem");
                htmlUtil.setClass(eventDiv, "mumEventDiv");
                
                wirePaneEventsContentDiv.appendChild(eventDiv);
                hasEventToShow = true;
                
                var title = "";
                var description = "";
                var shownType = "";
                var shownEventName = "";

				title = pubEvent.getTitle(dojo.locale) || pubEvent.getTitle(ibmConfig["default.locale"]) || pubEvent.getName();
                description = pubEvent.getDescription(dojo.locale) || pubEvent.getName();
                shownType = pubEvent.getPayloadType();
                shownEventName = pubEvent.getName();
                
                // To fix bug 3218 3228
                var eventTitle = dojo.string.substitute(cws.I_WIRING_EVENT_TITLE_SEND, [title, this.getShownType(shownType), description]);
                eventDiv.title = eventTitle;
                var widgetsArray = this.eventsMap["Send-" + shownEventName];
                var wiredEventCount = 0;
                for (var i = 0; i < widgetsArray.length; i++) {
                    wiredEventCount = wiredEventCount + widgetsArray[i].totalWiredEvents;
                }
                
                var eventDivCount = document.createElement("div");
                htmlUtil.setClass(eventDivCount, "mumEventDivCount" + this.currentType);
                
                if (wiredEventCount > 0) {
                    eventDivCount.innerHTML = wiredEventCount;
                    dojo.addClass(eventDiv, "mumEventDivWired");
                    if (wiredEventCount == 1) {
                        dojo.addClass(eventDivCount, "mumEventDivCountSingleWire" + this.currentType);
                    }
                    else {
                        dojo.addClass(eventDivCount, "mumEventDivCountMultiWire" + this.currentType);
                    }
                }
                
                var eventDivReturnImg = document.createElement("div");
                
                //defect 7491
                eventDivReturnImg.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/green_expand.png' alt=''>";
                
                htmlUtil.setClass(eventDivReturnImg, "mumEventDivReturnImg" + this.currentType);
                this.connect(eventDivReturnImg, "onclick", this.onClickEventReturnImg);
                eventDivReturnImg.style.visibility = "hidden";
                //A11Y
                this.connect(eventDivReturnImg, "onkeypress", this.onKeyPressEventReturnImg);
                eventDivReturnImg.setAttribute("tabindex", "0");
                dojo.attr(eventDivReturnImg, "title", cws["I_WIRING_OTHER_EVENTS_" + this.currentType.toUpperCase()]);
                
                eventDiv.setAttribute("eventName", shownEventName);
                eventDiv.setAttribute("eventTitle", title);
                eventDiv.setAttribute("isClicked", "false");
                //A11Y
                eventDiv.setAttribute("tabindex", "0");
                
                eventDiv.appendChild(eventDivCount);
                
                //init the event name and payload type div
                var eventDivText1 = this.createDivWithClass("mumEventDivTextSend");
                dojo.addClass(eventDivText1, "mumEventDivText1");
                eventDivText1.title = title;
                eventDivText1.innerHTML = htmlUtil.escapeString(title);
                
                
                var eventDivText3 = this.createDivWithClass("mumEventDivTextSend");
                dojo.addClass(eventDivText3, "mumEventDivText3");
				
				this._setupEventTypeDiv(eventDivText3, shownType);
				
                var wrapperDiv1 = document.createElement("div");
                wrapperDiv1.appendChild(eventDivText1);
                
                var wrapperDiv3 = document.createElement("div");
                wrapperDiv3.appendChild(eventDivText3);
                
                var storeEventDivInnerHTML = eventDiv.innerHTML;
                
                //construct the event content
                var eventContent = dojo.string.substitute(cws.I_WIRING_EVENT_CONTENT_SEND, [wrapperDiv1.innerHTML, '<div class="mumEventDivText2">', '</div>', wrapperDiv3.innerHTML]);
                eventDiv.innerHTML = eventDiv.innerHTML + eventContent;
                
                eventDivText1 = dojo.query(".mumEventDivText1", eventDiv)[0];
                var div1Width = htmlUtil.getStrWidth(eventDivText1.innerHTML, eventDivText1, this.defaultFontStyle);
                
                eventDivText3 = dojo.query(".mumEventDivText3", eventDiv)[0];
                var div3Width = htmlUtil.getStrWidth(eventDivText3.innerHTML, eventDivText3, this.defaultFontStyle);
                
                var eventDivText2 = dojo.query(".mumEventDivText2", eventDiv)[0];
                var div2Width = htmlUtil.getStrWidth(eventDivText2.innerHTML, eventDivText2, this.italicStyle);
                eventDivText2.title = eventDivText2.innerHTML;
                
                var totalWidth = dojo.isIE ? 370 : 380;
                
                if (div1Width + div2Width + div3Width > totalWidth) {
                
                    var widthLeft = totalWidth - div2Width; //the center text will never be truncated.
                    var widthLeftFor3 = widthLeft - div1Width;
                    var widthLeftFor1 = widthLeft - div3Width;
                    
                    if (widthLeftFor3 > 60) { //try to only truncate one only
                        div3Width = widthLeftFor3;
                        htmlUtil.setNodeTitleWithStyle(eventDivText3.innerHTML, eventDivText3, div3Width, this.defaultFontStyle);
                    }
                    else 
                        if (widthLeftFor1 > 60) {
                            div1Width = widthLeftFor1;
                            htmlUtil.setNodeTitleWithStyle(eventDivText1.innerHTML, eventDivText1, div1Width, this.defaultFontStyle);
                        }
                        else {
                            div1Width = widthLeft * 0.6;
                            div3Width = widthLeft * 0.4;
                            htmlUtil.setNodeTitleWithStyle(eventDivText1.innerHTML, eventDivText1, div1Width, this.defaultFontStyle);
                            htmlUtil.setNodeTitleWithStyle(eventDivText3.innerHTML, eventDivText3, div3Width, this.defaultFontStyle);
                        }
                }
                
                eventDiv.appendChild(eventDivReturnImg);
                
                this.connect(eventDiv, "onclick", this.onClickEvent);
                //A11Y
                this.connect(eventDiv, "onkeypress", this.onKeyPressEvent);
                this._insertEventA11yHint("Send", eventDiv, wiredEventCount);
            }
            if (!hasEventToShow) {
                wirePaneEventsContentDiv.appendChild(this.grayTip);
            }
            var wirePaneEventsBottomDiv = this.createDivWithClass("mumEventsBottomDiv" + this.currentType);
            this.wirePaneEventsDiv.appendChild(wirePaneEventsBottomDiv);
        },
        
        createCurrentWidgetDiv: function(){
        
            this.wirePaneCurrentWidgetDiv.innerHTML = "";
            var currentWidgetTitleDiv;
            htmlUtil.setClass(this.wirePaneCurrentWidgetDiv, "mumPaneDiv");
            
            var currentWidgetArrow = this.createDivWithClass("mumCurrentWidgetArrow" + this.currentType);
            
            // defect 7491
            currentWidgetArrow.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/" + this.currentType.toLowerCase() + (builderConfig.isBidi ? "_arrow_rtl.png' alt=''>" : "_arrow.png' alt=''>");
            
            // the mid centent of the current widget div
            var currentWidgetContentDiv = this.createDivWithClass("mumCurrentWidgetContentDiv" + this.currentType);
			currentWidgetContentDiv.setAttribute("role", "menu");
            var currentWidgetDiv = this.createDivWithClass("mumCurrentWidgetDiv" + this.currentType);
			currentWidgetDiv.setAttribute("role", "menuitem");
			
            // #17333 add hover class
			dojo.disconnect(this.widgetDivOverHandler);
			dojo.disconnect(this.widgetDivOutHandler);
	        this.widgetDivOverHandler = dojo.connect(currentWidgetDiv,'onmouseover',currentWidgetDiv,function() {
				dojo.addClass(this, 'hover');
	        },true);
	        this.widgetDivOutHandler = dojo.connect(currentWidgetDiv,'onmouseout',currentWidgetDiv,function() {
	        	dojo.removeClass(this,'hover');
	        },true); 
			
            //init the currentWidget div's content
            var currentWidgetIcon = this.createDivWithClass("mumCurrentWidgetIcon");
            currentWidgetIcon.innerHTML = "<img src='" + this.widgetObj.widgetIconSrc + "' class='mumWirePaneWidgetIcon' alt=''>";
            var currentWidgetName = this.createDivWithClass("mumCurrentWidgetName" + this.currentType);
			dojo.attr(currentWidgetName, "tabindex", "0");
            if (this.currentType == "Send") {
                currentWidgetTitleDiv = this.createDivWithClass("mumGreenTitleDiv");
				dojo.attr(currentWidgetTitleDiv, "tabindex", "0");
                htmlUtil.setNodeTitleWithStyle(cws.I_WIRING_CWIDGET_SEND, currentWidgetTitleDiv, 425, this.titleFontStyle);
                dojo.attr(currentWidgetTitleDiv, "title", cws.I_WIRING_CWIDGET_SEND);
                if (this.allPubWires === 0) {
                    dojo.addClass(currentWidgetArrow, "mumHiddenElement");
                    htmlUtil.setNodeTitleWithStyle(this.widgetObj.widgetname, currentWidgetName, 375, this.titleFontStyle);
                }
                else {
                    htmlUtil.setNodeTitleWithStyle(this.widgetObj.widgetname, currentWidgetName, 345, this.titleFontStyle);
                }
            }
            else {
                currentWidgetTitleDiv = this.createDivWithClass("mumBlueTitleDiv");
				dojo.attr(currentWidgetTitleDiv, "tabindex", "0");
                htmlUtil.setNodeTitleWithStyle(cws.I_WIRING_CWIDGET_RECEIVE, currentWidgetTitleDiv, 425, this.titleFontStyle);
                dojo.attr(currentWidgetTitleDiv, "title", cws.I_WIRING_CWIDGET_RECEIVE);
                if (this.allHanWires === 0) {
                    dojo.addClass(currentWidgetArrow, "mumHiddenElement");
                    htmlUtil.setNodeTitleWithStyle(this.widgetObj.widgetname, currentWidgetName, 375, this.titleFontStyle);
                }
                else {
                    htmlUtil.setNodeTitleWithStyle(this.widgetObj.widgetname, currentWidgetName, 345, this.titleFontStyle);
                }
            }
            
            currentWidgetDiv.appendChild(currentWidgetIcon);
            currentWidgetDiv.appendChild(currentWidgetName);
            currentWidgetDiv.appendChild(currentWidgetArrow);
            
            var currentWidgetBottomDiv = this.createDivWithClass("mumCurrentWidgetBottom" + this.currentType);
            currentWidgetContentDiv.appendChild(currentWidgetDiv);
            this.wirePaneCurrentWidgetDiv.appendChild(currentWidgetTitleDiv);
            this.wirePaneCurrentWidgetDiv.appendChild(currentWidgetContentDiv);
            this.wirePaneCurrentWidgetDiv.appendChild(currentWidgetBottomDiv);
        },
        
        createTitleDiv: function(){
            var span = document.createElement("span");
            span.innerHTML = cws.I_WIRING_TITLE_RECEIVE;
            this.receiveTextDiv.appendChild(span);
            if (builderConfig.isBidi) {
                this.recIconDiv.innerHTML = "(" + this.allHanWires + ")";
                //defect 7491
                this.receiveWireCountDiv.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/receive_arrow_deselect_rtl.png' alt=''>";
            }
            else {
                this.receiveWireCountDiv.innerHTML = "(" + this.allHanWires + ")";
                //defect 7491
                this.recIconDiv.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/receive_arrow_deselect.png' alt=''>";
            }
            var spanSend = document.createElement("span");
            spanSend.innerHTML = cws.I_WIRING_TITLE_SEND;
            this.sendTextDiv.appendChild(spanSend);
            if (builderConfig.isBidi) {
                this.sendIconDiv.innerHTML = "(" + this.allPubWires + ")";
                //defect 7491
                this.sendWireCountDiv.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/send_arrow_rtl.png' alt='' role='presentation'>";
            }
            else {
                this.sendWireCountDiv.innerHTML = "(" + this.allPubWires + ")";
                //defect 7491
                this.sendIconDiv.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/send_arrow.png' alt='' role='presentation'>";
            }
            
            this.connect(this.wirePaneTitleDivLeft, "onclick", this.onClickTitlePaneLeft);
			this.connect(this.wirePaneTitleDivLeft, "onkeypress", this.onKeyPresTitlePane);
            this.connect(this.wirePaneTitleDivRight, "onclick", this.onClickTitlePaneRight);
			this.connect(this.wirePaneTitleDivRight, "onkeypress", this.onKeyPresTitlePane);
            //Set the correct Div Styles on creation
            this.adjustDivsStyle();
        },
        
        adjustTitleDiv: function(){
            htmlUtil.setClass(this.wirePaneTitleDivLeft, "mumWirePaneTitleDivReceiveTab" + this.currentType);
            htmlUtil.setClass(this.leftDivOfReceiveTab, "mumLeftDivOfReceiveTab" + this.currentType);
            htmlUtil.setClass(this.midDivOfReceiveTab, "mumMidDivOfReceiveTab" + this.currentType);
            htmlUtil.setClass(this.rightDivOfReceiveTab, "mumRightDivOfReceiveTab" + this.currentType);
            if (builderConfig.isBidi) {
                htmlUtil.setClass(this.receiveWireCountDiv, "mumReceiveIconDiv" + this.currentType);
                htmlUtil.setClass(this.recIconDiv, "mumReceiveWireCountDiv");
                this.receiveWireCountDiv.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/receive_arrow" + (this.currentType === "Send" ? "_deselect" : "") + "_rtl.png' alt=''>";
            }
            else {
                htmlUtil.setClass(this.recIconDiv, "mumReceiveIconDivReceive");
                this.recIconDiv.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/receive_arrow" + (this.currentType === "Send" ? "_deselect" : "") + ".png' alt=''>";
            }
            
            
            htmlUtil.setClass(this.wirePaneTitleDivRight, "mumWirePaneTitleDivSendTab" + this.currentType);
            htmlUtil.setClass(this.leftDivOfSendTab, "mumLeftDivOfSendTab" + this.currentType);
            htmlUtil.setClass(this.midDivOfSendTab, "mumMidDivOfSendTab" + this.currentType);
            htmlUtil.setClass(this.rightDivOfSendTab, "mumRightDivOfSendTab" + this.currentType);
            if (builderConfig.isBidi) {
                htmlUtil.setClass(this.sendWireCountDiv, "mumSendIconDiv" + this.currentType);
                htmlUtil.setClass(this.sendIconDiv, "mumSendWireCountDiv");
                this.sendWireCountDiv.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/send_arrow" + (this.currentType === "Send" ? "" : "_deselect") + "_rtl.png' alt=''>";
            }
            else {
                htmlUtil.setClass(this.sendIconDiv, "mumSendIconDivSend");
                this.sendIconDiv.innerHTML = "<img src='" + builderConfig.builderPath + "/images/wiringscreen/send_arrow" + (this.currentType === "Send" ? "" : "_deselect") + ".png' alt=''>";
            }
        },
        
        /**
         * This function will be invoke when user click on the "wire" icon
         * 1. Gather all widget info
         * 2. Init the wire pane
         * 3. Init the Customized Dialog to show the wire pane
         */
        display: function(iwidgetId){
        	// actually it is layoutControlId, not widgetId
            this.iwidgetId = iwidgetId;
            // Default: View send events
            this.currentType = "Send";
            this.eventsMap = {};
            //Clean up the current wirepane
            if (this.wirePane) {
                this.wirePaneDiv.innerHTML = "";
                // reconstruct the UI.
                this.buildRendering();
            }
            this.widgetObj = {};
            
            //temporary - find first layoutcontrol in container
            var currentPID = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
            this.currentPageId = currentPID;
            this.widgetObj.widgetIconSrc = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetIconCSA2(this.iwidgetId);
            this.widgetObj.widgetname = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetTitleCSA2(this.iwidgetId);
            
            //Init work
            this.initAllData();
            this.initWirePane();
            this.createSendEventsDiv();
            
            var contentDiv = dojo.query("." + com.ibm.mm.builder.constant.iwWidgetContent, this.iContext.getRootElement())[0];
            if (contentDiv) {
                contentDiv.appendChild(this.wirePaneDiv);
            }
            else {
                this.iContext.getRootElement().appendChild(this.wirePaneDiv);
            }
            this.displayPrompter("1");
        },
        
        setContext: function(context){
            this.iContext = context;
        },
        
        _insertA11yHint: function(domNode, hint){
            this._removeA11yHint(domNode);
			dojo.create("span", {
				innerHTML: hint,
				'class': "access"
			}, domNode, "first");
        },
        
        _removeA11yHint: function(domNode){
			dojo.query(".access", domNode).forEach(dojo.destroy);
        },
        
        _insertEventA11yHint: function(currentType, eventDiv, count){
            if (count > 0) {
                this._insertA11yHint(eventDiv, "This event" + (currentType == "Send" ? " sends data to " : " receives data from ") + count + " event" + (count == 1 ? "" : "s"));
            }
            else {
                this._removeA11yHint(eventDiv);
            }
        },
        /**
         * Opens the wiring settings dialog widget.
         */
        openWiringSettings: function(){
            if (!this.wiringSettingsDialog) {
                this.wiringSettingsDialog = new com.ibm.mm.builder.iwidget.wiringscreen.WiringSettingsDialog();
                this.wiringSettingsDialog.setOuterContext( this.iContext );
                //Register as a listener to get notified when the settings dialog is dismissed using the Done button.
                dojo.connect(this.wiringSettingsDialog, "onSettingsSaved", this, this.settingsSaved);
            }
            
            this.wiringSettingsDialog.setMatchingType( this.matchingType );
            this.wiringSettingsDialog.show();
        },
        
        resetView: function () {
        	if ( this.firstAreaBottomDiv ) {
				htmlUtil.setClass(this.firstAreaBottomDiv, "mumFirstAreaBottomDiv" + this.currentType);
				
				dojo.fx.wipeOut({
					node: this.secondAreaDiv,
					duration: 500
				}).play();
			}	
			
			if ( this.secondAreaBottomDiv ) {
				this.hideElement(this.secondAreaBottomDiv);
				
				dojo.fx.wipeOut({
					node: this.wirePaneWidgetEventsDiv,
					duration: 10
				}).play();
			}	
            
            this.displayPrompter("1");
        	
        	if ( this.currentType === "Send" ) {
        		this.createSendEventsDiv();
        	} else if ( this.currentType === "Receive" ) {
        		this.createReceiveEventsDiv();
        	}
			
			this.resetEventWireCount();

        },
        
        /**
         * Handler for saved settings from the wiring settings dialog.
         */
        settingsSaved: function(settings){
            this.wiringSettings = settings;
            this.matchingType = settings[this.wiringSettingsConstants.SETTING_MATCHING_TYPE];
			var config = this.iContext.getiWidgetAttributes();
			config.setItemValue( "matchingType", this.matchingType );
			var me = this;
			// TODO: not work for system widget!
			config.save(function () {
				//reset the data now
				me.initAllData();
				//reset the view with the new data
				me.resetView();
			});
        },
		
		_setupEventTypeDiv: function(div, payloadType) {
			payloadLabel = this.getShownType(payloadType);
			div.innerHTML = htmlUtil.escapeString(payloadLabel);
			div.title = payloadLabel;
		}
    });
    
})();

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringDisabledTip"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringDisabledTip"] = true;
/**
 * @author <a href="mailto:bizheng@cn.ibm.com">Zheng Bi</a>
 */
dojo.provide("com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringDisabledTip");



dojo.declare("com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringDisabledTip", [dijit._Widget, dijit._Templated], {
	
	autoWiringResult: false,
	
	contentRoot: null,
	
	notificationDialog:null,
	
	widgetId: null,
	
	templateString: "<div dojoAttachPoint='autoWiringNotiDiv' class='mumAutoWiringTipDiv'>" +
						"<div class='mumAWDNIcon'>" + 
							"<img dojoAttachPoint='wiringIcon' />" +
						"</div>" + 
						"<div class='mumAWDNMiddle' >" + 
							"<div dojoAttachPoint='tipText' class='mumAWDNTip'>" + 
							"</div>" +
							"<div dojoAttachPoint='NotiCfgNode' class=''>" + 
								"<input type='checkbox' dojoAttachPoint='NotiCfgCheckNode' dojoAttachEvent='onclick: onNotNotifyMeClicked' class='mumAutoWiringNotiCfgCheck'/>" +
								"<div dojoAttachPoint='NotiCfgLabel' class='mumAutoWiringNotiCfgLable'></div>" +
							"</div>" +
						"</div>" +
						"<div dojoAttachPoint='okNode' class='mumAutoWiringOk'>" +
							"<div dojoAttachPoint='okTextHidden' class='mumAutoWiringOKTextHidden'>" + 
							"</div>"+
							"<div dojoAttachPoint='okText' class='mumAutoWiringOKText'>" + 
							"</div>"+
						"</div>" +
					"</div>",
						
	constructor:function(){
	},
	
	postCreate:function(){
		this.initContent();
	},
	
	updateContent:function(widgetId){
		var widgetTitle = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetTitleCSA2(widgetId);
		widgetTitle = com.ibm.mm.builder.utils.htmlUtil.formatBlankSpace(widgetTitle);
		var tip = dojo.query(".mumAWDNTip", this.notificationDialog.domNode)[0];
		tip.innerHTML = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_AUTO_WIRING_INTERFACE_TIP,[widgetTitle,"<span class='mumAWDNTipLink'>","</span>"]);
		var link = dojo.query(".mumAWDNTipLink", tip)[0];
		dojo.connect(link,"onclick", this,"onClickOpenAWProperties");
		
		// check/uncheck the NotiCfgCheckNode
		if (com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.AUTO_WIRE_DISABLED_NOTIFICATIONS")) {
    		var userModel = com.ibm.mm.builder.utils.userUtil.getUserModel();
	    	var user = userModel.findCurrentUser().start();
		    var showNoti = user.getAttribute("com.ibm.mashups.user.AUTO_WIRE_DISABLED_NOTIFICATIONS");
		    this.NotiCfgCheckNode.checked = !showNoti;
		}
	},
	
	setOuterWirePaneContext:function(iContext) {
		this.outerContext = iContext;	
	},
	
	onNotNotifyMeClicked: function(event){
		if (com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.AUTO_WIRE_DISABLED_NOTIFICATIONS")) {
    		var userModel = com.ibm.mm.builder.utils.userUtil.getUserModel();
	    	var user = userModel.findCurrentUser().start();
		    user.setAttribute("com.ibm.mashups.user.AUTO_WIRE_DISABLED_NOTIFICATIONS",!this.NotiCfgCheckNode.checked);
		    userModel.commit().start();
		}
	},
	
	onClickOpenAWProperties:function(){
		this.hide();
		var currentPageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
		com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.outerContext.widgetId);
		com.ibm.mm.builder.commonActions.editPage(currentPageId);
	},
	
	initContent:function(){
		this.wiringIcon.alt = this.wiringIcon.title= com.ibm.mm.builder.coreWidgetsStrings.I_WIRING_NAME;			
		dojo.attr(this.wiringIcon,"src",builderConfig.builderPath + (builderConfig.isBidi ? "/images/d_wiring_icon_rtl.png" :
		"/images/d_wiring_icon.png"));
		this.NotiCfgLabel.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_AUTO_WIRING_NOTIFICATION_DISABLE_NOTI;
		this.okText.innerHTML = "<a href='javascript:'>" + com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_OK + "</a>";
		dojo.connect(this.okText,"onclick", this,"hide");
		this.okTextHidden.innerHTML = "<a href='javascript:'>" + com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_OK + "</a>";
		
		var contentDiv = document.createElement("div");
		contentDiv.appendChild(this.autoWiringNotiDiv);
		this.notificationDialog = dijit.byId("this.notificationDialog");
		if (!this.notificationDialog) {
			this.notificationDialog = new com.ibm.mm.builder.widget.CustomDialog({
				id: "Mashup_Auto_Wiring_Disable_Tip_Dlg",
				needUnderLay: false,
				roundCorner: true,
				modelDialog: true,
				hasRightBottomResizer: false,
				dialogOpacity: 0.85
			}, contentDiv);
		}
	},
	
	destroy:function() {
		this.notificationDialog.destroy();
	},
	
	show:function(widgetId) {
		this.updateContent(widgetId);
		this.notificationDialog.show();
	},
	
	hide:function(){
		if(this.notificationDialog) {
			this.notificationDialog.hide();
		}
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringNotification"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringNotification"] = true;
/**
 * @author <a href="mailto:bizheng@cn.ibm.com">Zheng Bi</a>
 */
dojo.provide("com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringNotification");



dojo.declare("com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringNotification", [dijit._Widget, dijit._Templated], {
	
	autoWiringResult: null,
	
	contentRoot: null,
	
	notificationDialog:null,
	
	widgetId: null,
	
	location:null,
	
	templateString: "<div dojoAttachPoint='autoWiringNotiDiv' class='mumAutoWiringNotiDiv'>" +
						"<div dojoAttachPoint='autoWiringNotiDivMain' class='mumAutoWiringNotiDivMain'>"+
							"<div dojoAttachPoint='titleNode' class='mumAutoWiringTitle'>" +
								"<span dojoAttachPoint='titleIconNode' class='mumAutoWiringTitleIcon'>" + 
								"</span>" +
								"<span dojoAttachPoint='titleText' class='mumAutoWiringTitleText'>" + 
								"</span>" +
							"</div>" +
							"<div dojoAttachPoint='contentNode' class='mumAutoWiringContent'>" +
							"</div>" +
							"<div dojoAttachPoint='actionsNode' class='mumAutoWiringActions'>" +
								"<div dojoAttachPoint='openWiringNode' class='mumAutoWiringOpenWiring'>" + 
								"</div>" +
								"<div dojoAttachPoint='NotiCfgNode' class='mumAutoWiringNotiCfg'>" + 
									"<input type='checkbox' dojoAttachPoint='NotiCfgCheckNode' dojoAttachEvent='onclick: onNotifyMeClicked' class='mumAutoWiringNotiCfgCheck'/>" +
									"<div dojoAttachPoint='NotiCfgLabel' class='mumAutoWiringNotiCfgLable'></div>" +
								"</div>" +
							"</div>" +
						"</div>" +
						"<div dojoAttachPoint='okNode' class='mumAutoWiringOk'>" +
							"<div dojoAttachPoint='okTextHidden' class='mumAutoWiringOKTextHidden'>" + 
							"</div>"+
							"<div dojoAttachPoint='okText' class='mumAutoWiringOKText'>" + 
							"</div>"+
						"</div>" +
					"</div>",
						
	constructor: function(){
		
	},
	
	onNotifyMeClicked:function(event){
		if (com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.AUTO_WIRE_ENABLED_NOTIFICATIONS")) {
			var userModel = com.ibm.mm.builder.utils.userUtil.getUserModel();
			var user = userModel.findCurrentUser().start();
			user.setAttribute("com.ibm.mashups.user.AUTO_WIRE_ENABLED_NOTIFICATIONS", !this.NotiCfgCheckNode.checked);
			userModel.commit().start();
		}
	},
	
	onClickOpenWiring:function(){
		var widgetId = this.autoWiringResult.widgetId;
		var widgetUtil = com.ibm.mm.builder.utils.iwidgetUtil;
		var widgetIcon = widgetUtil.getWidgetIconCSA2(widgetId);
		var dialogParam = {
			nodeWidth: "486px",
			title: com.ibm.mm.builder.coreWidgetsStrings.I_WIRING_NAME,
			titleIconUrl: widgetIcon,
			leftBarWidth: "18px",
			rightBarWidth: "12px",
			displayCloseButton: true,
			hasRightBottomResizer: false
		};
		var payload = {
	    	widgetTypeId: "wireInterface",
	        eventName:  "com.ibm.mashups.builder.editWire",
	        eventPayload:  widgetId,
	        dialogParam:  dialogParam,
			hasRightBottomResizer: false,
	        requestRefresh: true
		};
		com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
	},
	
	initContent:function(){
		this.fillInText();
		if (!this.autoWiringResult) {
			return;
		}
		
		this.titleIconNode.innerHTML = "";
		var wiringIcon = document.createElement("img");	
		this.titleIconNode.appendChild(wiringIcon);
		wiringIcon.alt = wiringIcon.title= com.ibm.mm.builder.coreWidgetsStrings.I_WIRING_NAME;
		dojo.attr(wiringIcon,"src",builderConfig.builderPath + (builderConfig.isBidi ? "/images/d_wiring_icon_rtl.png":"/images/d_wiring_icon.png"));	
		
		
		this.contentNode.innerHTML = "";
		var publishToWidgets = this.autoWiringResult.publishTo;
		var receiveFromWidgets = this.autoWiringResult.receiveFrom;
		var wireDiv=null;
		for(var i = 0; i < publishToWidgets.length; i++) {
			wireDiv = this.createWireDiv(publishToWidgets[i],"Send");
			this.contentNode.appendChild(wireDiv);
		}
		for(var j = 0; j < receiveFromWidgets.length; j++) {
			 wireDiv = this.createWireDiv(receiveFromWidgets[j],"Receive");
			this.contentNode.appendChild(wireDiv);
		}
		dojo.connect(this.openWiringNode,"onclick", this,"onClickOpenWiring");
		dojo.connect(this.okText,"onclick", this,"hide");
	},
	
	hide:function(){
		var notificationDlg = dijit.byId("Mashup_Auto_Wiring_Notification_Dlg" + this.widgetId);
		if(notificationDlg) {
			notificationDlg.hide();
			notificationDlg.destroy();
		}
	},
	
	createWireDiv:function(widgetId,type) {
		//var widgetTitle = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(widgetId);
		var widgetTitle = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetTitleCSA2(widgetId);
		widgetTitle = com.ibm.mm.builder.utils.htmlUtil.formatBlankSpace(widgetTitle);
		var widgetIconUrl = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetIconCSA2(widgetId);
		var wireDiv = document.createElement("div");
		dojo.addClass(wireDiv,"mumAutoWiringWireDiv");
		var iconDiv = document.createElement("div");
		wireDiv.appendChild(iconDiv);
		dojo.addClass(iconDiv,"mumAWWireDivIcon");

		var widgetIcon = document.createElement("img");
		iconDiv.appendChild(widgetIcon);
		
		widgetIcon.alt = widgetIcon.title= com.ibm.mm.builder.utils.htmlUtil.unEscapeString(widgetTitle);	
		dojo.attr(widgetIcon,"src",widgetIconUrl);	
		
		var textDiv = document.createElement("div");
		wireDiv.appendChild(textDiv);
		dojo.addClass(textDiv,"mumAWWireDivText");
		
		if(type == "Send") {
			textDiv.innerHTML = textDiv.title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_AUTO_WIRING_NOTIFICATION_SENDING_TO,[widgetTitle]);
		}
		else {
			textDiv.innerHTML = textDiv.title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_AUTO_WIRING_NOTIFICATION_RECEIVING_FROM,[widgetTitle]);
		}
		return wireDiv;
	},
	
	fillInText:function(){
		var widgetTitle = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(this.widgetId);
		widgetTitle = com.ibm.mm.builder.utils.htmlUtil.formatBlankSpace(widgetTitle);
		if (this.location.inNVA) {
			this.titleText.innerHTML = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_AUTO_WIRING_NOTIFICATION_TITLE_FOR_WIDGET, [widgetTitle]);
		}
		else {
			this.titleText.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_AUTO_WIRING_NOTIFICATION_TITLE;
		}
		this.openWiringNode.innerHTML = "<a href='javascript:'>" + com.ibm.mm.builder.coreWidgetsStrings.I_AUTO_WIRING_NOTIFICATION_OPEN_WIRE_INTERFACE + "</a>";
		this.NotiCfgLabel.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_AUTO_WIRING_NOTIFICATION_DISABLE_NOTI;
		this.okText.innerHTML = "<a href='javascript:'>" + com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_OK + "</a>";
		this.okTextHidden.innerHTML = "<a href='javascript:'>" + com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_OK + "</a>";
	},
	
	/**
	 * show the access control reassign dialog
	 */
	showAutoWiringResult: function(id,autoWiringResult,location){
		this.widgetId = id;
		this.autoWiringResult = autoWiringResult;
		this.location = location;
		
		dojo.subscribe("widgetDeleted"+id,this,"hide");
		
		this.initContent();
		var notificationDlg = dijit.byId("Mashup_Auto_Wiring_Notification_Dlg" + this.widgetId);
		if (notificationDlg){
			notificationDlg.destroy();
		}
		var contentDiv = document.createElement("div");
		contentDiv.appendChild(this.autoWiringNotiDiv);
		
		this.notificationDialog = new com.ibm.mm.builder.widget.CustomDialog(
			{
				id: "Mashup_Auto_Wiring_Notification_Dlg"+this.widgetId,
				needUnderLay:false,
				roundCorner:true,
				modelDialog:false,
				initLeftPosition:location.x+"px",
				initTopPosition:location.y+"px",
				hasRightBottomResizer: false,
				dialogOpacity: 0.85
			},
			contentDiv
		);
		this.notificationDialog.show();
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.widget.MoveWidget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.MoveWidget"] = true;
dojo.provide("com.ibm.mm.builder.widget.MoveWidget");








dojo.declare("com.ibm.mm.builder.widget.MoveWidget",[dijit._Widget, dijit._Templated],{	
    templateString: 
    	'<div dojoAttachEvent="onkeypress: _onKeyPress" class="moveWidgetContainer">'+
			'<div class="moveWidgetDiv" dojoAttachPoint="containerNode">'+
				'<div class="moveWidgetItem" dojoAttachPoint="moveWidgetTopDiv">'+
					'<span class="moveWidget_item_label">${I_CONTEXT_MENU_WIDGET_TOP_LABEL}</span>'+
					'<input dojoType="dijit.form.NumberSpinner" type="text" dojoAttachPoint="widgetTopInput" '+ 
						'title="${TOP_INPUT_TITLE}" invalidMessage="${I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE}" '+
						'class="moveWidget_inputField" required="true" tabindex=0/>'+
				'</div>'+
				'<div class="clearthefloats"></div>' +
				'<div class="moveWidgetItem" dojoAttachPoint="moveWidgetLeftDiv">'+
					'<span class="moveWidget_item_label">${I_CONTEXT_MENU_WIDGET_LEFT_LABEL}</span>'+
					'<input dojoType="dijit.form.NumberSpinner" type="text" dojoAttachPoint="widgetLeftInput" '+ 
						'title="${LEFT_INPUT_TITLE}" invalidMessage="${I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE}" '+
						'class="moveWidget_inputField" required="true" tabindex=0 />'+
				'</div>'+
				'<div class="clearthefloats"></div>' +
			'</div>'+
			'<div dojoType="com.ibm.mm.builder.dialog.DialogFooter" dojoAttachPoint="footer" '+
				'dojoAttachEvent="onSave: save, onCancel: hide">'+
			'</div>'+
		'</div>',
	
	TOP_INPUT_TITLE: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_INPUT_TITLE2,
	LEFT_INPUT_TITLE: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_INPUT_TITLE1,
	
	I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE,
	I_COMMON_CANCEL: com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_CANCEL,
	I_COMMON_SAVE: com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_SAVE,
	I_CONTEXT_MENU_WIDGET_TOP_LABEL: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_TOP_LABEL,
	I_CONTEXT_MENU_WIDGET_LEFT_LABEL: builderConfig.isBidi ? 
		com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_RIGHT_LABEL : 
		com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_LEFT_LABEL,
	
	widgetsInTemplate: true,
	
	postCreate: function(){	
		this.uniDialog = new com.ibm.mm.builder.widget.CustomDialog(this.dlgPara);
		this.uniDialog.containerNode.appendChild(this.domNode);
		
		dojo.connect(this.uniDialog, "onResize", this, "onDialogResize");
		this._setA11YHint();
	},
	
	_setA11YHint: function() {
		var leftInput = dojo.query("input", this.moveWidgetLeftDiv)[0];
		dojo.attr(leftInput, "title", this.LEFT_INPUT_TITLE);
		
		var topInput = dojo.query("input", this.moveWidgetTopDiv)[0];
		dojo.attr(topInput, "title", this.TOP_INPUT_TITLE);
		
	},
	
	_onKeyPress:function(evt){
		if (evt.keyCode == dojo.keys.ENTER) {
			this.save();
		}
	},
	
	hide: function(){
		this.uniDialog.hide();
	},
	
	updateProperty: function(widgetId){
		this.widgetId = widgetId;
		
		this.widgetTopInput.constraints = {min: 0, places: 0};
		var widgetNode = com.ibm.pb.layout.LayoutParser.findById(widgetId);
				
		var pageWidthRange = com.ibm.mm.builder.utils.pageWidthChanger.getPageWidthRange();
		var widgetWidth = dojo.style(widgetNode, "width");
		//com.ibm.mm.builder.utils.skinUtil.getLocationValue("width", widgetId);
		this.widgetLeftInput.constraints = {min:0,max: pageWidthRange.max - widgetWidth, places:0};
				
		var top = dojo.style(widgetNode, "top");
		//var top = com.ibm.mm.builder.utils.skinUtil.getLocationValue("top",widgetId);
		if (top){
			top = parseInt(top,10);	
			this.widgetTopInput.setValue(top);		
		}else if(top === 0){
			this.widgetTopInput.setValue(0);
		}
		var left = dojo.style(widgetNode, builderConfig.isBidi ? "right" : "left");
		//var left = com.ibm.mm.builder.utils.skinUtil.getLocationValue(builderConfig.isBidi ? "right" : "left",widgetId);
		if (left){
			left = parseInt(left,10);		
			this.widgetLeftInput.setValue(left);
		}else if(left === 0){
			this.widgetLeftInput.setValue(0);
		}
		this.uniDialog.show();
	},
	
	setTitle: function(title) {
		if (this.uniDialog) {
			this.uniDialog.setTitle(title);
		}
	},
		
	save: function(){
		if (!(this.widgetTopInput.isValid() && this.widgetLeftInput.isValid())) { return; }
		
		var widget_left_coordinate = 0;
		var widgetNode = com.ibm.pb.layout.LayoutParser.findById(this.widgetId);
		if(builderConfig.isBidi){
			var widget_width = dojo.style(widgetNode, "width");
			var pageWidthRange = com.ibm.mm.builder.utils.pageWidthChanger.getPageWidthRange();
			//var widget_width = com.ibm.mm.builder.utils.skinUtil.getLocationValue("width", this.widgetId);
			var page_width = pageWidthRange.max;
			
			widget_left_coordinate = page_width - widget_width - this.widgetLeftInput.getValue();
			if (widget_left_coordinate < 0) {
				widget_left_coordinate = 0;
			}
		}else{
			widget_left_coordinate = this.widgetLeftInput.getValue();
		}
		
		this.moveWidget({
			id: this.widgetId,
			top: this.widgetTopInput.getValue()+"px", 
			left: widget_left_coordinate + "px"
		});
		this.hide();
	},
		
	moveWidget:function(widgetInfo){
		var widgetId = widgetInfo.id;
		var widgetNode = com.ibm.pb.layout.LayoutParser.findById(widgetId);
		if(!widgetNode.style.position){
			widgetNode.style.position="absolute";
		}
		widgetNode.style.left=widgetInfo.left;
		widgetNode.style.top=widgetInfo.top;
		var parent = widgetNode.parentNode;
		var currentPageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
		var lm = ibmCfg.controllers.dnd.nm.getLayoutModel(currentPageId);
		if (dojo.hasClass(parent, "ibmFreeform")){
			var oldHeight = dojo.coords(parent).h;
			var leastHeight = dojo.coords(widgetNode).h + parseInt(widgetInfo.top);
			if (oldHeight < leastHeight){
				parent.style.height = (leastHeight + 10) + "px";
				var _containerId = com.ibm.pb.layout.LayoutParser.extractID(parent);
				var ctrol = lm.find(_containerId).start();
				ctrol.setMetaData("css-style", "height:"+ (leastHeight + 10) +"px;");
			}
		}
		var lctl = lm.find(widgetId).start();
		lctl.setMetaData("css-style", widgetNode.style.cssText);	
	},

	onDialogResize: function(width, height) {
		var dialogContainerCB = dojo.contentBox(this.uniDialog.containerNode);
		var containerMB = dojo.marginBox(this.containerNode);
		var footerHeight = dojo.marginBox(this.footer.domNode).h;
		
		containerMB.w = dialogContainerCB.w;
		containerMB.h = dialogContainerCB.h - footerHeight;
		
		dojo.marginBox(this.containerNode, containerMB);
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.widget.ResizeWidget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.ResizeWidget"] = true;
dojo.provide("com.ibm.mm.builder.widget.ResizeWidget");





dojo.declare("com.ibm.mm.builder.widget.ResizeWidget",[dijit._Widget, dijit._Templated],{	

	templateString:
		'<div class="resizeWidgetContainer">'+
			'<div class="resizeWidgetDiv" >'+
				'<div class="resizeWidgetItem" dojoAttachPoint="resizeWidthDiv">'+
					'<label for="" dojoAttachPoint="widgetWidthLabel"><span class="resizeWidget_item_label">${I_CONTEXT_MENU_WIDGET_WIDTH}</span></label>'+
					'<input dojoType="dijit.form.NumberSpinner" dojoAttachPoint="widgetWidthInput" type="text" required="true" '+
						'class="resizeWidget_inputField" title="${I_CONTEXT_MENU_WIDGET_WIDTH}" '+
						'invalidMessage="${I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE}" tabindex=0 />'+
				'</div>'+
				'<div class="clearthefloats"></div>' +
				'<div class="resizeWidgetItem" dojoAttachPoint="resizeHeightDiv">'+
					'<label for="" dojoAttachPoint="widgetHeightLabel"><span class="resizeWidget_item_label">${I_CONTEXT_MENU_WIDGET_HEIGHT}</span></label>'+
					'<input dojoType="dijit.form.NumberSpinner" dojoAttachPoint="widgetHeightInput" type="text" required="true" '+
						'class="resizeWidget_inputField" title="${I_CONTEXT_MENU_WIDGET_HEIGHT}" '+
						'invalidMessage="${I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE}" tabindex=0 />'+
				'</div>'+
				'<div class="clearthefloats"></div>' +
			'</div>'+
			'<div dojoType="com.ibm.mm.builder.dialog.DialogFooter" dojoAttachPoint="footer" '+
				'dojoAttachEvent="onSave: save, onCancel: hide">'+
		'</div>',
	
	I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE,
	// TODO: remove the 'or' after translation is ready
	I_CONTEXT_MENU_WIDGET_WIDTH: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_WIDTH_TITLE || "Widget width",
	I_CONTEXT_MENU_WIDGET_HEIGHT: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_HEIGHT_TITLE || "Widget height",
	I_COMMON_CANCEL: com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_CANCEL,
	I_COMMON_SAVE: com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_SAVE,
	
	minWidth:50,
	minHeight:50,
	
	widgetsInTemplate: true,
	
	postCreate: function(){
		this.evtSvc = com.ibm.mashups.services.ServiceManager.getService("eventService");
		
		this.uniDialog = new com.ibm.mm.builder.widget.CustomDialog(this.dlgPara);
		this.uniDialog.containerNode.appendChild(this.domNode);
		
		dojo.connect(this.uniDialog, "onResize", this, "onDialogResize");
		this._setA11YHint();
		
		if(dijit._masterTT){
			dijit.setWaiState(dijit._masterTT.containerNode,"live","assertive");
			dijit.setWaiRole(dijit._masterTT.containerNode,"alert");
		}

		dojo.attr(this.widgetWidthLabel, "for", this.widgetWidthInput.id);
		dojo.attr(this.widgetHeightLabel, "for", this.widgetHeightInput.id);
	},
	
	_setA11YHint: function() {
		var widthInput = dojo.query("input", this.resizeWidthDiv)[0];
		dojo.attr(widthInput, "title", this.I_CONTEXT_MENU_WIDGET_WIDTH);
		
		
		var heightInput = dojo.query("input", this.resizeHeightDiv)[0];
		dojo.attr(heightInput, "title", this.I_CONTEXT_MENU_WIDGET_HEIGHT);
		
	},
	
	hide: function(){
		this.uniDialog.hide();
	},
	
	updateProperty: function(widgetId){
		this.widgetId = widgetId;
		var widgetWrapper = com.ibm.pb.layout.LayoutParser.findById(this.widgetId);
		this.maxSize = this.createMaxSize(widgetId);
		var pageWidthMode = com.ibm.mm.builder.utils.pageWidthChanger.getPageWidthMode();
		this.widgetWidthInput.constraints = {
			min: this.minWidth, 
			max: this.maxSize.maxW,
			places: 0
		};
		this.widgetHeightInput.constraints = {
			min: this.minHeight, 
			max: this.maxSize.h,
			places: 0
		};
		
		var height = dojo.style(widgetWrapper, "height");
		if (height){
			height = parseInt(height,10);	
			this.widgetHeightInput.setValue(height);
		}
		var width = dojo.style(widgetWrapper, "width");
		if (width){
			width = parseInt(width,10);		
			this.widgetWidthInput.setValue(width);		
		}
		this.uniDialog.show();
	},
	
	setTitle: function(title){
		if (this.uniDialog) {
		    this.uniDialog.setTitle(title);
		}
	},
		
	save: function(){
		alert('this is a test in save');
		if (!(this.widgetWidthInput.isValid() && this.widgetHeightInput.isValid())) {
			return;
		}

		var newH = this.widgetHeightInput.getValue();
		var newW = this.widgetWidthInput.getValue();
		
		var payload = {
			widgetId: this.widgetId,
			width: newW,
			height: newH
		};
		this.evtSvc.broadcastEvent("com.ibm.mashups.builder.resizeWidget", payload);
		this.hide();
	},
	
	createMaxSize:function(widgetId){
		var curWidget = com.ibm.pb.layout.LayoutParser.findById(widgetId);
		var containerNode = curWidget.parentNode;
		if(curWidget && containerNode){
			// defect 7486
			var curWidgetBox = dojo.marginBox(curWidget);
			var curLeft = parseInt(curWidgetBox.l,10);
			var curTop = parseInt(curWidgetBox.t,10);	
			var wholeWidth = dojo._getContentBox(containerNode).w;
			var wholeHeight = dojo._getContentBox(containerNode).h;
			var pageWidthRange = com.ibm.mm.builder.utils.pageWidthChanger.getPageWidthRange();
			return {
				maxW: pageWidthRange.max - curLeft,
				w: wholeWidth - curLeft,
				h: wholeHeight - curTop
			};
		}
		return null;		
	},
	
	onDialogResize: function(width, height){
		alert('this is a test in onDialogResize');
		var dialogContainerCB = dojo.contentBox(this.uniDialog.containerNode);
		var containerMB = dojo.marginBox(this.containerNode);
		var footerHeight = dojo.marginBox(this.footer.domNode).h;
		containerMB.w = dialogContainerCB.w;
		containerMB.h = dialogContainerCB.h - footerHeight;
		dojo.marginBox(this.containerNode, containerMB);
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.dialog.EmbeddingWidgetDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dialog.EmbeddingWidgetDialog"] = true;
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.dialog.EmbeddingWidgetDialog");




/**
 * This class will launch a custom dialog to show the embed widget UI.
 */
dojo.declare("com.ibm.mm.builder.dialog.EmbeddingWidgetDialog",null,{
	/**
	 * the root element id which the embed widget UI will be appended.
	 * @type String
	 */
	rootId:null,
	/**
	 * embed widget ID.
	 * @type String
	 */
	widgetId:null,
	
	/**
	 * widget instance ID for the widget to be embedded.
	 * @type String
	 */		
	widgetInstanceId:null,
	
	/**
	 * id of the div to host embedding dlg 
	 * @type String
	 */		
	embeddingDlg_ID:"mainEmbeddingDialog",

	/**
	 * id of the div to host embedding preview dlg 
	 * @type String
	 */	
	embeddingPreviewDlg_ID:"mainEmbeddingPreviewDialog",
	
	/**
	 * widget edit mode dlg
	 * @type Object
	 */
	editPane:null,
	
	/**
	 * open the preview by default or not
	 * @type String
	 */
	openPreviewAuto: "auto", // open preview by default
	
	openPreviewForce: "force", // user click the preview button
	
	dojoConnectors:[], 
	
	/**
	 * Constructor
	 * set open preview as true by default, subscribe a close dlg topic
	 */	
	constructor: function(_rootId, _widgetId){
		this.widgetId = _widgetId;
		this.rootId = _rootId;
		var preview = dojo.cookie("open_embed_widget_preview") || true;
		this.openEmbedWidgetPreview = (preview == "true") ? true : false;
		this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.dialog.EmbeddingWidgetDialog");
	},

	/**
	 * create the embedding widget dlg UI content
	 * @param {Object} stub
	 */	
	createEmbedingContent:function(widgetDef,status){
		var modes = widgetDef.getSupportedModes();
		var enableEditSetting = true;
		var widgetTitle = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(this.widgetInstanceId);
		
		var desc = "";
		// check the widget supported mode
		if (modes!==null && modes.length >0) {	
			if (!this._belong("edit",modes)){
				enableEditSetting = false;
				desc = com.ibm.mm.builder.coreWidgetsStrings.I_EMBED_WIDGET_DESC_NOEDITMODE;
			}else{
				desc = com.ibm.mm.builder.coreWidgetsStrings.I_EMBED_WIDGET_DESC_WITHEDITMODE;
			}
		}else{
			this.LOGGER.severe("createEmbedingContent",com.ibm.mm.builder.coreWidgetsMessages.E_EMBEDDING_WIDGET_ERROR_0);
		}			
		
		//update the description
		if (desc !== "") {
			dojo.byId("_" + this.widgetId + "_embed_desc").innerHTML = desc;
		}
		
		var inDialog = this.dialogContainer===null?false:true;
		
		// create the preview dlg
		var title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_EMBED_PAGE_PREVIEW_TITLE, [widgetTitle]);
		if (!this.previewDlg){
			this.previewDlg = new com.ibm.mm.builder.widget.CustomDialog({
				id:	this.embeddingPreviewDlg_ID,
				containerBackgroundColor: "white",
				nodeWidth:dojo.isIE?"520px":'515px',
				nodeHeight:dojo.isIE?(dojo.isIE==6?"505px":"512px"):"516px",
				initLeftPosition: "700px",
				initTopPosition: "100px",
				modelDialog:!inDialog,
				needUnderLay: false,
				scrollEnabled: true
				// 8143/9205: if bidi, CustomDialog will not add the 'custom_dialog_nomodel'
				// class which interferes with the left/right movement of the dialog
				// 9637: removed rtl version of custom_dialog_nomodel so removed param isEmbedPageBidi
			});			
		}
		this.previewDlg.setTitle(title);
		
		if (inDialog) {
			this.dialogContainer.registerSubDialog(this.embeddingPreviewDlg_ID);
		}
		
		this.previewEmbedding(this.openPreviewAuto);
		this.updateMarkup();
		// bind event
		this.dojoConnectors.push(dojo.connect(document.getElementsByName("_"+this.widgetId + "_emdPgWidth")[0], "onclick", this, function(){
			dojo.byId("_"+this.widgetId + "_width").disabled = false;
		}));
		this.dojoConnectors.push(dojo.connect(document.getElementsByName("_"+this.widgetId + "_emdPgWidth")[1], "onclick", this, function(){
			dojo.byId("_"+this.widgetId + "_width").disabled = true;
		}));
		this.dojoConnectors.push(dojo.connect(dojo.byId("_"+this.widgetId +"_close"), "onclick", this, "hideEmbeddingDlg"));
		this.dojoConnectors.push(dojo.connect(dojo.byId("_"+this.widgetId +"_preview"), "onclick", this, "previewEmbeddingAction"));	
		this.dojoConnectors.push(dojo.connect(dojo.byId("_"+this.widgetId +"_updateLink"), "onclick", this, "updateMarkup"));
		var embedEditButton = dojo.byId("_"+this.widgetId +"_embedEdit");
		if (enableEditSetting){
			this.dojoConnectors.push(dojo.connect(embedEditButton, "onclick", this, "loadEditMode"));
		}else{
			embedEditButton.disabled = true;
			dojo.toggleClass(embedEditButton, "lotusFormButton", false);
			dojo.toggleClass(embedEditButton, "lotusFormButtonDisabled", true);
		}		
	},

	/**
	 * show the embedding widget dlg
	 */		
	updateEmbedding: function(){
		var widgetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(this.widgetInstanceId);
		var getSMDeferred = widgetWrapper.getIWidgetDefinition();
		getSMDeferred.setFinishedCallback(dojo.hitch(this, this.createEmbedingContent));
		getSMDeferred.start(false);
	},
	
	destroyEmbeddedWidget: function(){
		com.ibm.mm.builder.utils.embedUtil.destroyEmbeddedWidget(this.widgetInstanceId);
		for (var i=0;i<this.dojoConnectors.length;i++){
			dojo.disconnect(this.dojoConnectors[i]);
		}
		this.dojoConnectors=[];
	},
	
	/**
	 * hide the embedding widget dlg
	 */		
	hideEmbeddingDlg: function(){
	    this.destroyEmbeddedWidget();
		com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.widgetId);
	},

	/**
	 * preview action when user click the Preview button in embedding widget UI
	 */	
	previewEmbeddingAction:function(){
		this.previewEmbedding(this.openPreviewForce);
	},

	/**
	 * show the preview dlg
	 * @param {String} previewType indicate whether the preview action is from user clicking the Preview button, or from auto preview
	 */	
	previewEmbedding: function(previewType){
		if (previewType == this.openPreviewAuto){
			if (!this.openEmbedWidgetPreview){
				// user have change the default open preview to false
				return;
			}
		}
		var validInput = com.ibm.mm.builder.utils.embedUtil.validateInput("_"+this.widgetId,this.embeddingDlg_ID);
		if (!validInput) {
			return null;
		}		
		if (this.previewDlg){
			this.previewDlg.dynaInitialized = false;
			this.previewDlg.show();	
			var root = this.previewDlg.containerNode;
			// create the preview UI
			root.innerHTML = "";
			root.appendChild(com.ibm.mm.builder.utils.embedUtil.createCheckPreview(this.widgetInstanceId,this.openEmbedWidgetPreview));
			root.appendChild(com.ibm.mm.builder.utils.embedUtil.createClearDiv());
			var iframeUID = com.ibm.mm.builder.utils.iwidgetUtil._getUid();
			var aframe = document.createElement("iframe");
			aframe.id = iframeUID;
			aframe.name = iframeUID;
			aframe.title = com.ibm.mm.builder.coreWidgetsStrings.I_EMBED_PREVIEW_FRAME;
			
			var widthValue = com.ibm.mm.builder.utils.embedUtil.getWidth("_"+this.widgetId);
			if (widthValue == "auto"){
				aframe.style.width = "100%";
			} else {
				aframe.style.width = widthValue;
			} 
			// add the height of " Widget powered by IBM Lotus Mashups"
			aframe.style.height = parseInt(com.ibm.mm.builder.utils.embedUtil.getHeight("_"+this.widgetId),10) + 25 + "px";
			aframe.scrolling = "no";
			aframe.frameBorder = 0;
			aframe.marginWidth = 0;
			aframe.frameSpacing = 0;
			aframe.marginHeight = 0;
			root.appendChild(aframe);	
			dojo.byId(this.widgetInstanceId +"_checkBox").setAttribute("accesskey", "A");
			dojo.byId(this.widgetInstanceId +"_closeLink").setAttribute("accesskey", "C");
			dojo.connect(dojo.byId(this.widgetInstanceId +"_checkBox"), "onclick", this, "reverseDefaultPreview");
			dojo.connect(dojo.byId(this.widgetInstanceId +"_closeLink"), "onclick", this, "hidePreview");			
			var iframeDoc = window.frames[iframeUID].document;
			iframeDoc.open();
			var url = this.generateURL();
			if (url){
				iframeDoc.write("<html><body><scr"+"ipt src=\"" + url + "\"></scr"+"ipt></body></html>");
			}	
			if (!dojo.isIE){
				iframeDoc.close();
			}
			this.updateMarkup();					
		}else{
			this.LOGGER.severe("previewEmbedding",com.ibm.mm.builder.coreWidgetsMessages.E_EMBEDDING_NOPREVIEWDLG_ERROR_0);
		}			
	},

	/**
	 * call enabler embedding generator to get the embeddable url
	 */
    generateURL:function() {
		var validInput = com.ibm.mm.builder.utils.embedUtil.validateInput("_"+this.widgetId,this.embeddingDlg_ID);
		var widgetXmlUrl;
		if (!validInput) {
			return null;
		}
		try {
			widgetXmlUrl = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetXMLURL(this.widgetInstanceId);
		}
		catch(e){
			return null;
		}
		
		// call iWidgetInstance from enabler to get all the itemset
		var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel();
		var iWidgetInstance = widgetModel.find(this.widgetInstanceId).getIWidgetInstance();

        if (iWidgetInstance === null) {
            this.LOGGER.severe(
            	"generateURL",
            	dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_EMBEDDING_NOWIDGET_ERROR_1,[this.widgetInstanceId])
            );
			return null;
        }
        var instanceAttributes = iWidgetInstance.getAttributes();			
		
		var width ="auto";
		if(dojo.query("[name=" + "_"+this.widgetId + "_emdPgWidth]")[0].checked){
			width = dojo.byId("_"+this.widgetId+"_width").value;
		}
		
		var height = dojo.byId("_"+this.widgetId+"_height").value;
		
		var haveScroll = false;
		if(dojo.query("[name=" + "_"+this.widgetId + "_emdPgScroll]")[0].checked){
			haveScroll = true;
		}

        var sandboxed = false;
        
        var widgetSpan = dojo.byId(this.widgetInstanceId);
        if (widgetSpan && widgetSpan.getAttribute("sandbox") === "true") {
            sandboxed = true;
        }

		return com.ibm.mm.builder.utils.embedUtil.generateURL(widgetXmlUrl,null,width,height,haveScroll,instanceAttributes,sandboxed);
    },

	/**
	 * action method when user click "Update Markup" in embedding UI.
	 * It will update the markup in the textarea 
	 */
	updateMarkup:function(){
		var url = this.generateURL();
		if (url){
			var markup = "<scr"+"ipt src=\"" + url + "\"></scr"+"ipt>";
			var textArea = dojo.byId("_"+this.widgetId+"_markup");
			var w = dojo.coords(textArea).w; 	
			textArea.style.width = w;	
			textArea.value = markup;	
			textArea.style.width = "98%";			
		}
	},

	/**
	 * load the widget edit mode dlg
	 */			
    loadEditMode: function(){
        var _title = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(this.widgetInstanceId);
	    this.editPane = new com.ibm.mm.builder.widget.WidgetEditDialog({
            id: this.widgetInstanceId + "_edit",
            title: dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_SYSTEM_CONF_TITLE, [_title]),
            type: "config",
            nodeWidth: dojo.byId(this.widgetInstanceId).getAttribute("sandbox") === "true" ? "600px" : null,
			nodeHeight: dojo.byId(this.widgetInstanceId).getAttribute("sandbox") === "true" ? "400px" : null,
			leftBarWidth: "0px",
        	rightBarWidth: "0px",
            needModeSwitch: true,
            belongId: this.widgetInstanceId,
            containerBackgroundColor: "white",
			closeCallback: function(){
				this.destroy(); 
			}
        });
		this.dojoConnectors.push(dojo.connect(this.editPane,"closeCallback",this,this.updateMarkup));
        com.ibm.mashups.services.ServiceManager.getService("eventService").fireEvent(this.widgetInstanceId, "onModeChanged", {
            newMode: 'edit',
            rootElementId: this.editPane.containerNode
        });
        this.editPane.show();
    },
	
	/**
	 * destroy the edit mode dlg
	 */	
	destroyEditPane: function(){
		if(dijit.byId(this.widgetInstanceId + "_edit")){
			dijit.byId(this.widgetInstanceId + "_edit").destroy();	
		}
	},

	/**
	 * hide the preview dlg
	 */	
	hidePreview:function(){
		if (this.previewDlg){
			this.previewDlg.hide();
		}
	},

	/**
	 * action method when check the checkbox "show preview by default"
	 */	
	reverseDefaultPreview:function(){
		this.openEmbedWidgetPreview = !this.openEmbedWidgetPreview;
		dojo.cookie("open_embed_widget_preview",this.openEmbedWidgetPreview);
	},		

	_belong:function(value, arr){
		for (var i in arr) {
			if (arr[i] == value) {
				return true;
			}
		}
	}			
	
});

}

if(!dojo._hasResource["com.ibm.mm.builder.dialog.NewPageDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dialog.NewPageDialog"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.dialog.NewPageDialog");







/**
 * This class will create a dialog for user to change widget instance title and icon
 */
dojo.declare("com.ibm.mm.builder.dialog.NewPageDialog", [dijit._Widget, dijit._Templated], {
	
	templateString: 
		'<div>'+
			'<div class="mmDialogTopArea">'+
				'<img src="'+builderConfig.builderPath+'/images/widget.png" alt="">'+
				'<span dojoAttachPoint="renamePrompt" class="mmDialogTopAreaTitle"></span>'+
			'</div>'+
			'<div style="margin:20px 10px 30px 20px">'+
				'<div class="pageProperty_item">'+
					'<input dojoAttachPoint="pageName" type="text" class="pageProperty_item_content"></input>'+
				'</div>'+
			'</div>'+
			'<div dojoType="com.ibm.mm.builder.dialog.DialogFooter" '+
				'dojoAttachEvent="onSave: save, onCancel: hide">'+
		'</div>',
		
	widgetsInTemplate: true,

	postCreate: function() {
		this.editorTitleDiv = document.createElement("div");
		document.body.appendChild(this.editorTitleDiv);
		this.editorTitleDiv.appendChild(this.domNode);
		this.renamePrompt.innerHTML = "Please input your page name:";
		//this.cancelBtn.innerHTML=com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_CANCEL;
		//this.saveBtn.value=com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_SAVE;
		
		this.dialog = new com.ibm.mm.builder.widget.WidgetEditDialog({
			belongId: this.iwidgetId,
			containerBackgroundColor: "white",
			nodeWidth: "430px"
		}, this.editorTitleDiv);
		
		this._pageUtil = com.ibm.mm.builder.utils.pageUtil;
	},
	
	child: false,
	
	/**
	 * show the page property dialog
	 */
	show: function() {
		this.dialog.show();
	},

	/**
	 * hide the page property dialog
	 */		
	hide: function() {
		this.dialog.hide();
	},
		
	save: function() {
		//invoke api to do this
		var name = this.pageName.value;
		if (!this._pageUtil.validatePageName(name)) { return; }
		name = dojo.trim(name);
		if (this.child) {
			this._pageUtil.createPage(name, this._pageUtil.getCurrentPageId());
		} else {
			this._pageUtil.createPage(name);
		}
		this.hide();
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.dialog.PageSaveConfirmDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dialog.PageSaveConfirmDialog"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.dialog.PageSaveConfirmDialog");






dojo.declare("com.ibm.mm.builder.dialog.PageSaveConfirmDialog", [dijit._Widget, dijit._Templated], 
{
	frameDialog: null,
	
	callbackSave: null,
	
	callbackNotSave: null,
	
	callbackCancel: null,
	
	contentWarning: null,
	
	contentQuestion: null,
	
	btnSaveText: null,
	
	btnNotSaveText: null,
	
	btnCancelText: null,
	
	hideNotSave: false,
	
	savePageOnSave: true,
	
	frameWidth: "540px",
	
	templateString:"<div role=\"alertdialog\">\n    <div class=\"mmConfirmDlgTop\">\n        <div class=\"mmConfirmDlgText1\" role=\"alert\">\n            <span dojoAttachPoint=\"warningMsg\">${contentWarning}</span>\n        </div>\n        <div class=\"mmConfirmDlgText2\" role=\"alert\">\n            <span dojoAttachPoint=\"suggestMsg\">${contentQuestion}</span>\n        </div>\n    </div>\n    <div class=\"mmConfirmDlgBottomArea lotusDialogFooter\" dojoAttachPoint = \"mmConfirmFooter\">\n        <input type=\"button\" dojoAttachPoint=\"saveBtn\" style=\"margin: 0\" class=\"lotusFormButton truncatedLabel\" \n\t\t\tdojoAttachEvent=\"onclick: _onSave,onkeypress:_onSaveWithKey\" \n\t\t\trole=\"button\" wairole=\"button\" aria-label=\"${btnSaveText}\" title=\"${btnSaveText}\" value=\"${btnSaveText}\"/>\n        <input type=\"button\" dojoAttachPoint=\"notSaveBtn\" class=\"lotusFormButton truncatedLabel\" \n\t\t\tdojoAttachEvent=\"onclick: _onNotSave,onkeypress:_onNotSaveWithKey\" \n\t\t\trole=\"button\" wairole=\"button\" aria-label=\"${btnNotSaveText}\" title=\"${btnNotSaveText}\" value=\"${btnNotSaveText}\"/>\n        <a href=\"javascript:void(0);\" dojoAttachPoint=\"cancelBtn\" aria-label=\"${btnCancelText}\" \n\t\t\tdojoAttachEvent=\"onclick: _onCancel,onkeypress:_onCancelWithKey\"\n\t\t\tclass=\"common_cancel lotusAction confirm_cancel truncatedLabel\" title=\"${btnCancelText}\">${btnCancelText}</a>\n    </div>\n</div>\n",
	
	postCreate: function(){
	
		var dialogParams = {
			id: "pageSaveConfirmDialog",
			title: com.ibm.mm.builder.coreWidgetsStrings.I_PAGE_SAVE_TITLE,
			displayCloseButton: true,
			hasRightBottomResizer: false,
			leftBarWidth: "0px",
			rightBarWidth: "0px"
		};
		
		this.frameDialog = new com.ibm.mm.builder.widget.CleanDialog(dojo.mixin(dialogParams, {
			nodeWidth: this.frameWidth,
			displayCloseButton: true,
			closeCallback: function(){
				this.destroy();
			}
		}));
		this.frameDialog.containerNode.appendChild(this.domNode);
		
		if(this.hideNotSave) {
			dojo.style(this.notSaveBtn, "display", "none");
		}
	},
	
	_onSaveWithKey: function(e){
		if (e.charCode === dojo.keys.SPACE || e.keyCode === dojo.keys.ENTER) {
			this._onSave(e);
		}
	},
	
	_onSave: function(){
		this.frameDialog.hide();
		if(this.savePageOnSave) {
			var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
			this.pageSavedHandle = eventService.subscribeEvent("com.ibm.mashups.builder.pageSaved", this, "_onSaveContinue");
			eventService.broadcastEvent("com.ibm.mashups.builder.savePage");
		}
		else {
			this.callbackSave && this.callbackSave(); 
		}
	},
	
	_onSaveContinue: function(){
    	if (this.pageSavedHandle) {
            var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
            eventService.unsubscribeEvent(this.pageSavedHandle);
            this.pageSavedHandle = null;
        }
        this.callbackSave && this.callbackSave();
	},
	
	_onNotSaveWithKey: function(e){
		if (e.charCode === dojo.keys.SPACE || e.keyCode === dojo.keys.ENTER) {
			this._onNotSave(e);
		}
	},
	
	_onNotSave: function(){
		this.frameDialog.hide();
		var runtimePage = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage();
		if (runtimePage) {
			// invalidate page
			var pageId = runtimePage.getID();
			var nm = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
			var page = nm.find(pageId).start();
			page && nm.invalidate(page);
			
			// invalidate widget windows
			com.ibm.mashups.enabler.widget.Factory.getWidgetModel().cachedWindows = {};
			
			// cancel widget sizes
			var nsm = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
			var layoutAccessor = com.ibm.mashups.enabler.model.state.AccessorFactory.getLayoutAccessor(nsm, pageId);
			layoutAccessor.setTemplateURL(null);
			
			// clean page
			runtimePage.setDirty(false);
		}
		this.callbackNotSave && this.callbackNotSave();
	},
	
	_onCancelWithKey: function(e){
		if (e.charCode === dojo.keys.SPACE || e.keyCode === dojo.keys.ENTER) {
			this._onCancel();
		}
	},
	
	_onCancel: function(){
		this.frameDialog.hide();
		this.callbackCancel && this.callbackCancel();
	},
	
	show: function(){
		this.frameDialog && this.frameDialog.show();
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.WidgetCreator"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.WidgetCreator"] = true;
/**
 * This class is used to create the span microformat for a iWidget
 * All the information should be passed in by a com.ibm.mm.builder.widget.PaletteEntry object
 * 
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.WidgetCreator");

dojo.declare("com.ibm.mm.builder.WidgetCreator",null,{
	
	widgetSkin:null,
	
	widgetDefXML:null,
	
	onNewWire:null,
	
	widgetType:null,
	
	uid:null,
	
	widgetTitle:null,
	
	systemWidget:null,
	
	widgetParam:null,
	
	configPanelNodeName:null,

	/**
	 * @constructor
	 * @param {String} uid the unique id of this iWidget instance
	 * @param {Object} inlineItemObj is an object in type of com.ibm.mm.builder.widget.PaletteEntry.
	 * this object should take all the information which is needed to create the microformat of the iWidget.
	 */
	constructor: function (_uid,widgetMetaData,itemset,widgetMap) {
		this.uid = _uid;
		this.itemSet = itemset;
		
		//if (typeof widgetMetaData != 'undefined'){
		if (widgetMetaData) {
			this.widgetDefXML = widgetMetaData.getDefinitionURL(false);
			var onnewwire = widgetMetaData.getMetadata("onNewWire");
			if (onnewwire == ""){
				this.onNewWire = "null";
			}else{
				this.onNewWire = onnewwire;
			}
			// Reading widgettype for determing other types of widgets such open social and open ajax.
			var widgetType = widgetMetaData.getMetadata("widgetType");
			if (widgetType == ""){
				this.widgetType = null;
			}else{
				this.widgetType = widgetType;
			}
			this.widgetTitle = com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(widgetMetaData);
			this.systemWidget = false;
			this.widgetParam = this._jsonObj(widgetMetaData.getMetadata("widgetParam"));
			this.istrusted = com.ibm.mm.builder.utils.iwidgetUtil.isTrustedWidget(widgetMetaData.getID());
			this.autowire = widgetMetaData.getMetadata("com.ibm.mashups.builder.autoWiringEnabled");
		} else {
			this.widgetDefXML = widgetMap.definitionURL;
			var onnewwire = widgetMap.onNewWire;
			if (onnewwire == ""){
				this.onNewWire = "null";
			}else{
				this.onNewWire = onnewwire;
			}
			// Reading widgettype for determing other types of widgets such open social and open ajax.

			this.widgetType = null;			

			this.widgetTitle = widgetMap.label;
			this.systemWidget = false;
			this.widgetParam = this._jsonObj(widgetMap.widgetParam);
			this.istrusted = widgetMap.sandbox_user == "true" ? false : true;
			this.autowire = widgetMap.onAutoWire;
		}
	},
	
	
	_jsonObj: function(paramStr) {
		return (paramStr)? dojo.fromJson(paramStr): {};
	},
	
	/**
	 * set the skin type, it should be "none" or "shadow" or "blue"
	 * @param {String} _widgetSkin
	 */
	setWidgetSkin:function(_widgetSkin){
		this.widgetSkin = _widgetSkin;
	},
	
	/**
	 * return the configPanelNodeName
	 */
	getConfigPanelNodeName:function(){
		return this.configPanelNodeName;
	},
	
	/**
	 * create the root span string, this is the start of the span
	 */
	createRootSpan:function(){
		var rootSpan = document.createElement("span");
		
		// other widget types for openSocial will be set here, by default we'll create the mm_iWidget
		if (this.widgetType){
			dojo.addClass(rootSpan, this.widgetType);
		}else{
			//dojo.addClass(rootSpan, com.ibm.mm.builder.constant.mmIWidget);
			dojo.addClass(rootSpan, com.ibm.mm.builder.constant.iwIWidget);
			dojo.addClass(rootSpan, com.ibm.mm.builder.constant.iWStandalone);
		}

		rootSpan.setAttribute(com.ibm.mm.builder.constant.widget_span_attr_id,""+this.uid);
		rootSpan.setAttribute(com.ibm.mm.builder.constant.widget_span_attr_skin,this.widgetSkin);	
		com.ibm.mm.builder.utils.iWidgetSpecUtil.setWidgetDefXML(rootSpan,this.widgetDefXML);		
		if (!this.istrusted){
			rootSpan.setAttribute("sandbox","true");
		}
		if (this.autowire == "true"){
			rootSpan.setAttribute("autowiringenabled","true");
		}	
		return rootSpan;
	},

	/**
	 * create the parameter string
	 */	
	createParamsElement: function(){
		var param = null;
		if (this.widgetParam && this.widgetParam.length) {
			param = com.ibm.mm.builder.utils.iWidgetSpecUtil.newItemSetSpan();
			dojo.forEach(this.widgetParam, function(item){
				com.ibm.mm.builder.utils.iWidgetSpecUtil.newItemSetKeyValue(param, item.itemName, item.itemValue);
			});
		}
		if (this.itemSet) {
			param = param || com.ibm.mm.builder.utils.iWidgetSpecUtil.newItemSetSpan();
			for (var key in this.itemSet) {
				if (Object.prototype.hasOwnProperty.call(this.itemSet, key)) {
					var ii = dojo.query("[href='#" + key + "']", param);
					if (ii && ii[0]) {
						ii[0].innerHTML = this.itemSet[key];
					}
					else {
						com.ibm.mm.builder.utils.iWidgetSpecUtil.newItemSetKeyValue(param, key, this.itemSet[key]);
					}
				}
			}
		}
		return param;
	},		

	/**
	 * call this method to get the microformat of a widget
	 */					
	getWidget:function(){
		var param = this.createParamsElement();
		var root = this.createRootSpan();
		if (param!==null){
			root.appendChild(param);
		}
		return root;
	}
	
});

}

if(!dojo._hasResource["com.ibm.mm.builder.widget.ExtendableShadowMenu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.ExtendableShadowMenu"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.widget.ExtendableShadowMenu");



/**
 * summary: Shadow menu with extension
 */
dojo.declare("com.ibm.mm.builder.widget.ExtendableShadowMenu", com.ibm.mm.builder.widget.ShadowMenu, {
	
	hasMorePage:false,
	
	currentPosition: 0,
	
	isLastItemShowed:false,
	
	loadedEntriesNumber:0,
	
	limitedSize:null,
	
	onOpen: function(){
		if (!this._arrowIsCreated) {
			this.upArrow = new com.ibm.mm.builder.widget.MenuItemArrow({type: "previous"});
			this.addChild(this.upArrow, 0);
			
			this.downArrow = new com.ibm.mm.builder.widget.MenuItemArrow({type: "next"});
			this.addChild(this.downArrow, this.loadedEntriesNumber + 1);	
			this._arrowIsCreated = true;
		}
		this.adjustMenu();
		this.inherited(arguments);
	},
	
	/*
	 * Show the arrows when then number is greater than page sizing
	 */
	adjustMenu: function(){
		var children = this.getChildren();
		for (var i = 0, len = children.length; i < len; i++) {
			var child = children[i];
			if (child.declaredClass == "com.ibm.mm.builder.widget.MenuItemArrow") {
				if (this.hasMorePage) {
					child.domNode.style.display = "";
					if (child.type === "previous") {
						child.setDisabled(this.currentPosition > 0 ? false : true);
						
					} else if (child.type === "next") {
						child.setDisabled(this.isLastItemShowed);
						
					} else {
						child.domNode.style.display = "none";
					}
				}
			}
			if (child.declaredClass == "dijit.PopupMenuItem" || child.constructor.superclass.declaredClass == "dijit.PopupMenuItem") {
				child.domNode.style.display = (i > this.currentPosition && i <= this.currentPosition + this.limitedSize) ? "" : "none";
			}
		}
	}
});

dojo.declare("com.ibm.mm.builder.widget.MenuItemArrow", [dijit.MenuItem], {
	
	type: null,
	
	templateString: 
		"<tr class='dijitReset dijitMenuItem MenuItemArrow' dojoAttachEvent='onmouseenter:_onHover,onmouseleave:_onUnhover' style='display:none;'>"+
	        "<td colspan='4'>"+
				"<div>"+
					"<img dojoAttachPoint='pageNextNode' dojoAttachEvent='onclick:_entryFlip,onkeypress:_onKeyPressEntryFlip'  class='NavigationMenuPageNext' alt='' tabindex=0 />"+
					"<span class='NavigationMenuPageDivider'></span>"+
					"<img  dojoAttachPoint='jumpNextPage' dojoAttachEvent='onclick:_pageFlip,onkeypress:_onKeyPressPageFlip'  class='NavigationMenuPageJump' alt='' tabindex=0 />"+
				"</div>"+
			"</td>"+
		"</tr>",
			
	postCreate: function(){
		this.imgPath = builderConfig.builderPath+ "/images/" + this.type;
        this.pageNextNode.src = this.imgPath + "_entry_disabled.png";
        this.jumpNextPage.src = this.imgPath + "_page_disabled.png";
	},
	
	_onKeyPressEntryFlip:function(e){
        if (e.keyCode === dojo.keys.ENTER){ this._entryFlip(e); }
	},
	
	_onKeyPressPageFlip: function(e) {
		if (e.keyCode === dojo.keys.ENTER) { this._pageFlip(e); }
	},
	
	setDisabled: function(/*Boolean*/ disabled){
        this.pageNextNode.src = this.imgPath + "_entry" + (disabled ? "_disabled" : "_enabled") + ".png";
        this.jumpNextPage.src = this.imgPath + "_page" + (disabled ? "_disabled" : "_enabled") + ".png";
		this.isDisabled = disabled;
	},
	
	_entryFlip: function(e){
		if (this.isDisabled) { return; }
		
		var parent = this.getParent();
		this._flipHelper(parent);
		parent.adjustMenu();
		if (parent.shadow) { parent.shadow.resize(); }
	},
	
	_flipHelper: function(parent){
		if (this.type === "previous") {
			if (parent.currentPosition > 0) {
				parent.currentPosition--;
				parent.isLastItemShowed = false;
			}
		}
		else if (this.type === "next") {
			var pages = parent.pages;
			if (!pages || parent.isLastItemShowed) { return; }
			
			if ((parent.currentPosition + parent.limitedSize) === parent.loadedEntriesNumber && pages.hasNext()) {
				var page = pages.next();
				var newItem = parent.createNewItem(page);
				dojo.forEach(parent.getChildren(), function(child){
					if (child.declaredClass === "com.ibm.mm.builder.widget.MenuItemArrow") {
						parent.addChild(newItem, parent.getIndexOfChild(child));
					}
				});
				parent.loadedEntriesNumber++;
				parent.currentPosition++;
				parent.isLastItemShowed = !pages.hasNext();
			}
			else {
				parent.currentPosition++;
				parent.isLastItemShowed = (parent.currentPosition + parent.limitedSize) === parent.loadedEntriesNumber;
			}
		}
	},
	
	_pageFlip: function(e){
		if (this.isDisabled) { return; }
		
		var parent = this.getParent();
		for (var i = 0; i < parent.limitedSize; i++) {
			this._flipHelper(parent);
		}
		parent.adjustMenu();
		if (parent.shadow) {
			parent.shadow.resize();
		}
	},
	
	focus: function(){
		// this throws on IE (at least) in some scenarios
		try{ dijit.focus(this.pageNextNode); }catch(e){}
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.dnd.IndicatorSource"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dnd.IndicatorSource"] = true;
dojo.provide("com.ibm.mm.builder.dnd.IndicatorSource");



/**
 * IndicatorSource is the auto sync source. It will create indicator during dragging.
 * 
 * @author jarod (zhangpy@cn.ibm.com)
 */
dojo.declare("com.ibm.mm.builder.dnd.IndicatorSource", dojo.dnd.AutoSource, {
		
	onMouseMove: function(e){
		this.inherited(arguments);
		if (this.isDragging) {
			if (this.removeIndicatorTimer) {
				clearTimeout(this.removeIndicatorTimer);
			}
			if (dojo.dnd.manager().canDropFlag && this.targetState != "Disabled") {
				this.createIndicator(e);
			}
		}
	},
	
	onDndDrop: function(source, nodes, copy, target){
		this.inherited(arguments);
		this.removeIndicator();
	},

	removeIndicator: function(){
		//callback for customized layout to remove inidcator
	},
	
	createIndicator: function(e){
		//callback for customized layout to create inidcator
	},
	
	onDndCancel: function(){
		this.inherited(arguments);
		this.removeIndicator();
	},
	
	onDraggingOut: function(){
		this.removeIndicatorTimer = setTimeout(dojo.hitch(this, function(){
			this.removeIndicator();
		}, 2));
	}
});

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.navigation.NavigationPanel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.navigation.NavigationPanel"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.iwidget.navigation.NavigationPanel");








(function(){
var maxLen = 150;
var utils = com.ibm.mm.builder.utils;
var htmlUtil = utils.htmlUtil;
var pageUtil = utils.pageUtil;
var navigationUtil = utils.navigationUtil;
var spaceUtil = utils.spaceUtil;
var themeUtil = utils.themeUtil;
var userUtil = utils.userUtil;
var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
/**
 * The default breadcrumb navigation
 * @version 2.0
 */
dojo.declare("com.ibm.mm.builder.iwidget.navigation.NavigationPanel", 
	[dijit._Widget, dijit._Templated, dijit._Container],{
	
	templateString: '<ul class="navigationPanel" dojoAttachPoint="containerNode"></ul>',
	
	npItemShowNum: 4, //the max number of last navigation items to show; Others will hide in separator ...
	
	/**
	 * the iEvent handler for navigation iEvent: "refreshNavigation" 
	 * it will refresh page if necessary.
	 */
	refresh: function(pid, needSwitch){
		this._cleanup();
		
		var currentPageIdBeforeRefresh = pageUtil.getCurrentPageId();
		var locationBeforeRefresh = unescape(location.href);
		//build models and render
		var models = this._getNavigationModelArray(pid);
		
		if (!models) { //this means there is no any page
			//if the theme is different from default, load defautl theme.
			if (themeUtil.getCurrentSpaceThemeId() != themeUtil.getCurrentThemeId()) {
				pageUtil.setPageId();
				setTimeout(function(){
					window.location.reload();
				}, 10);
				return;
			}
			//prompt user to create a new page.
			var m = navigationUtil.getNavigationModel();
			var rootNode = navigationUtil.getNavigationRootNode(spaceUtil.getCurrentSpaceId());
			if (m.confirmCreate() && m.confirmInsert(null, rootNode, null) && !userUtil.isLockedDownAnonymousMode()) {
				this.addChild(new com.ibm.mm.builder.iwidget.navigation.EmptyPagePanelItem());
			}
		} else {
			//reload theme if the page has new theme
			if (themeUtil.getThemeId() != themeUtil.getCurrentThemeId()) {
				var cpid = pageUtil.getCurrentPageId();
				pageUtil.setPageId(cpid);
				var redirectAddress = navigationUtil.getRedirectAddress();
				setTimeout(function(){
					//if only pid is changed, reload the page.
					//there are two conditions: 
					// 1) http://localhost:8080/mum/enabler#pid=1&
					// 2) http://localhost:8080/mum/enabler#    (this means no page before switch)
					if(redirectAddress === locationBeforeRefresh.replace(/pid=([^&]*)/, "pid=" + cpid) || 
						(locationBeforeRefresh.indexOf("pid=") < 0 && redirectAddress === locationBeforeRefresh.replace("#", "#pid="+cpid + "&"))){
						location.reload();
					}else{
						location.href = redirectAddress;
					}
				}, 10);
				return;
			}
			
			//if there is no page before refresh and new page is added, swith to new page
			if (!currentPageIdBeforeRefresh) {
				needSwitch = true;
			}
			
			// iterate all items in models and paint it
			var slashAdjust = 1;
			var _len = models.length;
			
			//if model's length reach the upper limit(here is npItemShowNum(4))
			//we will add NavPaneArrow widget(show as "...")
			if (_len > this.npItemShowNum) {
				this.addChild(new com.ibm.mm.builder.iwidget.navigation.NavPaneArrow());
				slashAdjust = 2;
			}
			//adjust the begin item number in model
			var _begin = 0;
			if (_len > this.npItemShowNum) {
				_begin = _len - this.npItemShowNum;
			}
			
			//render the navigation items and slash
			for (var i = _begin; i < _len; i++) {
				var naviModel = models[i];
				var navPaneItem = new com.ibm.mm.builder.iwidget.navigation.NavigationPanelItem({
					navigationNode: naviModel
				});
				this.addChild(navPaneItem);
				if (i < _len - 1) {//slash between two NavPaneItem
					this.addChild(new com.ibm.mm.builder.iwidget.navigation.NavigationPanelSeparator());
				}
			}
		}
		dojo.forEach(this.getChildren(), function(child){ child.startup(); });
		
		this._adjustWidthForBidiIE();
		
		pageUtil.updatePageTitle();
		
		setTimeout(function(){
			if(needSwitch){
				var pageId = pageUtil.getCurrentPageId();
				com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(false);
				pageUtil.setPageId(pageId);
				eventService.broadcastEvent("com.ibm.mashups.builder.pageSwitched", pageId);
			}
		}, 0);
	},
	
	_adjustWidthForBidiIE: function(){
		if ((builderConfig.isBidi && dojo.isIE)) {
			setTimeout(function(){
				var nav = dojo.query(".navigatorDiv")[0];
				if (nav){
					var piw = 0;
					dojo.query(".navigationPanelItem", nav).forEach(function(item){
						piw += dojo.coords(item, true).w;
					});
					dojo.query(".emptyPagePanelItem", nav).forEach(function(item){
						piw += dojo.coords(item, true).w;
					});
					var adjust = 5;//IE7 & IE6
					if (dojo.isIE === 8) { adjust = 30; }
					nav.style.width = piw + adjust + "px";					
				}
				if (builderConfig.isBidi && dojo.isIE === 8) {
					//use paddingRight to prevent Welcome Page and Space Selector overlap
					var navPan = dojo.query(".navigationPanel", nav)[0];
					if (navPan) { navPan.style.paddingRight = "30px"; }
				}
			}, 0);
		}
	},
	/**
	 * Init the Navigation's models array, so that the Navigation knows
	 * which item(s) it should render.
	 */
	render: function(pid) {
		this.refresh(pid, true);
	},
	
	_cleanup: function(){
		dojo.forEach(this.getChildren(), function(item){
			item.destroy();
		});
	},
	
	destroy: function(){
		this._cleanup();
		this.inherited(arguments);
	},
	/**
	 * Construct navigation model array according to parameter pid
	 * The array represents the data of navigation panel items.
	 * @param {String} pid: current page id. If it is not specified, get the current page id
	 * @return array of the models
	 */
	_getNavigationModelArray: function(pid) {
		//if parameter pid is null, used current page id;
		//if current page is null, try to find first page under root
		var currentPage = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage();
		pid = pid || currentPage.getID();
		if(!pid){
			var sid = spaceUtil.getCurrentSpaceId();
			pid = sid ? pageUtil.getFirstPageInSpace(sid) : pageUtil.getFirstRootPageId();
		}
		//if current page still is null, this means no page exists.
		if(!pid) { return null; }
		
		//update current page id and space id
		currentPage.setID(pid);
		var spaceId = spaceUtil.getSpaceIdByPageId(pid);
		if (spaceId !== spaceUtil.getCurrentSpaceId()) {
			spaceUtil.setSpaceId(spaceId);
		}
		//try to build model array
		var menuModelArrays = [];
		var navModel = navigationUtil.getNavigationModel();
		var currentModel = navModel.find(pid).start();
		var rootId = navigationUtil.getNavigationRootNodeId();
		var currentSpaceRootId = navigationUtil.getNavigationRootNodeId(spaceUtil.getCurrentSpaceId());
		//Loop to root to build the menuModelArrays array that holds all the models of the item that need to be rendered
		while(currentModel && currentModel.getID() !== rootId && currentModel.getID() !== currentSpaceRootId) {
			menuModelArrays.push(currentModel);
			currentModel = navModel.getParent(currentModel.getID()).start();
		}
		if(menuModelArrays.length === 0){ return null; } //means no any page under root
		return menuModelArrays.reverse();
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.navigation.NavigationPanelItem",
	[dijit._Widget, dijit._Templated, dijit._Contained],
{
	/**
	 * current page model
	 */
	navigationNode: null,
	
	/**
	 * current menu object stored for reuse
	 */
	pageMenu:null,
	
	templateString: 
		'<li dojoAttachEvent="onmouseover:_onHover,onmouseout:_onUnHover,onkeypress:_onKeyPress,onclick: _onClick">'+
			'<div dojoAttachPoint="containerNode" class="navigationPanelItem">'+
				'<div dojoAttachPoint="titleNode" tabindex="0" class="navigationPanelItemLabel truncatedLabel" widthLimit="150"></div>'+
			'</div> '+
		'</li>',

	postCreate: function(){
		var node = this.titleNode;
		var title = pageUtil.getPageTitle(this.navigationNode);
		setTimeout(function(){ //set timeout to make sure the class is applied on the node
			node.innerHTML = title;
			htmlUtil.truncateNodeText(node);
			if ((builderConfig.isBidi && dojo.isIE) || (dojo.isIE === 6)) {
				var w = htmlUtil.getStrWidth(node.innerHTML, node);
				node.style.width = w + "px";
			}
		},0);
	},
	
	_onKeyPress: function(evt){
		switch(evt.keyCode){
			case dojo.keys.UP_ARROW:
			case dojo.keys.DOWN_ARROW:
			case dojo.keys.ENTER:
				this.renderMenu(evt);
			break;
		}
	},
	
	onFocus:function(){
		dojo.addClass(this.containerNode, "navigationPanelItemHover");
		this.focus();
	},
	
	onBlur:function(){
		if(!this.pageMenu || (this.pageMenu && !this.pageMenu.isShowingNow)){
			dojo.removeClass(this.containerNode, "navigationPanelItemHover");
		}
	},
	
	focus: function(){
		try{
			dijit.focus(this.domNode);
		}catch(e){} // this throws on IE (at least) in some scenarios
	},
	
	_onHover: function(evt){
		dojo.addClass(this.containerNode, "navigationPanelItemHover");
		if(!this.pageMenu || (this.pageMenu && !this.pageMenu.isShowingNow)){ this.focus(); }
	},
	
	_onUnHover: function(evt){
		if(!this.pageMenu || (this.pageMenu && !this.pageMenu.isShowingNow)){
			dojo.removeClass(this.containerNode, "navigationPanelItemHover");
		}
	},
	
	renderMenu: function(evt){
		//the page id should be the parent id of the current item.
		this.pageMenu = this.pageMenu || new com.ibm.mm.builder.iwidget.navigation.NavigationMenu({
			targetNodeIds: [this.containerNode],
			siblingPageId: this.navigationNode.getID(),
			parentPanelItem: this
		});
		
		this.pageMenu._openMyself(evt);
	},
	
	_onClick: function(evt){
		this.renderMenu(evt);
	},
	
	uninitialize: function(){
		if (this.pageMenu) {
			if(this.pageMenu.isShowingNow){
				dijit.popup.close(this.pageMenu);
			}
			this.pageMenu.destroyRecursive();
			delete this.pageMenu;
			this.pageMenu = null;
		}
		this.inherited(arguments);
	}
});

/**
 * A slash line between two page items
 */
dojo.declare("com.ibm.mm.builder.iwidget.navigation.NavigationPanelSeparator",
	[dijit._Widget, dijit._Templated, dijit._Contained], {

	templateString: '<li><span class="navigationPanelSeparator">/</span></li>',

	postCreate: function(){
		dojo.setSelectable(this.domNode, false);
	},
	
	isFocusable: function(){
		// summary: over ride to always return false
		return false;
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.navigation.NavPaneArrow",
	[dijit._Widget, dijit._Templated, dijit._Contained], {
	
	templateString: '<li><div class="NavPaneArrow">...</div></li>'
	
});

dojo.declare("com.ibm.mm.builder.iwidget.navigation.EmptyPagePanelItem",
	[dijit._Widget, dijit._Templated, dijit._Contained], {

	templateString:
		'<li dojoAttachEvent="onclick:_showInput,onkeydown:_enterToShowInput" tabindex="0" class="emptyPagePanelItem">'+
			'<span dojoAttachPoint="pageTitleLabel" class="emptyPagePanleLabel truncatedLabel" widthLimit="200"></span>'+
			'<label dojoAttachPoint="realPageTitleLabel" for="${id}_input" style="display: none"></label>'+
			'<input id="${id}_input" dojoAttachPoint="pageTitleInput" dojoAttachEvent="onkeydown:_onKeyPress,onblur:_onBlur"/>'+
		'</li>',
	
	postCreate: function(){
		this._hideInput();
		htmlUtil.truncateNodeText(this.pageTitleLabel);
		dojo.attr(this.realPageTitleLabel,'innerHTML',com.ibm.mm.builder.coreWidgetsStrings.I_NAVIGATION_NEW_PAGE);
	},
	
	_enterToShowInput: function(evt){
		if(evt.keyCode === dojo.keys.ENTER){
			this._showInput();
		}
	},
	
	_showInput: function(evt){
		this.pageTitleLabel.style.display = "none";
		this.pageTitleInput.style.display = "";
		this.pageTitleInput.focus();
	},
	
	_hideInput: function(){
		this.pageTitleLabel.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_NAVIGATION_NEW_PAGE;
		this.pageTitleLabel.style.display = "";
		this.pageTitleInput.style.display = "none";
	},
	
	_onKeyPress: function(evt){
		switch(evt.keyCode){
			case dojo.keys.ENTER:
				var name = this.pageTitleInput.value;
				if (!pageUtil.validatePageName(name)) {	return;	}
				name = dojo.trim(name);
				pageUtil.createPage(name);
				dojo.stopEvent(evt);
				break;
			case dojo.keys.ESCAPE:
				this._hideInput();
				dijit.focus(this.domNode);
				dojo.stopEvent(evt);
				break;
		}
	},
	
	_onBlur: function(evt){
		if(!this.pageTitleInput.value){ this._hideInput(); }
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.navigation.NavigationMenu", com.ibm.mm.builder.widget.ExtendableShadowMenu ,{

	siblingPageId: null,
	
	parentPageId: null,
	
	parentPanelItem: null,
	
	offset_x: -1,
	
	popupDelay: 250,
	
	postCreate: function(){
		this.limitedSize = com.ibm.mm.builder.constant.NavigationPageSize;
		this.inherited(arguments);
		dojo.addClass(this.domNode, "navigationMenu");
		var navMenu = this;
		var pNodeId = this.parentPageId || pageUtil.getParentPageId(this.siblingPageId);
		
		if (this.dndDisable) { return; }
		
		if (userUtil.isLockedDownAnonymousMode()) { return; }
		this.dndSource = new com.ibm.mm.builder.dnd.IndicatorSource(this.domNode, {
			
			accept: ["navigationPage"],
			
			creator: function(item, hint){
				if(hint === "avatar"){
					var selectedNode = dojo.query("tr[dnddata='"+item+"']")[0];
					var tbody = selectedNode.parentNode.cloneNode(false);
					var n = selectedNode.parentNode.parentNode.cloneNode(false);
					tbody.appendChild(selectedNode.cloneNode(true));
					n.appendChild(tbody);
					return { node: n, data: item, type: ["navigationPage"] };
				}
				return {
					node: navMenu.createNewItem(pageUtil.getPageNode(item)).domNode,
					data: item,
					type: ["navigationPage"]
				};
			},
			
			onDndCancel: function(){
				com.ibm.mm.builder.dnd.IndicatorSource.prototype.onDndCancel.call(this);
				dojo.forEach(navMenu.getChildren(), function(c){
					if (c.declaredClass === "dijit.PopupMenuItem") { c.setDisabled(false); }
				});
				this.hoveredPageId = "";
			},
			
			onDndStart: function(source, nodes, copy){
				if (this === source) {
					var node = dijit.byId(nodes[0].id);
					if (node && node.popup) {
						node.popup._stopPopupTimer();
						if (node.popup.isShowingNow) {
							//bug 11434, not sure why safari will close all menu when close popup.
							//timer can solve such issue.
							window.setTimeout(function(){
								dijit.popup.close(node.popup);
							}, 500);
						}
						node.setDisabled(true);
					}
				}
				com.ibm.mm.builder.dnd.IndicatorSource.prototype.onDndStart.call(this, source, nodes, copy);
			},
			
			onDropExternal: function(source, nodes, copy){ //this means to parent or child
				if (!navMenu.isShowingNow || !this.hoveredPageId || !this.dropIndicator) { return; }
				dijit.popup.close(navMenu._getTopMenu());
				var draggedNodeId = nodes[0].getAttribute("dnddata");
				var hoveredPageId = this.hoveredPageId;
				var position = (this.hoveredNewPage) ? "children" : ((this.before) ? "previous" : "next");
				//put the heavy operation later after dnd cancel
				setTimeout(function(){
					navigationUtil.reorderPageNode(draggedNodeId, hoveredPageId, position);
				}, 0);
			},
			
			onDropInternal: function(nodes, copy){ //this means reorder
				if (!navMenu.isShowingNow || !this.dropIndicator) { return; }
				dijit.popup.close(navMenu._getTopMenu());
				com.ibm.mm.builder.dnd.IndicatorSource.prototype.onDropInternal.call(this, nodes, copy);
				var draggedNodeId = nodes[0].getAttribute("dnddata");
				var hoveredPageId = this.hoveredPageId;
				var position = (this.before) ? "previous" : "next";
				//put the heavy operation later after dnd cancel
				setTimeout(function(){
					navigationUtil.reorderPageNode(draggedNodeId, hoveredPageId, position);
				}, 0);
			},
			
			/* fix the bug 11434
			 * The menu focus behavior is incorrect in some specified dnd operation such as
			 * dragging too fast so that the mouse hovers the avatar etc. 
			 */
			onDndSourceOver: function(source){
				com.ibm.mm.builder.dnd.IndicatorSource.prototype.onDndSourceOver.call(this, source);
				if (!navMenu.isActive) { navMenu._onFocus(); }
			},
			
			removeIndicator: function(){
				if (this.dropIndicator) {
					navMenu.removeChild(this.dropIndicator);
					this.dropIndicator = null;
				}
				if (navMenu.shadow && navMenu.isShowingNow) { navMenu.shadow.resize(); }
			},
			//todo simply this method
			createIndicator: function(e){
				com.ibm.mm.builder.dnd.IndicatorSource.prototype.createIndicator.call(this, e);
				var hoveredNode = e.target.parentNode;
				if(!hoveredNode){ this.removeIndicator(); return; }
				var menuChildren = navMenu.getChildren();
				if(menuChildren.length === 3 && menuChildren[2].declaredClass == "com.ibm.mm.builder.iwidget.navigation.NewPageMenuItem"){
					this.hoveredPageId = navMenu.parentPageId;
					this.hoveredNewPage = true;
					if (!this.dropIndicator) { this.insertIndicator(1); }
					return;
				}else if(menuChildren.length === 4 && menuChildren[1] === this.dropIndicator && 
					menuChildren[3].declaredClass == "com.ibm.mm.builder.iwidget.navigation.NewPageMenuItem"){
					return;
				} else {
					this.hoveredPageId = hoveredNode.getAttribute("dnddata");
					if(!this.hoveredPageId){ this.removeIndicator(); return; }
				}
				this.hoveredNewPage = false;
				
				//should not insert the same position
				var draggedPageId = this.getSelectedNodes() && this.getSelectedNodes()[0] && this.getSelectedNodes()[0].getAttribute("dnddata");
				if(this.hoveredPageId === draggedPageId){ this.removeIndicator(); return; }
				
				//if previous/next page is the dragged page, should void to create indicator
				if((this.before && hoveredNode.previousSibling && hoveredNode.previousSibling.getAttribute("dnddata") === draggedPageId) ||
					(!this.before && hoveredNode.nextSibling && hoveredNode.nextSibling.getAttribute("dnddata") === draggedPageId)) {
					this.removeIndicator(); return;
				}
				//if the dragged page can't insert into current menu, the indicator will not be created.
				var navigationModel = navigationUtil.getNavigationModel();
				var page = pageUtil.getPageNode(draggedPageId);
				var parentPage = pageUtil.getPageNode(navMenu._getParentPageId());
				try {
					if (!navigationModel.confirmInsert(page, parentPage)) { return; }
				} catch (err) {
					console.log(draggedPageId, navMenu._getParentPageId());
					console.error(err);
				}
				
				var insertIndex =  navMenu.getIndexOfChild(dijit.byId(hoveredNode.id)) + ((this.before) ? 0 : 1);
				this.insertIndicator(insertIndex);
			},
			
			insertIndicator: function(insertIndex){
				this.dropIndicator = this.dropIndicator || new com.ibm.mm.builder.iwidget.navigation.NavigationMenuDNDIndicator();
				navMenu.addChild(this.dropIndicator, insertIndex);
				if(navMenu.shadow){ navMenu.shadow.resize(); }
			}
		});
		//the new source created during dragging need to init the state.
		if(dojo.dnd.manager().source && dojo.dnd.manager().source.isDragging){
			this.dndSource.isDragging = true;
		}
	},
	
	//change the dijit.Menu's default behaviour(onClick) to onItemHover when the popup menu should be shown by key
	_onKeyPress: function(evt){
		if(evt.ctrlKey || evt.altKey){ return; }

		switch(evt.keyCode){
			case dojo.keys.RIGHT_ARROW:
				this.onItemHover(this.focusedChild);
				break;
			case dojo.keys.LEFT_ARROW:
				if(this.parentMenu){
					this.onCancel(false);
				}else{
					dojo.stopEvent(evt);
				}
				break;
		}
	},
	
	_onPageItemClick: function(pageId){
		dijit.popup.close(this._getTopMenu());
		
		setTimeout(function(){
			if (com.ibm.mm.builder.TabbedNavigationDelegate){
				// clear the global page in tabbed navigation
				com.ibm.mm.builder.TabbedNavigationDelegate.onClearGlobalPage();
			}else{
				// clear the global page in other navigations
				dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid, null, {expires: -1});
			}
			eventService.broadcastEvent("com.ibm.mashups.builder.switchPage", pageId);
		}, 0);
	},
	
	prepareData: function(){
		var pages;
        if (this.siblingPageId) {
		    pages = pageUtil.getSiblingPages(this.siblingPageId);
		} else if (this.parentPageId) {
		    pages = pageUtil.getChildPages(this.parentPageId);
        }
        if (!this.confirmInsert) {
            var pNodeId = this.parentPageId || pageUtil.getParentPageId(this.siblingPageId);
            this.confirmInsert = navigationUtil.getNavigationModel().confirmInsert(null, pageUtil.getPageNode(pNodeId), null);
        }
		var canCreatePage = navigationUtil.getNavigationModel().confirmCreate() && this.confirmInsert && !userUtil.isLockedDownAnonymousMode();
		
		if (pages) {
			var self = this;
			while (pages.hasNext()) {
				if (self.loadedEntriesNumber >= com.ibm.mm.builder.constant.NavigationPageSize) {
					self.hasMorePage = true;
					self.isLastItemShowed = false;
					break;
				}
				var node = pages.next();
				if (com.ibm.mm.builder.utils.pageUtil.isVisiable(node)) {
					this.addChild(this.createNewItem(node));
					this.loadedEntriesNumber++;
				}
			}
			
			if (this.loadedEntriesNumber > 0 && canCreatePage) {
				this.addChild(new com.ibm.mm.builder.iwidget.navigation.NavigationMenuSeparator());
			}
		}
		if(canCreatePage){
			this.addChild(new com.ibm.mm.builder.iwidget.navigation.NewPageMenuItem({
				parentPageId: this._getParentPageId()
			}));
		}
		
		this.pages = pages;
		htmlUtil.truncateAllChildNodesText(this.domNode,null,{fontSize:"1.2em"});
		
		//make sure the current panel item is highlighted when the page is openning.
		if(this.parentPanelItem && this.parentPanelItem.containerNode){
			dojo.addClass(this.parentPanelItem.containerNode, "navigationPanelItemHover");
		}
	},
	
	_getParentPageId: function(){
		return this.parentPageId || pageUtil.getParentPageId(this.siblingPageId);
	},
	
	createNewItem: function(page){
		var pageId = page.getID();
		var newChild = new dijit.PopupMenuItem({
			label: pageUtil.getPageTitle(pageId),
			popup: new com.ibm.mm.builder.iwidget.navigation.NavigationMenu({ parentPageId: pageId }),
			postCreate:function(){
				dijit.PopupMenuItem.prototype.postCreate.call(this);
				htmlUtil.markTruncation(this.containerNode,"153");
			},
			_onClick: dojo.hitch(this, "_onPageItemClick", pageId)
		});
		
		newChild.domNode.setAttribute("dndtype", "navigationPage");
		newChild.domNode.setAttribute("dnddata", pageId);
		dojo.query(".dijitMenuArrowCell",newChild.domNode)[0].style.display = "none";
		
		dojo.addClass(newChild.domNode, "dojoDndItem");
		return newChild;
	},
	
	onClose: function(){
		this.inherited(arguments);
		if(this.parentPanelItem && this.parentPanelItem.containerNode){
			dojo.removeClass(this.parentPanelItem.containerNode, "navigationPanelItemHover");
		}
	},
	
	uninitialize: function(){
		if (this.dndSource) {
			this.dndSource.destroy();
		}
		this.parentPanelItem = null;
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.navigation.NewPageMenuItem", dijit.MenuItem, {
	
	//newPageMenuItemTd is add for automation test.
	templateString:
		'<tr class="dijitReset dijitMenuItem newPageMenuItem" dojoAttachPoint="focusNode" waiRole="menuitem" tabIndex="-1"' +
			'dojoAttachEvent="onmouseenter:_onHover,onmouseleave:_onUnhover,onclick:_onClick,onkeypress:_onKeyPressMenuItem">' +
			'<td class="dijitReset newPageMenuItemTd" dojoAttachPoint="containerNode" colspan="4">' +
				'<label dojoAttachPoint="realPageTitleLabel" for="${id}_input" style="display: none"></label>'+
				'<input type="text" dojoAttachPoint="input" id="${id}_input" style="display:none"' +
					'dojoAttachEvent="onkeypress:_onKeyPress,onfocus:_onfocus, onblur:_onblur" ></input>' +
				'<div dojoAttachPoint="textNode" class="dijitMenuItemLabel truncatedLabel" widthLimit="153"></div>' +
			'</td>'+
		'</tr>',

	parentPageId: null,
	
	postCreate: function(){
		this.inherited(arguments);
		//make sure that user can click mouse to move the caret
		dojo.setSelectable(this.domNode, true);
		
		var label = com.ibm.mm.builder.coreWidgetsStrings.I_NAVIGATION_NEW_PAGE;
		this.input.title = label;
		this.textNode.innerHTML = label;
		this.textNode.title = label;
		dojo.attr(this.realPageTitleLabel,'innerHTML',label);
	},
	
	//reactive the default key event by clearing the parent's function used to prevent the default key event. 
	//todo, if there is mem leak, try to use dojo.connect to fix
	_onfocus: function(){
		this.parentPreviousKeyPress = this.getParent()._onKeyPress;
		this.getParent()._onKeyPress = function(evt){};
	},
	
	_onblur: function(){
		this.getParent()._onKeyPress = this.parentPreviousKeyPress;
	},
	
	_onKeyPressMenuItem:function(e){
		if (e.keyCode === dojo.keys.ENTER) { this._onClick(e); }
	},
	_onClick: function(evt){
		this.textNode.style.display = "none";
		this.input.style.display = "";
		this.input.focus();
		this._resizeShadow();
	},
	
	_onKeyPress: function(evt){
        switch (evt.keyCode) {
            case dojo.keys.ENTER:
				var newPageName = this.input.value;
				if (!pageUtil.validatePageName(newPageName)) {
		            return;
		        }
				newPageName = dojo.trim(newPageName);
		
				dijit.popup.close(this.getParent()._getTopMenu());
				dojo.stopEvent(evt);
				
            	this._createNewPage(newPageName);
                break;
				
            case dojo.keys.ESCAPE:
				this._restore();
                dojo.stopEvent(evt);
                break;
        }
	},
	
	_restore: function(){
		this.input.style.display = "none";
		this.input.value = "";
		this.textNode.style.display = "";
		this._resizeShadow();
	},
	
	_createNewPage: function(newPageName){
		var cancelcb = dojo.hitch(this, function(){
			this._restore();
		});
		
		var cb = dojo.hitch(this, function(){
			pageUtil.createPage(newPageName,this.parentPageId, cancelcb);
		});
		
		com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(cb, cancelcb);
	},
	
	//have to do this..
	_resizeShadow: function(){
		var shadow = this.getParent().shadow;
		if (shadow) { shadow.resize(); }
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.navigation.NavigationMenuSeparator", dijit.MenuSeparator, {
	
	templateString: '<tr class="dijitMenuSeparator"><td colspan=4><div class="dijitNewMenuSeparator"></div></td></tr>'
	
});

dojo.declare("com.ibm.mm.builder.iwidget.navigation.NavigationMenuDNDIndicator", dijit.MenuSeparator, {
	
	templateString: '<tr class="NavigationMenuDNDIndicator"><td colspan=4><div class="NavigationMenuDNDIndicatorInstance"></div></td></tr>'
	
});

})();

}

if(!dojo._hasResource["com.ibm.mm.builder.iwidget.SmallWidgetContextMenu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.SmallWidgetContextMenu"] = true;
/**
 * @author Allen Liang(llcsdl@cn.ibm.com)
 */

dojo.provide("com.ibm.mm.builder.iwidget.SmallWidgetContextMenu");


dojo.declare("com.ibm.mm.builder.iwidget.SmallWidgetContextMenu", com.ibm.mm.builder.widget.ShadowMenu, {

    offset_y: 3,
    category: null,
    leftClickToOpen: true,
    entryModel: null,
    entryId: "",
	myparent: null,
	widget: null,
	LOGGER: com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.iwidget.SmallWidgetContextMenu"),
    cwm: com.ibm.mm.builder.coreWidgetsMessages,
	
    postCreate: function(){
        this.inherited(arguments);
        //get entryModel 
		if (!this._isFromHub()) {
			var utils = com.ibm.mm.builder.utils;
			var toolboxUtil = utils.toolboxUtil;
			var _catModel = toolboxUtil.getCatalogModel();
			var cs = toolboxUtil.getCategories();
			var find = false;
			
			for (var i = 0; i < cs.length && i < 5 && !find; i++) {
				_categoryModel = _catModel.getCatalogEntryModel(cs[i]);
				var elemIterator = _categoryModel.iterator();
				elemIterator.setCursorPosition(0);
				while (elemIterator.hasNext()) {
					var entry = elemIterator.next();
					if (!entry) continue;
					if (entry.getID() == this.entryId) {
						find = true; // find the entryModel 
						this.entryModel = entry;
						break;
					}
				}
			}
		}
		if (null == this.entryModel) {
			return;
		}

		this.utils = com.ibm.mm.builder.utils;
        this.iwidgetUtil = this.utils.iwidgetUtil;
		
		if (!this._isFromHub()) {
			this.isTrusted = this.iwidgetUtil.isWidgetTrusted(this.entryModel.getID());
		} else {
			this.isTrusted = this.widget.map.sandbox_user == "true" ? false : true;
		};
		
        this.enablerUtil = this.utils.enablerUtil;
        this.htmlUtil = this.utils.htmlUtil;
        this.toolboxUtil = this.utils.toolboxUtil;
        this.eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
    },
    canShowSandboxSeparator: function(){
		return this._isSandBoxEnabled()
    },
	
	_isFromHub : function() {
		return dojo.trim(ibmConfig["com.ibm.mashups.builder.contentShelf.mode"])== "hub";	
	},
	
	_isSandBoxEnabled : function() {
		var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
		var sandboxEnabled = cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.SANDBOXENABLED);
        return sandboxEnabled;	
	},
    
    canToggleSandbox: function(){	
		if (this._isOpenSocial()) return false;
			
		if (!this._isSandBoxEnabled()) return false;
		
		if (this._isFeed()) return false;
	
		
		if (this._isFromHub()) {				
			return this.widget.map.permission == "edit";	
		} else {
			var tu = com.ibm.mm.builder.utils.toolboxUtil;
			var wd = tu.getWidgetDefinition(this.entryId);	
	        return !this.iwidgetUtil.isDisabledSandboxWidget(this.entryId) && !this.iwidgetUtil.isSandboxWidget(this.entryId) && wd.confirmSetMetaData('sandbox_user', true);
		}		
    },
    
    canShowMarkAsTrustedSandBoxMenuItem: function(){
		
		if (this._isOpenSocial()) return false;
		
		if (!this._isSandBoxEnabled()) return false;
		
		if (this._isFeed()) return false; 
		
		if (this._isFromHub()){
			if (this.widget.map.sandbox_definition == "true") 
				return false;	
		} else {
			if (com.ibm.mm.builder.utils.iwidgetUtil.isSandboxWidget(this.entryId)) 
				return false;
		};
		
		if (this._isWidgetInSandboxDisableGroup(this.widget.map.definitionURL))
			return false;	
		
		if (this._isFromHub()) {
			var trusted = this.widget.map.sandbox_user == "true" ? false : true; 
			return !trusted;			
		} else {
			return !this.iwidgetUtil.isWidgetTrusted(this.entryModel.getID());	
		}
		
    },
    
    canShowMarkAsUntrustedSandBoxMenuItem: function(){	
		if (this._isOpenSocial()) return false;
			
		if (!this._isSandBoxEnabled()) return false;
		
		if (this._isFeed()) return false; 
		
		if (this._isFromHub()){
			if (this.widget.map.sandbox_definition == "true") 
				return false;	
		} else {
			if (com.ibm.mm.builder.utils.iwidgetUtil.isSandboxWidget(this.entryId)) 
				return false;
		};
		
		if (this._isWidgetInSandboxDisableGroup(this.widget.map.definitionURL))
			return false;		
		
		if (this._isFromHub()) {
			var trusted = this.widget.map.sandbox_user == "true" ? false : true; 
			return trusted;					
		} else {
			return this.iwidgetUtil.isWidgetTrusted(this.entryModel.getID());	
		}		
    },
	
	_isWidgetInSandboxDisableGroup: function(thisWidgetUrl) {
		var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
		var disableWidgets= cs.getValue("com.ibm.mashups.sandbox.force.disable");	
		if (dojo.isArray(disableWidgets)) {
			for (var x in disableWidgets) {
				var widgetUrl = dojo.trim(disableWidgets[x]);
				if (thisWidgetUrl == widgetUrl) 
					return true;
			}	
		} else {
			return (thisWidgetUrl == disableWidgets);
		}
		return false;
	},
	
	_isFeed : function () {
		return this.widget.isFeed;
	},
	
	_isOpenSocial : function () {
		return this.widget.isOpenSocial;
	},
	
	canShowEmbedWidget: function() {
		return !this._isFeed(); 
		//return !(this._isFeed() || this._isOpenSocial());	
	},
	
	canEnableEmbedWidget: function() {
		return !(this._isFeed() || this._isOpenSocial());	
	},
    
    canRemove: function(){
		if (this._isFromHub()) {
			return this.widget.map.permission == "edit";
		} else {
			return this.toolboxUtil.getCatalogModel().confirmRemove(this.entryModel);
		}
    },
    
    needRemove: function(){
		if (this._isFromHub()) {
			return false;
		} else {
			return true;
		}
    },
    
    addWidget: function(){
		//this.eventService.broadcastEvent("com.ibm.mashups.builder.addWidget", this.entryId);
    },
	
	updateWidgetItemUI: function () {		
	},
    
    embedWidget: function(){

		
		if (this._isFromHub()) {
			com.ibm.mm.builder.utils.embedUtil.displayEmbedDialogForHubWidget(this.widget.map);
		} else  {
			var widgetType = this.enablerUtil.getNodeTitle(this.entryModel);
        	com.ibm.mm.builder.utils.embedUtil.displayEmbedDialog(this.entryId, "widget", widgetType);	
		}
		
    },
	
	_getCategories: function(){
			if (this.catalogEntries) { return this.catalogEntries; }
			this.catalogEntries = [];
			var cm = com.ibm.mashups.enabler.model.Factory.getCatalogCategoryModel(),
				rootNode = cm.getRoot().start(),
				iter = cm.getChildren(rootNode);
			while (iter.hasNext()) {
				this.catalogEntries.push(iter.next());
			}
			return this.catalogEntries;
	},
    
    removeWidgetDefinition: function(){
		if (this._isFromHub()) {

			var hubURL = this._getHubURL();
			dojo.xhrDelete({	         
	            url: hubURL,
				error: dojo.hitch(this, function(error, ioArgs){
		                console.log(error);
		        })          
	        });
			this.widget.destroyRecursive();
		
		} else {
			var _catModel = this.toolboxUtil.getCatalogModel();
			
			var myElement = null;
			var cwm = com.ibm.mm.builder.coreWidgetsMessages;
			var categories = this._getCategories();
			for (var i = 0; i < categories.length; i++) {
				var category = categories[i];
				var _entryModel = _catModel.getCatalogEntryModel(category);
				var myElement = _entryModel.find(this.entryId).start();
				if (myElement) {
					
					var menuTitle = this.enablerUtil.getNodeTitle(myElement)
					var warnInfo = this.htmlUtil.getSubstitute(cwm.I_TOOLBOX_DELETE_WARN_1, [menuTitle]);
					if (confirm(warnInfo)) {
						_entryModel.remove(this.entryId);
						_catModel.commit().start();
						this.toolboxUtil.getCatalogModel(true);
						this.widget.destroyRecursive();
					};
					break;
				}		
			}

		}
		
    },
    
    toggleMark: function(){
		
		if (this._isFromHub()) {
			var needMarkSandbox = this.widget.map.sandbox_user == "true" ? false : true; 
			this._changeWidgetTrustSetting(needMarkSandbox);
		}else{
			var needMarkSandbox = this.iwidgetUtil.toggleMarkedSandboxWidget(this.entryId);	
			this.widget.map.isTrusted = !needMarkSandbox;
			this.updateWidgetItemUI();
		}		
		
		this.destroyDescendants();
		this.opened = false;        
    },
	
	
	_getHubWidgetID: function () {
		var hubURL = this.widget.item.store.url;
 		var id = this.widget.map.id;
    	id = id.replace("urn:id:", "");	
		return id;			
	},
	
	_getHubURL: function () {
		var id = this._getHubWidgetID();
		var hubURL = this.widget.item.store.url;
		hubURL += "&id=" + id;
		return hubURL;
	},
	
//	_getHubPutURLForFeed: function () {
//		var id = this._getHubWidgetID();
//		var hubURL = this.widget.item.store.url;
//		hubURL = com.ibm.mm.catalog.hubUtil.getDefaultHubUrl() + hubURL.replace("/mashuphub","") + ".feed&id=" + id;
//		//hubURL = com.ibm.mm.catalog.hubUtil.getDefaultHubUrl() + "/atom?collection=widgets.iWidgetURL&id=" + id;
//		
//		return hubURL;
//	},
	
	_generateAtom: function (feed, needMarkSandbox) {		
		
		//change user permission to public.
		feed = feed.replace("<catalog:permission>edit</catalog:permission>", "<catalog:permission>public</catalog:permission>")
        
		if (!needMarkSandbox) {
			feed = feed.replace("<catalog:metadata name=\"sandbox_user\" label=\"sandbox_user\" value=\"true\"></catalog:metadata>", 
				"<catalog:metadata name=\"sandbox_user\" label=\"sandbox_user\" value=\"false\"></catalog:metadata>");
			return feed;
		}
		
		var sandbox_markup 
			= "  <catalog:metadata name=\"sandbox_user\" label=\"sandbox_user\" value=\"true\"></catalog:metadata>";
			  
		var meta_sandbox_markup 
			= "<catalog:objectmeta>\n" +
			   sandbox_markup + "\n" +
 			  "</catalog:objectmeta>";	
		
		//check if the feed passed is for feed or widget	  
		//isFeed = feed.indexOf("<catalog:feed") >= 0;
		isFeed = this._isFeed();
			 
		//add sandbox mark	  
		feed = feed.replace("<catalog:objectmeta/>", "");
		feed = feed.replace("<catalog:metadata name=\"sandbox_user\" label=\"sandbox_user\" value=\"true\"></catalog:metadata>", "");
		feed = feed.replace("<catalog:metadata name=\"sandbox_user\" label=\"sandbox_user\" value=\"false\"></catalog:metadata>", "");

		var s1 = "";
		var inx = feed.indexOf("</catalog:objectmeta>");

		if (inx >= 0) {			
			s1 = feed.substring(0, inx);
			s1 += sandbox_markup;		
			s1 += feed.substring(inx)		
		} else {
			if (isFeed) {
				inx = feed.indexOf("</catalog:feed>");
			} else {
				inx = feed.indexOf("</catalog:widget>");
			}
			s1 = feed.substring(0, inx);
			s1 += meta_sandbox_markup;
			s1 += feed.substring(inx);				
		}
		
		return s1;
	},
	
	
	_changeWidgetTrustSetting: function (needMarkSandbox) {
		var hubURL = this._getHubURL();
		
		dojo.xhrGet({
			url: hubURL,
			load: dojo.hitch(this, function (feed, ioArgs) {
				dojo.xhrPut({
		            headers: { "Content-Type": "application/xml" },
		            url: hubURL,
		            load: dojo.hitch(this, function(data, ioArgs){
						if (needMarkSandbox) {
							this.widget.map.sandbox_user = "true";
							this.widget.map.isTrusted = false;
						}
						else {
							this.widget.map.sandbox_user = "false";
							this.widget.map.isTrusted = true;
						}
						this.updateWidgetItemUI();
						// The trust setting that you just marked applies to all subsequent users of this widget
						this.LOGGER.info("_changeWidgetTrustSetting",this.cwm.I_CONTENTSHELF_WIDGET_SANDBOX_0);
		            }),
		            error: dojo.hitch(this, function(error, ioArgs){
		                console.log(error);
		            }),
		            postData: this._generateAtom(feed, needMarkSandbox),
		            handleAs: "text"
		        });  
						
			}),
			error: dojo.hitch(this, function(error, ioArgs){
                console.log(error);
            })
		});		
		
	},
	
	
    prepareData: function(){        
	    try {
			
			var mycontextmenu = com.ibm.mashups.builder.model.Factory.getContextMenuModel();
			var widgetMenus = mycontextmenu.getContextMenu("ContextMenu.toolboxAction", this.entryId, null, {
	            context: this
	        });
	
	        for (var i = 0; i < widgetMenus.length; ++i) {
	            if (widgetMenus[i].isSeparator) {
	                this.addChild(new com.ibm.mm.builder.iwidget.navigation.NavigationMenuSeparator())
	                continue;
	            }
	            
				
				
	            this.addChild(new dijit.MenuItem({
	                label: widgetMenus[i].title,
	                iconClass: widgetMenus[i].iconClass,
	                disabled: !widgetMenus[i].enabled,
	                onClick: widgetMenus[i].actionCallBackFunction
	            }));
	        }
		} catch (e) {
			console.log(e)
		}
    },
	
	_clearMenu: function() {
		
		dojo.forEach(this.containerNode.childNodes,function(item){
			dojo.removeClass(item,"dijitMenuItemHover");
			dojo.removeClass(item,"dijitMenuItemSelected");
		});
		
		dojo.forEach(this.getChildren(), function(item){	
			this.removeChild(item);
			dijit.byId(item.id).destroy();
			item.destroyRecursive();		
			delete item;			
		},this);
		
		this._isMenuCreated = false;			
	},
	
	onClose: function () {

		this.inherited(arguments);		
		this._clearMenu();
	
		
		
	}
    
});

}

